"use strict";
/*!
// <copyright file="Util.js" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
*/
var util={label:function(n){var t=Globalize.localize(n);return t!==undefined?t:n},format:function(n){if(n){var t=arguments;return n.replace(/{(\d+)}/g,function(n,i){var u=Number(i),r;if(isNaN(u)||t[u+1]===undefined)return"";if(r=t[u+1],typeof r=="object"){if(r&&r.hasOwnProperty("toString"))return r.toString();try{return JSON.stringify(r)}catch(f){return r}}else return r})}return n},formatRangeAddress:function(n,t){return $format("{0}!{1}",n,t)},_window:window,getOrigin:function(n){var t,i;return n===undefined&&(n=this._window),n.location.origin!==undefined?t=n.location.origin:(i=n.location.href.indexOf(n.location.pathname),t=n.location.href.substr(0,i)),t},_resourceQueryStringLanguageExpression:/[\?|&]Language=([^&]+)/,getResourceLanguage:function(){var n=this._resourceQueryStringLanguageExpression.exec(this._window.location.search);if(n&&n.length===2)return n[1]},addStyleSheet:function(n,t){var i=$("<link/>",{type:"text/css",rel:"stylesheet"}).appendTo("head");i.unbind("load");i.bind("load",null,function(){t()});i.attr("href",n)},ApplicationType:{Excel:1,Word:2},OfficeVersion:{Legacy:2013,Release:2016},MessageType:{Event:0,Telemetry:1},TelemetryType:{Exception:0,Error:1,Warning:2,Informational:3},edm:{binary:"Edm.Binary",decimal:"Edm.Decimal",double:"Edm.Double",int16:"Edm.Int16",int32:"Edm.Int32",int64:"Edm.Int64",single:"Edm.Single",string:"Edm.String",dateTime:"Edm.DateTimeOffset",guid:"Edm.Guid"},odataJsonAnnotations:{eTag:"@odata.etag"},findElementByClass:function(n,t){var i=$format(".{0}",n);return util._findElement(i,t)},findElementById:function(n,t){var i=n.replace(/(:|\.|\[|\]|,)/g,"\\$1"),r=$format("#{0}",i);return util._findElement(r,t)},_findElement:function(n,t){return $(n,t)},changeAttribute:function(n,t,i){i===undefined?n.removeAttr(t):n.attr(t,i)},enableControl:function(n,t){var i;t||(i="disabled");util.changeAttribute(n,"disabled",i)},controlEnabled:function(n){return n.attr("disabled")!=="disabled"},navigateFrame:function(n,t){util.changeAttribute(n,"src",t)},doesElementExist:function(n){return n.length>0},Map:function(){this._map={}},StringSet:function(){this._set={}},dateTime:function(){return{secondsPerDay:86400,excelDateToDate:function(n){var i=0,r=0,u=0,t,e,o,f;return n==60?(i=29,r=2,u=1900,util.dateTime.getDateString(u,r,i)):(n<60&&n++,t=n+68569+2415019,e=Math.floor(4*t/146097),t=t-Math.floor((146097*e+3)/4),o=Math.floor(4e3*(t+1)/1461001),t=t-Math.floor(1461*o/4)+31,f=Math.floor(80*t/2447),i=t-Math.floor(2447*f/80),t=Math.floor(f/11),r=f+2-12*t,u=100*(e-49)+o+t,util.dateTime.getDateString(u,r,i))},excelDateToJSDate:function(n){var i=0,r=0,u=0,t,e,o,f;return n==60?(i=29,r=2,u=1900,util.dateTime.getDateString(u,r,i)):(n<60&&n++,t=n+68569+2415019,e=Math.floor(4*t/146097),t=t-Math.floor((146097*e+3)/4),o=Math.floor(4e3*(t+1)/1461001),t=t-Math.floor(1461*o/4)+31,f=Math.floor(80*t/2447),i=t-Math.floor(2447*f/80),t=Math.floor(f/11),r=f+2-12*t-1,u=100*(e-49)+o+t,new Date(u,r,i))},dateToExcelDate:function(n,t,i){var r=(new Date(n,t,i).getTime()-new Date(1899,11,31).getTime())/864e5;return r>=60&&r++,Math.round(r)},excelTimeToAxTime:function(n){var t=n-Math.floor(n);return Math.round(t*util.dateTime.secondsPerDay)},timeInSecondsToFormat:function(n){var i=Math.floor(n/3600),t;return n=n%3600,t=Math.floor(n/60),n=n%60,util.dateTime.getTimeString(i,t,n)},getTimeString:function(n,t,i){return i<10&&(i="0"+Number(i)),t<10&&(t="0"+Number(t)),n<10&&(n="0"+n),""+n+":"+t+":"+i},getLocalizedTimeString:function(n,t,i){return Globalize.format(new Date(0,0,0,n,t,i),"T")},getLocalizedDateString:function(n,t,i){return Globalize.format(new Date(n,t,i),"d")},getDateString:function(n,t,i){return t<10&&(t="0"+Number(t)),i<10&&(i="0"+Number(i)),""+n+"-"+t+"-"+i},blankDate:"1900-01-01T12:00:00Z",blankDateTime:"1900-01-01T00:00:00Z"}}(),Guid:function(n){this.GuidValue=n},EnumValue:function(n,t){this.EnumName=n;this.EnumMember=t},unwrapUtilClasses:function(n){var t=n;return t instanceof util.Guid?t=t.GuidValue:t instanceof util.EnumValue&&(t=t.EnumMember),t},convertODataArgumentValue:function(n,t){var i=n;switch(t){case util.edm.string:i=typeof n!="string"?undefined:n;break;case util.edm.decimal:case util.edm.double:case util.edm.single:case util.edm.int16:case util.edm.int32:case util.edm.int64:i=Number(n);isNaN(i)&&(i=undefined);break;case util.edm.dateTime:n instanceof Date?i=n:(i=new Date(n),isNaN(i.valueOf())&&(i=undefined));break;case util.edm.guid:typeof n=="string"?i=new util.Guid(n):n.GuidValue!==undefined&&(i=n);break;default:t&&typeof n=="string"&&t.indexOf("Microsoft.Dynamics.DataEntities.")===0&&(i=new util.EnumValue(t,n))}return i},formatODataArgumentValue:function(n){return n!==undefined&&(n instanceof Date?n=n.toISOString():n.GuidValue!==undefined?n=n.GuidValue:n.EnumMember!==undefined?n=$format("{0}'{1}'",n.EnumName,n.EnumMember):(typeof n=="string"||n instanceof String)&&(n=n.replace(/\'/g,"''"),n=n.replace(/\%/g,"%25"),n=n.replace(/\&/g,"%26"),n=n.replace(/\*/g,"%2A"),n=n.replace(/\+/g,"%2B"),n=n.replace(/\//g,"%2F"),n=n.replace(/\?/g,"%3F"),n=n.replace(/\#/g,"%23"),n=$format("'{0}'",n))),n},BatchProcessor:function(n,t,i){var r=this;i===undefined&&(i={});i.BatchSize===undefined&&(i.BatchSize=util.BatchProcessor._DefaultBatchSize);i.CompleteCallback===undefined&&(i.CompleteCallback=function(){});this._arrayCount=n.length;this._lastIndex=this._arrayCount-1;this._rowIndex=0;this.process=function(){r._arrayCount>0?window.setTimeout(r._processNextBatch,0):i.CompleteCallback()};this._processNextBatch=function(){var f=!1,u=r._rowIndex+i.BatchSize-1;for(u>r._lastIndex&&(u=r._lastIndex);r._rowIndex<=u;r._rowIndex++)if(t(r._rowIndex,n[r._rowIndex])===!1){f=!0;break}r._rowIndex===r._arrayCount||f?i.CompleteCallback():window.setTimeout(r._processNextBatch,util.BatchProcessor._BatchDelay)}},sortArrayAsync:function(n,t,i){function u(i,f,e,o,s,h,c){function it(){u(i,f,e,l,a,k,y)}function w(){return p=l<a+1-y}var d=f-i+1,p,nt,tt,b,v;if(d<2){e();return}var k=h!==undefined?h:n[Math.floor(Math.random()*d)+i],y=c!==undefined?c:1,l=o!==undefined?o:i,a=s!==undefined?s:f,g=!1;for(w();p;){while(w()&&(nt=t(n[l],k))<0)r++,l++;while(w()&&(tt=t(n[a],k))>0)r++,a--;if(p)if(nt===tt){for(v=l+1,y=2;v<a&&t(n[v],n[l])===0;)r++,v++,y++;b=n[a];n[a]=n[v];n[v]=b;w()}else b=n[a],n[a]=n[l],n[l]=b;if(r>=util.sortArrayAsync._MaxIterations){g=!0;r=0;window.setTimeout(it,util.sortArrayAsync._SortDelay);break}}p||g||u(i,l-1,function(){u(l+y,f,e)})}var r=0;u(0,n.length-1,i)},generateGuid:function(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(n){var t=Math.random()*16|0,i=n=="x"?t:t&3|8;return i.toString(16)})}},$label,$format,resources,messaging,Office,appletMessaging,authentication,app,appletInteraction,officeInteraction;util.BatchProcessor._DefaultBatchSize=2048;util.BatchProcessor._BatchDelay=10;util.sortArrayAsync._MaxIterations=2048;util.sortArrayAsync._SortDelay=10;util.Guid.NullGuidString="00000000-0000-0000-0000-000000000000";util.StringSet.prototype._set=undefined;util.StringSet.prototype.getItems=function(){return Object.keys(this._set)};util.StringSet.prototype.add=function(n){this._set[n]=undefined};util.StringSet.prototype.remove=function(n){return delete this._set[n]};util.Map.prototype._map=undefined;util.Map.prototype.getKeys=function(){return Object.keys(this._map)};util.Map.prototype.containsKey=function(n){return n in this._map};util.Map.prototype.isEmpty=function(){return Object.keys(this._map).length===0};util.Map.prototype.add=function(n,t){this._map[n]=t};util.Map.prototype.addMap=function(n){var t=this;n&&$.each(n.getKeys(),function(i,r){t._map[r]=n.get(r)})};util.Map.prototype.get=function(n){return this._map[n]};util.Map.prototype.remove=function(n){return delete this._map[n]};util.Map.prototype.clear=function(){var n=this,t=n.getKeys();$.each(t,function(t,i){n.remove(i)})};util.Map.prototype.copyToArray=function(n){var t=this;$.each(t.getKeys(),function(i,r){n.push(t.get(r))})};util.Map.prototype.copyToArrayAsync=function(n,t){var i=this;new util.BatchProcessor(i.getKeys(),function(t,r){n.push(i.get(r))},{CompleteCallback:t}).process()};util.Map.prototype.map=function(n){var t=this,i=new util.Map;return $.each(t.getKeys(),function(r,u){i.add(u,n(t.get(u),u,t))}),i};util.Promise=function(){};util.Promise.prototype._then=undefined;util.Promise.prototype._catch=undefined;util.Promise.prototype._finally=undefined;util.Promise.prototype.then=function(n,t){switch(arguments.length){case 0:n=$.noop;t={};break;case 1:$.isFunction(n)?t={}:(n=$.noop,t=arguments[0])}return this._then=new util.Promise._NextClause(n,new util.Promise),$.isFunction(t.catch)&&this.catch(t.catch),$.isFunction(t.finally)&&this.finally(t.finally),this._then.Promise};util.Promise.prototype.catch=function(n){return this._catch=new util.Promise._NextClause(n,new util.Promise),this._catch.Promise};util.Promise.prototype.finally=function(n){return this._finally=new util.Promise._NextClause(n,new util.Promise),this._finally.Promise};util.Promise.prototype.resolve=function(n){this._then!==undefined?util.Promise._executePromiseCallback(this,this._then,n):this._finally!==undefined&&util.Promise._executePromiseCallback(this,this._finally)};util.Promise.prototype.reject=function(n){var t=util.Promise._executeClosestPromiseCatch(this,n,{isException:!1})};util.Promise._executePromiseCallback=function(n,t,i){try{var r=t.Callback(i);n._finally!==undefined&&n._finally!==t&&util.Promise._executePromiseCallback(n,n._finally);r instanceof util.Promise?(r._then=t.Promise._then,r._catch=t.Promise._catch,r._finally=t.Promise._finally):t.Promise._then!==undefined?util.Promise._executePromiseCallback(t.Promise,t.Promise._then,r):t.Promise._finally!==undefined&&util.Promise._executePromiseCallback(t.Promise,t.Promise._finally)}catch(u){util.Promise._executeClosestPromiseCatch(t.Promise,u,{"finally":n._finally})}};util.Promise._executeClosestPromiseCatch=function(n,t,i){i===undefined&&(i={});var r;if(r=i.finally!==undefined?function(){util.Promise._executePromiseCallback(n,i.finally)}:$.noop,n._catch!==undefined)util.Promise._executePromiseCallback(n,n._catch,t);else if(r(),n._then!==undefined)util.Promise._executeClosestPromiseCatch(n._then.Promise,t,{"finally":n._finally,isException:i.isException});else if(n._finally!==undefined&&util.Promise._executePromiseCallback(n,n._finally),i.isException!==!1)throw t;};util.Promise._NextClause=function(n,t){this.Callback=n;this.Promise=t};$label=util.label;$format=util.format;
/*!
// <copyright file="Resources.js" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
*/
resources={_format:$format,Excel:{DesignerButtonLabel:function(){return $label("Excel_DesignerButtonLabel")},DesignerButtonTooltip:function(){return $label("Excel_DesignerButtonTooltip")},DesignerDialogAddDataFailedErrorFormat:function(n){var t=$label("Excel_DesignerDialogAddDataFailedErrorFormat");return resources._format(t,n)},DesignerDialogBindingFailedError:function(){return $label("Excel_DesignerDialogBindingFailedError")},OptionsRefreshGroupTitle:function(){return $label("Excel_OptionsRefreshGroupTitle")},OptionsAutoSizeColumnsText:function(){return $label("Excel_OptionsAutoSizeColumnsText")},OptionsRefreshOnOpenText:function(){return $label("Excel_OptionsRefreshOnOpenText")},OptionsCellRefreshLimit:function(){return $label("Excel_OptionsCellRefreshLimit")},OptionsClearBindingDataText:function(){return $label("Excel_OptionsClearBindingDataText")},OptionsPublishGroupTitle:function(){return $label("Excel_OptionsPublishGroupTitle")},OptionsConfirmPublishOnCreateText:function(){return $label("Excel_OptionsConfirmPublishOnCreateText")},OptionsConfirmPublishOnUpdateText:function(){return $label("Excel_OptionsConfirmPublishOnUpdateText")},OptionsConfirmPublishOnDeleteText:function(){return $label("Excel_OptionsConfirmPublishOnDeleteText")},OptionsPublishSequentiallyText:function(){return $label("Excel_OptionsPublishSequentiallyText")},OptionsDesignGroupTitle:function(){return $label("Excel_OptionsDesignGroupTitle")},OptionsEnableDesignText:function(){return $label("Excel_OptionsEnableDesignText")},InvalidCellLimitValueError:function(){return $label("Excel_InvalidCellLimitValueError")},AddRecordButtonLabel:function(){return $label("Excel_AddRecordButtonLabel")},AddRecordButtonTooltip:function(){return $label("Excel_AddRecordButtonTooltip")},RefreshButtonLabel:function(){return $label("Excel_RefreshButtonLabel")},RefreshButtonTooltip:function(){return $label("Excel_RefreshButtonTooltip")},PublishButtonLabel:function(){return $label("Excel_PublishButtonLabel")},PublishButtonTooltip:function(){return $label("Excel_PublishButtonTooltip")},FilterButtonLabel:function(){return $label("Excel_FilterButtonLabel")},FilterButtonTooltip:function(){return $label("Excel_FilterButtonTooltip")},RetrievingColumnHeaders:function(){return $label("Excel_RetrievingColumnHeaders")},ColumnHeadersRetrieved:function(){return $label("Excel_ColumnHeadersRetrieved")},RetrievingColumnHeadersFailed:function(){return $label("Excel_RetrievingColumnHeadersFailed")},RetrievingMetadata:function(){return $label("Excel_RetrievingMetadata")},MetadataRetrieved:function(){return $label("Excel_MetadataRetrieved")},RetrievingMetadataFailed:function(){return $label("Excel_RetrievingMetadataFailed")},BinaryFieldsError:function(){return $label("Excel_BinaryFieldsError")},BinaryFieldsErrorDetail:function(){return $label("Excel_BinaryFieldsErrorDetail")},BinaryFieldErrorFormat:function(n){var t=$label("Excel_BinaryFieldErrorFormat");return resources._format(t,n)},LocalizingColumnHeaders:function(){return $label("Excel_LocalizingColumnHeaders")},ColumnHeadersLocalized:function(){return $label("Excel_ColumnHeadersLocalized")},LocalizingColumnHeadersFailed:function(){return $label("Excel_LocalizingColumnHeadersFailed")},SelectedDataSourceTextFormat:function(n){var t=$label("Excel_SelectedDataSourceTextFormat");return resources._format(t,n)},SelectedDataSourceTitleFormat:function(n){var t=$label("Excel_SelectedDataSourceTitleFormat");return resources._format(t,n)},SelectedFieldTextFormat:function(n){var t=$label("Excel_SelectedFieldTextFormat");return resources._format(t,n)},SelectedFieldTitleFormat:function(n,t){var i=$label("Excel_SelectedFieldTitleFormat");return resources._format(i,n,t)},SelectedFieldIsKey:function(){return $label("Excel_SelectedFieldIsKey")},SelectedFieldIsMandatory:function(){return $label("Excel_SelectedFieldIsMandatory")},NonExistentFieldsBoundError:function(){return $label("Excel_NonExistentFieldsBoundError")},EntityNonExistentFieldsDetail:function(n,t){var i=$label("Excel_EntityNonExistentFieldsDetail");return resources._format(i,n,t)},EntityNonExistentFieldsDetailSeparator:function(){return $label("Excel_EntityNonExistentFieldsDetailSeparator")},EntityNonExistentFieldsSeparator:function(){return $label("Excel_EntityNonExistentFieldsSeparator")},AddingLabelBinding:function(){return $label("Excel_AddingLabelBinding")},LabelBindingAdded:function(){return $label("Excel_LabelBindingAdded")},AddingLabelBindingFailed:function(){return $label("Excel_AddingLabelBindingFailed")},LocalizingLabelBindings:function(){return $label("Excel_LocalizingLabelBindings")},LabelBindingsLocalized:function(){return $label("Excel_LabelBindingsLocalized")},LocalizingLabelBindingsFailed:function(){return $label("Excel_LocalizingLabelBindingsFailed")},AddingValueBinding:function(){return $label("Excel_AddingValueBinding")},ValueBindingAdded:function(){return $label("Excel_ValueBindingAdded")},AddingValueBindingFailed:function(){return $label("Excel_AddingValueBindingFailed")},AddingTableBinding:function(){return $label("Excel_AddingTableBinding")},TableBindingAdded:function(){return $label("Excel_TableBindingAdded")},AddingTableBindingFailed:function(){return $label("Excel_AddingTableBindingFailed")},UpdatingTableBinding:function(){return $label("Excel_UpdatingTableBinding")},TableBindingUpdated:function(){return $label("Excel_TableBindingUpdated")},UpdatingTableBindingFailed:function(){return $label("Excel_UpdatingTableBindingFailed")},BindingChangeRequiresRefreshPrompt:function(){return $label("Excel_BindingChangeRequiresRefreshPrompt")},BindingAlreadyExistsForSelectionError:function(){return $label("Excel_BindingAlreadyExistsForSelectionError")},ClearingData:function(){return $label("Excel_ClearingData")},DataCleared:function(){return $label("Excel_DataCleared")},ClearBindingsError:function(){return $label("Excel_ClearBindingsError")},NonPublishableDataSources:function(n){var t=$label("Excel_NonPublishableDataSources");return resources._format(t,n)},NonPublishableDataSourcesSeparator:function(){return $label("Excel_NonPublishableDataSourcesSeparator")},NonPublishableDataSourceReadOnly:function(n){var t=$label("Excel_NonPublishableDataSourceReadOnly");return resources._format(t,n)},NonPublishableDataSourceIdentityFieldsMissing:function(n){var t=$label("Excel_NonPublishableDataSourceIdentityFieldsMissing");return resources._format(t,n)},NonPublishableDataSourceMetadataNotLoaded:function(n){var t=$label("Excel_NonPublishableDataSourceMetadataNotLoaded");return resources._format(t,n)},DataCacheReadError:function(){return $label("Excel_DataCacheReadError")},ConfirmRefreshAfterCacheLoadFailure:function(){return $label("Excel_ConfirmRefreshAfterCacheLoadFailure")}},DataPublish:{PublishingError:function(){return $label("DataPublish_PublishingError")},NoDataToPublish:function(){return $label("DataPublish_NoDataToPublish")},PublishConfirmationFormat:function(n,t,i){var r=$label("DataPublish_PublishConfirmationFormat");return resources._format(r,n,t,i)},PublishConfirmDiscardReadOnlyChanges:function(){return $label("DataPublish_PublishConfirmDiscardReadOnlyChanges")},PublishingMessage:function(){return $label("DataPublish_PublishingMessage")},PublishingProgress:function(n){var t=$label("DataPublish_PublishingProgress");return resources._format(t,n)},PublishingSuccess:function(){return $label("DataPublish_PublishingSuccess")},PublishingErrorRowsHidden:function(){return $label("DataPublish_PublishingErrorRowsHidden")},PublishingErrorWithCountFormat:function(n){var t=$label("DataPublish_PublishingErrorWithCountFormat");return resources._format(t,n)},PublishError_OneOrMoreFailures:function(n,t){var i=$label("DataPublish_PublishError_OneOrMoreFailures");return resources._format(i,n,t)},PublishingSuccessCreateCountMessage:function(n){var t=$label("DataPublish_PublishingSuccessCreateCountMessage");return resources._format(t,n)},PublishingSuccessUpdateCountMessage:function(n){var t=$label("DataPublish_PublishingSuccessUpdateCountMessage");return resources._format(t,n)},PublishingSuccessDeleteCountMessage:function(n){var t=$label("DataPublish_PublishingSuccessDeleteCountMessage");return resources._format(t,n)},PublishingRowError:function(){return $label("DataPublish_PublishingRowError")},DisplayValueGenerationError:function(n){var t=$label("DataPublish_DisplayValueGenerationError");return resources._format(t,n)},UpdatingMessage:function(){return $label("DataPublish_UpdatingMessage")},UpdatingProgress:function(n){var t=$label("DataPublish_UpdatingProgress");return resources._format(t,n)},UpdatingError:function(n){var t=$label("DataPublish_UpdatingError");return resources._format(t,n)},UpdatingSuccess:function(){return $label("DataPublish_UpdatingSuccess")},UpdatingPartialSuccess:function(){return $label("DataPublish_UpdatingPartialSuccess")},UpdatingSuccessPublishingFailed:function(){return $label("DataPublish_UpdatingSuccessPublishingFailed")},UpdatingFormattingError:function(){return $label("DataPublish_UpdatingFormattingError")},RetrieveBindingDataMessage:function(){return $label("DataPublish_RetrieveBindingDataMessage")},RetrieveBindingDataSuccess:function(){return $label("DataPublish_RetrieveBindingDataSuccess")},RetrieveBindingDataFailed:function(){return $label("DataPublish_RetrieveBindingDataFailed")},AnalyzingDataChangesMessage:function(){return $label("DataPublish_AnalyzingDataChangesMessage")},AnalyzingDataChangesSuccess:function(){return $label("DataPublish_AnalyzingDataChangesSuccess")},AnalyzingDataChangesFailed:function(){return $label("DataPublish_AnalyzingDataChangesFailed")},NonPublishabledFields:function(n){var t=$label("DataPublish_NonPublishabledFields");return resources._format(t,n)},NonPublishabledFieldsSeparator:function(){return $label("DataPublish_NonPublishabledFieldsSeparator")}},DataRefresh:{UnableToGetWorkbookDataForFieldError:function(){return $label("DataRefresh_UnableToGetWorkbookDataForFieldError")},DataRetrievalError:function(){return $label("DataRefresh_DataRetrievalError")},DataWriteError:function(){return $label("DataRefresh_DataWriteError")},DataReadError:function(){return $label("DataRefresh_DataReadError")},RefreshingData:function(){return $label("DataRefresh_RefreshingData")},RefreshingDataProgress:function(n){var t=$label("DataRefresh_RefreshingDataProgress");return resources._format(t,n)},UpdatingWorkbook:function(){return $label("DataRefresh_UpdatingWorkbook")},CountRetrievalError:function(n,t){var i=$label("DataRefresh_CountRetrievalError");return resources._format(i,n,t)},RefreshingErrorRowsHidden:function(){return $label("DataRefresh_RefreshingErrorRowsHidden")},RefreshedAllEntityData:function(){return $label("DataRefresh_RefreshedAllEntityData")},RefreshedEntityDataFormat:function(n,t,i){var r=$label("DataRefresh_RefreshedEntityDataFormat");return resources._format(r,n,t,i)},CellRefreshLimitExceeded:function(n){var t=$label("DataRefresh_CellRefreshLimitExceeded");return resources._format(t,n)},EditFilters:function(){return $label("DataRefresh_EditFilters")},DataRefreshed:function(){return $label("DataRefresh_DataRefreshed")},RefreshingDataFailed:function(){return $label("DataRefresh_RefreshingDataFailed")},NoBindingsToRefresh:function(){return $label("DataRefresh_NoBindingsToRefresh")},RefreshingDataCancelled:function(){return $label("DataRefresh_RefreshingDataCancelled")},UnableToRefreshData:function(){return $label("DataRefresh_UnableToRefreshData")},UnableToFindEntityFormat:function(n){var t=$label("DataRefresh_UnableToFindEntityFormat");return resources._format(t,n)},UnableToGetWorkbookDataError:function(){return $label("DataRefresh_UnableToGetWorkbookDataError")},RefreshConfirmationTitle:function(){return $label("DataRefresh_RefreshConfirmationTitle")},RefreshConfirmationMessage:function(){return $label("DataRefresh_RefreshConfirmationMessage")},MultipleEntityNamesFormat:function(n,t,i){var r=$label("DataRefresh_MultipleEntityNamesFormat");return resources._format(r,n,t,i)},MultipleEntityNameSeparator:function(){return $label("DataRefresh_MultipleEntityNameSeparator")},MultipleFailureMessagesFormat:function(n,t,i){var r=$label("DataRefresh_MultipleFailureMessagesFormat");return resources._format(r,n,t,i)},MultipleFailureMessagesSeparator:function(){return $label("DataRefresh_MultipleFailureMessagesSeparator")}},DataCache:{ReadOperationText:function(){return $label("DataCache_ReadOperationText")},ReadCompleteText:function(){return $label("DataCache_ReadCompleteText")},ReadFailedText:function(){return $label("DataCache_ReadFailedText")},WriteOperationText:function(){return $label("DataCache_WriteOperationText")},WriteCompleteText:function(){return $label("DataCache_WriteCompleteText")},WriteFailedText:function(){return $label("DataCache_WriteFailedText")},WriteError:function(){return $label("DataCache_WriteError")},RowJsonParseError:function(){return $label("DataCache_RowJsonParseError")},WorksheetUserWarning:function(){return $label("DataCache_WorksheetUserWarning")}},Lookup:{ConfiguringSelectionChangedHandlers:function(){return $label("Lookup_ConfiguringSelectionChangedHandlers")},SelectionChangedHandlersConfigured:function(){return $label("Lookup_SelectionChangedHandlersConfigured")},ConfiguringSelectionChangedHandlersFailed:function(){return $label("Lookup_ConfiguringSelectionChangedHandlersFailed")},ErrorConfiguringSelectionChangedHandlers:function(){return $label("Lookup_ErrorConfiguringSelectionChangedHandlers")},ListControlLabel:function(n){var t=$label("Lookup_ListControlLabel");return resources._format(t,n)},ConfiguringLookupsLabel:function(){return $label("Lookup_ConfiguringLookupsLabel")},RelationLookupResultsMoreThanBatchStatus:function(n){var t=$label("Lookup_RelationLookupResultsMoreThanBatchStatus");return resources._format(t,n)},RelationLookupResultsLessThanBatchStatus:function(n){var t=$label("Lookup_RelationLookupResultsLessThanBatchStatus");return resources._format(t,n)},MultiPartRelationLookupFieldsNotBound:function(n){var t=$label("Lookup_MultiPartRelationLookupFieldsNotBound");return resources._format(t,n)},MultiPartRelationLookupFieldsNotBoundDelimiter:function(){return $label("Lookup_MultiPartRelationLookupFieldsNotBoundDelimiter")},RelationLookupEmpty:function(){return $label("Lookup_RelationLookupEmpty")},RelationLookupRetrievingData:function(){return $label("Lookup_RelationLookupRetrievingData")},RelationLookupSortAscending:function(){return $label("Lookup_RelationLookupSortAscending")},RelationLookupSortDescending:function(){return $label("Lookup_RelationLookupSortDescending")},RelationLookupRemoveSort:function(){return $label("Lookup_RelationLookupRemoveSort")},RelationLookupFilterShowRows:function(){return $label("Lookup_RelationLookupFilterShowRows")},RelationLookupFilterShowDateRows:function(){return $label("Lookup_RelationLookupFilterShowDateRows")},RelationLookupFilterButtonLabel:function(){return $label("Lookup_RelationLookupFilterButtonLabel")},RelationLookupClearButtonLabel:function(){return $label("Lookup_RelationLookupClearButtonLabel")},RelationLookupChooseFilter:function(){return $label("Lookup_RelationLookupChooseFilter")}},DataDef:{Error_MetadataNotLoaded:function(n){var t=$label("DataDef_Error_MetadataNotLoaded");return resources._format(t,n)}},Selection:{SelectedDataSourceIsReadonly:function(){return $label("Selection_SelectedDataSourceIsReadonly")},SelectedFieldIsReadonly:function(){return $label("Selection_SelectedFieldIsReadonly")},SelectedFieldIsReadonlyOnCreate:function(){return $label("Selection_SelectedFieldIsReadonlyOnCreate")},UnboundLabelText:function(n){var t=$label("Selection_UnboundLabelText");return resources._format(t,n)},UnboundLabelTooltip:function(n){var t=$label("Selection_UnboundLabelTooltip");return resources._format(t,n)},UnboundStaticLabelTooltip:function(){return $label("Selection_UnboundStaticLabelTooltip")}},DesignTime:{DesignerTitle:function(){return $label("DesignTime_DesignerTitle")},AllBindingsSourceColumnLabel:function(){return $label("DesignTime_AllBindingsSourceColumnLabel")},TableBindingTypeLabel:function(){return $label("DesignTime_TableBindingTypeLabel")},FieldSetBindingTypeLabel:function(){return $label("DesignTime_FieldSetBindingTypeLabel")},EditLabel:function(){return $label("DesignTime_EditLabel")},DeleteLabel:function(){return $label("DesignTime_DeleteLabel")},SaveLabel:function(){return $label("DesignTime_SaveLabel")},AddFieldBindingButtonLabel:function(){return $label("DesignTime_AddFieldBindingButtonLabel")},AddFieldBindingButtonTooltip:function(){return $label("DesignTime_AddFieldBindingButtonTooltip")},AddTableBindingButtonLabel:function(){return $label("DesignTime_AddTableBindingButtonLabel")},AddTableBindingButtonTooltip:function(){return $label("DesignTime_AddTableBindingButtonTooltip")},LabelBindingsButtonLabel:function(){return $label("DesignTime_LabelBindingsButtonLabel")},LabelBindingsButtonTooltip:function(){return $label("DesignTime_LabelBindingsButtonTooltip")},AddUnboundLabelButtonLabel:function(){return $label("DesignTime_AddUnboundLabelButtonLabel")},AddUnboundLabelButtonTooltip:function(){return $label("DesignTime_AddUnboundLabelButtonTooltip")},UnboundLabelTableHeading:function(){return $label("DesignTime_UnboundLabelTableHeading")},UnboundLabelDefaultValue:function(){return $label("DesignTime_UnboundLabelDefaultValue")},AddingUnboundLabelFailedMessage:function(){return $label("DesignTime_AddingUnboundLabelFailedMessage")},UnboundLabelsCloseConfirmation:function(){return $label("DesignTime_UnboundLabelsCloseConfirmation")},DoneButtonLabel:function(){return $label("DesignTime_DoneButtonLabel")},AddFieldButtonLabel:function(){return $label("DesignTime_AddFieldButtonLabel")},AddFieldButtonTooltip:function(){return $label("DesignTime_AddFieldButtonTooltip")},AddFormulaButtonLabel:function(){return $label("DesignTime_AddFormulaButtonLabel")},AddFormulaButtonTooltip:function(){return $label("DesignTime_AddFormulaButtonTooltip")},RemoveFieldButtonLabel:function(){return $label("DesignTime_RemoveFieldButtonLabel")},RemoveFieldButtonTooltip:function(){return $label("DesignTime_RemoveFieldButtonTooltip")},MoveFieldUpButtonLabel:function(){return $label("DesignTime_MoveFieldUpButtonLabel")},MoveFieldUpButtonTooltip:function(){return $label("DesignTime_MoveFieldUpButtonTooltip")},MoveFieldDownButtonLabel:function(){return $label("DesignTime_MoveFieldDownButtonLabel")},MoveFieldDownButtonTooltip:function(){return $label("DesignTime_MoveFieldDownButtonTooltip")},ColumnLabelInputLabel:function(){return $label("DesignTime_ColumnLabelInputLabel")},FormulaInputLabel:function(){return $label("DesignTime_FormulaInputLabel")},ColumnForceReadOnlyCheckboxLabel:function(){return $label("DesignTime_ColumnForceReadOnlyCheckboxLabel")},ColumnForceReadOnlyOnCreateCheckboxLabel:function(){return $label("DesignTime_ColumnForceReadOnlyOnCreateCheckboxLabel")},ColumnForceReadOnlyTitleLabel:function(){return $label("DesignTime_ColumnForceReadOnlyTitleLabel")},ColumnForceReadOnlyOnCreateTitleLabel:function(){return $label("DesignTime_ColumnForceReadOnlyOnCreateTitleLabel")},NewColumnLabelFormat:function(n){var t=$label("DesignTime_NewColumnLabelFormat");return resources._format(t,n)},SelectedSourceLabel:function(){return $label("DesignTime_SelectedSourceLabel")},SelectedFieldsLabel:function(){return $label("DesignTime_SelectedFieldsLabel")},AvailableFieldsLabel:function(){return $label("DesignTime_AvailableFieldsLabel")},EntityOptionsHeadingLabel:function(){return $label("DesignTime_EntityOptionsHeadingLabel")},EntityRefreshAfterPublishLabel:function(){return $label("DesignTime_EntityRefreshAfterPublishLabel")},EntityRefreshAfterPublishTooltip:function(){return $label("DesignTime_EntityRefreshAfterPublishTooltip")},FieldFormat:function(n,t){var i=$label("DesignTime_FieldFormat");return resources._format(i,n,t)},FieldLabelSuffixFormat:function(n){var t=$label("DesignTime_FieldLabelSuffixFormat");return resources._format(t,n)},OkButtonText:function(){return $label("DesignTime_OkButtonText")},CancelButtonText:function(){return $label("DesignTime_CancelButtonText")},AddLabelButtonLabel:function(){return $label("DesignTime_AddLabelButtonLabel")},AddValueButtonLabel:function(){return $label("DesignTime_AddValueButtonLabel")},FieldBindingsSourceColumnLabel:function(){return $label("DesignTime_FieldBindingsSourceColumnLabel")},FieldLabelBindingTypeLabel:function(){return $label("DesignTime_FieldLabelBindingTypeLabel")},FieldValueBindingTypeLabel:function(){return $label("DesignTime_FieldValueBindingTypeLabel")},UnboundLabelsHeading:function(){return $label("DesignTime_UnboundLabelsHeading")},DesignerSourcesLabelText:function(){return $label("DesignTime_DesignerSourcesLabelText")},SelectSourcesNextButtonText:function(){return $label("DesignTime_SelectSourcesNextButtonText")},SelectSourcesPreviousButtonText:function(){return $label("DesignTime_SelectSourcesPreviousButtonText")},SelectedDataSourceDetailsText:function(){return $label("DesignTime_SelectedDataSourceDetailsText")},SelectedDataSourceLabelFormat:function(n){var t=$label("DesignTime_SelectedDataSourceLabelFormat");return resources._format(t,n)},SelectedDataSourceNameFormat:function(n){var t=$label("DesignTime_SelectedDataSourceNameFormat");return resources._format(t,n)},RelationNameFormat:function(n){var t=$label("DesignTime_RelationNameFormat");return resources._format(t,n)},SourceFormat:function(n,t){var i=$label("DesignTime_SourceFormat");return resources._format(i,n,t)},SourceSuffixFormat:function(n){var t=$label("DesignTime_SourceSuffixFormat");return resources._format(t,n)},UpdateBinding:function(){return $label("DesignTime_UpdateBinding")},RemovingBinding:function(){return $label("DesignTime_RemovingBinding")},BindingRemoved:function(){return $label("DesignTime_BindingRemoved")},EntityBoundWithRelatedDetails:function(){return $label("DesignTime_EntityBoundWithRelatedDetails")},EntityBoundWithDifferentRelatedDetails:function(){return $label("DesignTime_EntityBoundWithDifferentRelatedDetails")},AddRelatedTableTooltip:function(){return $label("DesignTime_AddRelatedTableTooltip")},NoRelatedTableTooltip:function(){return $label("DesignTime_NoRelatedTableTooltip")},IsRelatedToTooltip:function(n){var t=$label("DesignTime_IsRelatedToTooltip");return resources._format(t,n)},RevertToFieldLabelPromptMessage:function(n){var t=$label("DesignTime_RevertToFieldLabelPromptMessage");return resources._format(t,n)}},Filtering:{FilterDialogHeading:function(){return $label("Filtering_FilterDialogHeading")},FilterDialogEntitySelectLabel:function(){return $label("Filtering_FilterDialogEntitySelectLabel")},FilterDialogFilterInputLabel:function(){return $label("Filtering_FilterDialogFilterInputLabel")},FilterDialogNoBoundEntitiesMessage:function(){return $label("Filtering_FilterDialogNoBoundEntitiesMessage")},FilterDialogDoneButtonLabel:function(){return $label("Filtering_FilterDialogDoneButtonLabel")},FilterDialogClearButtonLabel:function(){return $label("Filtering_FilterDialogClearButtonLabel")},FilterDialogClearButtonTitle:function(){return $label("Filtering_FilterDialogClearButtonTitle")},FilterDialogAddButtonLabel:function(){return $label("Filtering_FilterDialogAddButtonLabel")},FilterNotSupportedMessage:function(){return $label("Filtering_FilterNotSupportedMessage")},InvalidFilterEnteredMessage:function(){return $label("Filtering_InvalidFilterEnteredMessage")},InvalidFilterEnteredDetailsFormat:function(n,t){var i=$label("Filtering_InvalidFilterEnteredDetailsFormat");return resources._format(i,n,t)},OrOperation:function(){return $label("Filtering_OrOperation")},AndOperation:function(){return $label("Filtering_AndOperation")},EqualOperation:function(){return $label("Filtering_EqualOperation")},NotEqualOperation:function(){return $label("Filtering_NotEqualOperation")},LessThanOperation:function(){return $label("Filtering_LessThanOperation")},LessThanOrEqualOperation:function(){return $label("Filtering_LessThanOrEqualOperation")},GreaterThanOperation:function(){return $label("Filtering_GreaterThanOperation")},GreaterThanOrEqualOperation:function(){return $label("Filtering_GreaterThanOrEqualOperation")},IsEmptyOperation:function(){return $label("Filtering_IsEmptyOperation")},IsNotEmptyOperation:function(){return $label("Filtering_IsNotEmptyOperation")},ContainsOperation:function(){return $label("Filtering_ContainsOperation")},DoesNotContainOperation:function(){return $label("Filtering_DoesNotContainOperation")},StartsWithOperation:function(){return $label("Filtering_StartsWithOperation")},EndsWithOperation:function(){return $label("Filtering_EndsWithOperation")}},Error:{LoadingMetadata_Title:function(){return $label("Error_LoadingMetadata_Title")},ResolvingLabels_Title:function(){return $label("Error_ResolvingLabels_Title")},UnableToResolveLabelFormat:function(n){var t=$label("Error_UnableToResolveLabelFormat");return resources._format(t,n)},UnableToRetrieveEntities:function(){return $label("Error_UnableToRetrieveEntities")},UrlTooLong:function(){return $label("Error_UrlTooLong")},UnknownMessageType:function(n){var t=$label("Error_UnknownMessageType");return resources._format(t,n)}},Metadata:{RetrievingMetadata:function(){return $label("Metadata_RetrievingMetadata")},MetadataRetrieved:function(){return $label("Metadata_MetadataRetrieved")},RetrievingMetadataFailed:function(){return $label("Metadata_RetrievingMetadataFailed")},RetrievingEntityNames:function(){return $label("Metadata_RetrievingEntityNames")},EntityNamesRetrieved:function(){return $label("Metadata_EntityNamesRetrieved")},RetrievingEntityNamesFailed:function(){return $label("Metadata_RetrievingEntityNamesFailed")}},Views:{Error_BindingFormattingColumns_Title:function(){return $label("Views_Error_BindingFormattingColumns_Title")},Error_BindingAddingRows_Title:function(){return $label("Views_Error_BindingAddingRows_Title")},Error_BindingDeleteRows_Title:function(){return $label("Views_Error_BindingDeleteRows_Title")},Error_BindingAutoFit_Title:function(){return $label("Views_Error_BindingAutoFit_Title")},Error_EntityNotFound_Title:function(){return $label("Views_Error_EntityNotFound_Title")},Error_EntityNotFound_Text:function(n){var t=$label("Views_Error_EntityNotFound_Text");return resources._format(t,n)},Error_EntityNotFound_NoEntity_Text:function(){return $label("Views_Error_EntityNotFound_NoEntity_Text")},Error_NewContainsDuplicateEntries:function(){return $label("Views_Error_NewContainsDuplicateEntries")},Error_NewContainsRowsWithoutIdentity:function(n){var t=$label("Views_Error_NewContainsRowsWithoutIdentity");return resources._format(t,n)},Error_OriginalContainsDuplicateEntries:function(){return $label("Views_Error_OriginalContainsDuplicateEntries")},Error_OriginalContainsRowsWithoutIdentity:function(n){var t=$label("Views_Error_OriginalContainsRowsWithoutIdentity");return resources._format(t,n)},Error_ClearingFormatting:function(){return $label("Views_Error_ClearingFormatting")},Info_DataRefreshed_NoData:function(){return $label("Views_Info_DataRefreshed_NoData")},Confirm_LabelValueChangedFormat:function(n,t){var i=$label("Views_Confirm_LabelValueChangedFormat");return resources._format(i,n,t)},UnableToChangeKeyFieldOfFieldSetBindingError:function(n,t){var i=$label("Views_UnableToChangeKeyFieldOfFieldSetBindingError");return resources._format(i,n,t)},NoDataLoadedForBinding:function(){return $label("Views_NoDataLoadedForBinding")},DeletedColumnHeader:function(){return $label("Views_DeletedColumnHeader")}},Message:{CloseWindow:function(){return $label("Message_CloseWindow")},UserAuthenticated:function(){return $label("Message_UserAuthenticated")}},Warning:{OfficeAppsPageOnly:function(){return $label("Warning_OfficeAppsPageOnly")}},MetadataError:{MalformedXml:function(){return $label("MetadataError_MalformedXml")},MalformedEntityXmlFormat:function(n){var t=$label("MetadataError_MalformedEntityXmlFormat");return resources._format(t,n)},MalformedEntityXmlSeparator:function(){return $label("MetadataError_MalformedEntityXmlSeparator")}},LabelError:{UndeterminedSuccess:function(){return $label("LabelError_UndeterminedSuccess")}},DisplayValueError:{UnrecognizedEntity:function(n){var t=$label("DisplayValueError_UnrecognizedEntity");return resources._format(t,n)}},PublishError:{UndeterminedSuccess:function(){return $label("PublishError_UndeterminedSuccess")},OneOrMoreFailures:function(n,t){var i=$label("PublishError_OneOrMoreFailures");return resources._format(i,n,t)},ConcurrencyConflict:function(){return $label("PublishError_ConcurrencyConflict")}},PublishMessage:{CreatedRowFailure:function(n,t){var i=$label("PublishMessage_CreatedRowFailure");return resources._format(i,n,t)},UpdatedRowFailure:function(n,t){var i=$label("PublishMessage_UpdatedRowFailure");return resources._format(i,n,t)},DeletedRowFailure:function(n,t){var i=$label("PublishMessage_DeletedRowFailure");return resources._format(i,n,t)}},UpdateError:{UndeterminedSuccess:function(){return $label("UpdateError_UndeterminedSuccess")},OneOrMoreFailures:function(n){var t=$label("UpdateError_OneOrMoreFailures");return resources._format(t,n)}},AppletMessaging:{RequestTimedOutMessage:function(){return $label("AppletMessaging_RequestTimedOutMessage")}},AppWrapper:{UnhandledErrorOccurredMessage:function(){return $label("AppWrapper_UnhandledErrorOccurredMessage")}},AppletInteraction:{InvalidRelativeUrlFormat:function(n,t){var i=$label("AppletInteraction_InvalidRelativeUrlFormat");return resources._format(i,n,t)},DuplicateResourceFormat:function(n,t){var i=$label("AppletInteraction_DuplicateResourceFormat");return resources._format(i,n,t)},UnableToLoadAppletErrorFormat:function(n){var t=$label("AppletInteraction_UnableToLoadAppletErrorFormat");return resources._format(t,n)},UnableToUpdateAppletOptionsErrorFormat:function(n){var t=$label("AppletInteraction_UnableToUpdateAppletOptionsErrorFormat");return resources._format(t,n)},AppletConfigurationTimedOutErrorFormat:function(n){var t=$label("AppletInteraction_AppletConfigurationTimedOutErrorFormat");return resources._format(t,n)},AppletLocalizationErrorFormat:function(n){var t=$label("AppletInteraction_AppletLocalizationErrorFormat");return resources._format(t,n)},UnableToLoadResourceErrorFormat:function(n){var t=$label("AppletInteraction_UnableToLoadResourceErrorFormat");return resources._format(t,n)},ResourceConfigurationTimedOutErrorFormat:function(n){var t=$label("AppletInteraction_ResourceConfigurationTimedOutErrorFormat");return resources._format(t,n)},ResourceNotRegisteredErrorFormat:function(n){var t=$label("AppletInteraction_ResourceNotRegisteredErrorFormat");return resources._format(t,n)},UserConfirmAppletsLoadedChangesMessage:function(){return $label("AppletInteraction_UserConfirmAppletsLoadedChangesMessage")},AppletsToBeLoadedMessageFormat:function(n,t){var i=$label("AppletInteraction_AppletsToBeLoadedMessageFormat");return resources._format(i,n,t)},AppletsToBeUnloadedMessageFormat:function(n,t){var i=$label("AppletInteraction_AppletsToBeUnloadedMessageFormat");return resources._format(i,n,t)},AppletListSeparator:function(){return $label("AppletInteraction_AppletListSeparator")},AppletLoadingMessageFormat:function(n){var t=$label("AppletInteraction_AppletLoadingMessageFormat");return resources._format(t,n)},AppletLoadingFailedMessageFormat:function(n){var t=$label("AppletInteraction_AppletLoadingFailedMessageFormat");return resources._format(t,n)},AppletLoadingSucceededMessageFormat:function(n){var t=$label("AppletInteraction_AppletLoadingSucceededMessageFormat");return resources._format(t,n)},AppletToLoadNotRegisteredMessageFormat:function(n){var t=$label("AppletInteraction_AppletToLoadNotRegisteredMessageFormat");return resources._format(t,n)},NoAppletRegistrationsFoundMessageFormat:function(){return $label("AppletInteraction_NoAppletRegistrationsFoundMessageFormat")},AuthenticationError:function(){return $label("AppletInteraction_AuthenticationError")}},OfficeInteraction:{AppletDocumentSubscriptionErrorFormat:function(n){var t=$label("OfficeInteraction_AppletDocumentSubscriptionErrorFormat");return resources._format(t,n)},AppletTableBindingRetrievalError:function(){return $label("OfficeInteraction_AppletTableBindingRetrievalError")},AppletTableBindingSubscriptionErrorFormat:function(n){var t=$label("OfficeInteraction_AppletTableBindingSubscriptionErrorFormat");return resources._format(t,n)},AppletTableBindingMethodErrorFormat:function(n){var t=$label("OfficeInteraction_AppletTableBindingMethodErrorFormat");return resources._format(t,n)},ExecutingDocumentMethodErrorFormat:function(n){var t=$label("OfficeInteraction_ExecutingDocumentMethodErrorFormat");return resources._format(t,n)},ExecutingBindingsMethodErrorFormat:function(n){var t=$label("OfficeInteraction_ExecutingBindingsMethodErrorFormat");return resources._format(t,n)},OfficeMethodNotFoundErrorFormat:function(n){var t=$label("OfficeInteraction_OfficeMethodNotFoundErrorFormat");return resources._format(t,n)},Office2016RequiredError:function(){return $label("OfficeInteraction_Office2016RequiredError")}},Authentication:{UnableToLoadAuthenticationResourceError:function(){return $label("Authentication_UnableToLoadAuthenticationResourceError")},InvalidServerConfiguration:function(){return $label("Authentication_InvalidServerConfiguration")},NoAuthRealm:function(){return $label("Authentication_NoAuthRealm")},NoAuthClientId:function(){return $label("Authentication_NoAuthClientId")},NoAuthResourceId:function(){return $label("Authentication_NoAuthResourceId")},LoggedInAs:function(n){var t=$label("Authentication_LoggedInAs");return resources._format(t,n)},ManualSignInAttempted:function(){return $label("Authentication_ManualSignInAttempted")},SignOutLabel:function(){return $label("Authentication_SignOutLabel")},SigningOutMessage:function(){return $label("Authentication_SigningOutMessage")}},DynamicsApp:{UnsupportedIE:function(){return $label("DynamicsApp_UnsupportedIE")},UnrecognizedApplicationError:function(){return $label("DynamicsApp_UnrecognizedApplicationError")},RegistrationRetrievalError:function(){return $label("DynamicsApp_RegistrationRetrievalError")},Authentication_Verifying:function(){return $label("DynamicsApp_Authentication_Verifying")},Authentication_NotAuthenticated:function(){return $label("DynamicsApp_Authentication_NotAuthenticated")},Authentication_Authenticated:function(){return $label("DynamicsApp_Authentication_Authenticated")},SignInButtonLabel:function(){return $label("DynamicsApp_SignInButtonLabel")},UnableToSaveSettingsError:function(){return $label("DynamicsApp_UnableToSaveSettingsError")},UnableToSaveSettingsDetail:function(){return $label("DynamicsApp_UnableToSaveSettingsDetail")},Status_BusyFormattedMessage:function(n){var t=$label("DynamicsApp_Status_BusyFormattedMessage");return resources._format(t,n)},OptionsButtonTooltip:function(){return $label("DynamicsApp_OptionsButtonTooltip")},OptionsConfirmChangesTitle:function(){return $label("DynamicsApp_OptionsConfirmChangesTitle")},OptionsConfirmAppReloadMessage:function(){return $label("DynamicsApp_OptionsConfirmAppReloadMessage")},OptionsDialogTitle:function(){return $label("DynamicsApp_OptionsDialogTitle")},UserButtonTooltip:function(){return $label("DynamicsApp_UserButtonTooltip")},DynamicsAppOptionsTitle:function(){return $label("DynamicsApp_DynamicsAppOptionsTitle")},DynamicsAppGeneralOptionsTitle:function(){return $label("DynamicsApp_DynamicsAppGeneralOptionsTitle")},OptionsCancelButtonText:function(){return $label("DynamicsApp_OptionsCancelButtonText")},OptionsOkButtonText:function(){return $label("DynamicsApp_OptionsOkButtonText")},OptionsDialogServerText:function(){return $label("DynamicsApp_OptionsDialogServerText")},OptionsDialogLanguageText:function(){return $label("DynamicsApp_OptionsDialogLanguageText")},OptionsButtonLabel:function(){return $label("DynamicsApp_OptionsButtonLabel")},DynamicsAppAppletConfigTitle:function(){return $label("DynamicsApp_DynamicsAppAppletConfigTitle")},OptionsAppletConfigButtonLabel:function(){return $label("DynamicsApp_OptionsAppletConfigButtonLabel")},AppletConfigDialogTitle:function(){return $label("DynamicsApp_AppletConfigDialogTitle")},AppletConfigGroupTitle:function(){return $label("DynamicsApp_AppletConfigGroupTitle")},AppletConfigOkButtonLabel:function(){return $label("DynamicsApp_AppletConfigOkButtonLabel")},AppletConfigCancelButtonLabel:function(){return $label("DynamicsApp_AppletConfigCancelButtonLabel")},Notification_WithDetailsMessageFormat:function(n,t){var i=$label("DynamicsApp_Notification_WithDetailsMessageFormat");return resources._format(i,n,t)},Notification_TitleAndMessageFormat:function(n,t){var i=$label("DynamicsApp_Notification_TitleAndMessageFormat");return resources._format(i,n,t)},Notification_DurationFormat:function(n,t){var i=$label("DynamicsApp_Notification_DurationFormat");return resources._format(i,n,t)},NotificationsButtonTooltip:function(){return $label("DynamicsApp_NotificationsButtonTooltip")},OkButtonLabel:function(){return $label("DynamicsApp_OkButtonLabel")},CancelButtonLabel:function(){return $label("DynamicsApp_CancelButtonLabel")},YesButtonLabel:function(){return $label("DynamicsApp_YesButtonLabel")},NoButtonLabel:function(){return $label("DynamicsApp_NoButtonLabel")},MessageCenterHeading:function(){return $label("DynamicsApp_MessageCenterHeading")},MessageCenterNoMessages:function(){return $label("DynamicsApp_MessageCenterNoMessages")},MessageCenterErrorsOnlyLabel:function(){return $label("DynamicsApp_MessageCenterErrorsOnlyLabel")},MessageCenterClearButtonLabel:function(){return $label("DynamicsApp_MessageCenterClearButtonLabel")},MessageCenterDoneButtonLabel:function(){return $label("DynamicsApp_MessageCenterDoneButtonLabel")},UnknownMessageError:function(){return $label("DynamicsApp_UnknownMessageError")},NoServerMessage:function(){return $label("DynamicsApp_NoServerMessage")},NoServerLinkLabel:function(){return $label("DynamicsApp_NoServerLinkLabel")},NoAppletLinkLabel:function(){return $label("DynamicsApp_NoAppletLinkLabel")},RegistrationsRetrievalMessage:function(){return $label("DynamicsApp_RegistrationsRetrievalMessage")},RegistrationsRetrievalSucceededMessage:function(){return $label("DynamicsApp_RegistrationsRetrievalSucceededMessage")},RegistrationsRetrievalFailedMessage:function(){return $label("DynamicsApp_RegistrationsRetrievalFailedMessage")},InvalidHostUrlEnteredErrorMessage:function(){return $label("DynamicsApp_InvalidHostUrlEnteredErrorMessage")},UnhandledErrorOccurredMessage:function(){return $label("DynamicsApp_UnhandledErrorOccurredMessage")},RetrievingConfigurationMessage:function(){return $label("DynamicsApp_RetrievingConfigurationMessage")},RetrievingConfigurationFailedMessage:function(){return $label("DynamicsApp_RetrievingConfigurationFailedMessage")},RetrievingConfigurationSucceededMessage:function(){return $label("DynamicsApp_RetrievingConfigurationSucceededMessage")},ConfigRetrievalErrorMessage:function(){return $label("DynamicsApp_ConfigRetrievalErrorMessage")},LanguageInitializationlErrorMessageFormat:function(n,t){var i=$label("DynamicsApp_LanguageInitializationlErrorMessageFormat");return resources._format(i,n,t)}},_setLanguageFileUrlFormat:"{0}/{1}",_setLanguageCultureFileUrlFormat:"{0}/{1}",_setLanguageDefaultLanguage:"EN-US",_resourceFileMap:{"OfficeAppResources.resjson":{CS:"OfficeAppResources.cs.resjson",DA:"OfficeAppResources.da.resjson","DE-AT":"OfficeAppResources.de-AT.resjson","DE-CH":"OfficeAppResources.de-CH.resjson",DE:"OfficeAppResources.de.resjson","EN-AU":"OfficeAppResources.en-AU.resjson","EN-CA":"OfficeAppResources.en-CA.resjson","EN-GB":"OfficeAppResources.en-GB.resjson","EN-IE":"OfficeAppResources.en-IE.resjson","EN-IN":"OfficeAppResources.en-IN.resjson","EN-MY":"OfficeAppResources.en-MY.resjson","EN-NZ":"OfficeAppResources.en-NZ.resjson","EN-SG":"OfficeAppResources.en-SG.resjson","EN-ZA":"OfficeAppResources.en-ZA.resjson","ES-MX":"OfficeAppResources.es-MX.resjson",ES:"OfficeAppResources.es.resjson",ET:"OfficeAppResources.et.resjson",FI:"OfficeAppResources.fi.resjson","FR-BE":"OfficeAppResources.fr-BE.resjson","FR-CA":"OfficeAppResources.fr-CA.resjson","FR-CH":"OfficeAppResources.fr-CH.resjson",FR:"OfficeAppResources.fr.resjson",HU:"OfficeAppResources.hu.resjson",IS:"OfficeAppResources.is.resjson","IT-CH":"OfficeAppResources.it-CH.resjson",IT:"OfficeAppResources.it.resjson",JA:"OfficeAppResources.ja.resjson",LT:"OfficeAppResources.lt.resjson",LV:"OfficeAppResources.lv.resjson","NB-NO":"OfficeAppResources.nb-NO.resjson","NL-BE":"OfficeAppResources.nl-BE.resjson",NL:"OfficeAppResources.nl.resjson",PL:"OfficeAppResources.pl.resjson","PT-BR":"OfficeAppResources.pt-BR.resjson",RU:"OfficeAppResources.RU.resjson",SV:"OfficeAppResources.sv.resjson",TH:"OfficeAppResources.th.resjson",TR:"OfficeAppResources.tr.resjson","ZH-HANS":"OfficeAppResources.zh-Hans.resjson"},"DynamicsAppResources.resjson":{CS:"DynamicsAppResources.cs.resjson",DA:"DynamicsAppResources.da.resjson","DE-AT":"DynamicsAppResources.de-AT.resjson","DE-CH":"DynamicsAppResources.de-CH.resjson",DE:"DynamicsAppResources.de.resjson","EN-AU":"DynamicsAppResources.en-AU.resjson","EN-CA":"DynamicsAppResources.en-CA.resjson","EN-GB":"DynamicsAppResources.en-GB.resjson","EN-IE":"DynamicsAppResources.en-IE.resjson","EN-IN":"DynamicsAppResources.en-IN.resjson","EN-MY":"DynamicsAppResources.en-MY.resjson","EN-NZ":"DynamicsAppResources.en-NZ.resjson","EN-SG":"DynamicsAppResources.en-SG.resjson","EN-ZA":"DynamicsAppResources.en-ZA.resjson","ES-MX":"DynamicsAppResources.es-MX.resjson",ES:"DynamicsAppResources.es.resjson",ET:"DynamicsAppResources.et.resjson",FI:"DynamicsAppResources.fi.resjson","FR-BE":"DynamicsAppResources.fr-BE.resjson","FR-CA":"DynamicsAppResources.fr-CA.resjson","FR-CH":"DynamicsAppResources.fr-CH.resjson",FR:"DynamicsAppResources.fr.resjson",HU:"DynamicsAppResources.hu.resjson",IS:"DynamicsAppResources.is.resjson","IT-CH":"DynamicsAppResources.it-CH.resjson",IT:"DynamicsAppResources.it.resjson",JA:"DynamicsAppResources.ja.resjson",LT:"DynamicsAppResources.lt.resjson",LV:"DynamicsAppResources.lv.resjson","NB-NO":"DynamicsAppResources.nb-NO.resjson","NL-BE":"DynamicsAppResources.nl-BE.resjson",NL:"DynamicsAppResources.nl.resjson",PL:"DynamicsAppResources.pl.resjson","PT-BR":"DynamicsAppResources.pt-BR.resjson",RU:"DynamicsAppResources.RU.resjson",SV:"DynamicsAppResources.sv.resjson",TH:"DynamicsAppResources.th.resjson",TR:"DynamicsAppResources.tr.resjson","ZH-HANS":"DynamicsAppResources.zh-Hans.resjson"}},_globalizeCultureFileMap:{"AF-ZA":"globalize.culture.af-ZA.js",AF:"globalize.culture.af.js","AM-ET":"globalize.culture.am-ET.js",AM:"globalize.culture.am.js","AR-AE":"globalize.culture.ar-AE.js","AR-BH":"globalize.culture.ar-BH.js","AR-DZ":"globalize.culture.ar-DZ.js","AR-EG":"globalize.culture.ar-EG.js","AR-IQ":"globalize.culture.ar-IQ.js","AR-JO":"globalize.culture.ar-JO.js","AR-KW":"globalize.culture.ar-KW.js","AR-LB":"globalize.culture.ar-LB.js","AR-LY":"globalize.culture.ar-LY.js","AR-MA":"globalize.culture.ar-MA.js","AR-OM":"globalize.culture.ar-OM.js","AR-QA":"globalize.culture.ar-QA.js","AR-SA":"globalize.culture.ar-SA.js","AR-SY":"globalize.culture.ar-SY.js","AR-TN":"globalize.culture.ar-TN.js","AR-YE":"globalize.culture.ar-YE.js",AR:"globalize.culture.ar.js","ARN-CL":"globalize.culture.arn-CL.js",ARN:"globalize.culture.arn.js","AS-IN":"globalize.culture.as-IN.js",AS:"globalize.culture.as.js","AZ-CYRL-AZ":"globalize.culture.az-Cyrl-AZ.js","AZ-CYRL":"globalize.culture.az-Cyrl.js","AZ-LATN-AZ":"globalize.culture.az-Latn-AZ.js","AZ-LATN":"globalize.culture.az-Latn.js",AZ:"globalize.culture.az.js","BA-RU":"globalize.culture.ba-RU.js",BA:"globalize.culture.ba.js","BE-BY":"globalize.culture.be-BY.js",BE:"globalize.culture.be.js","BG-BG":"globalize.culture.bg-BG.js",BG:"globalize.culture.bg.js","BN-BD":"globalize.culture.bn-BD.js","BN-IN":"globalize.culture.bn-IN.js",BN:"globalize.culture.bn.js","BO-CN":"globalize.culture.bo-CN.js",BO:"globalize.culture.bo.js","BR-FR":"globalize.culture.br-FR.js",BR:"globalize.culture.br.js","BS-CYRL-BA":"globalize.culture.bs-Cyrl-BA.js","BS-CYRL":"globalize.culture.bs-Cyrl.js","BS-LATN-BA":"globalize.culture.bs-Latn-BA.js","BS-LATN":"globalize.culture.bs-Latn.js",BS:"globalize.culture.bs.js","CA-ES":"globalize.culture.ca-ES.js",CA:"globalize.culture.ca.js","CO-FR":"globalize.culture.co-FR.js",CO:"globalize.culture.co.js","CS-CZ":"globalize.culture.cs-CZ.js",CS:"globalize.culture.cs.js","CY-GB":"globalize.culture.cy-GB.js",CY:"globalize.culture.cy.js","DA-DK":"globalize.culture.da-DK.js",DA:"globalize.culture.da.js","DE-AT":"globalize.culture.de-AT.js","DE-CH":"globalize.culture.de-CH.js","DE-DE":"globalize.culture.de-DE.js","DE-LI":"globalize.culture.de-LI.js","DE-LU":"globalize.culture.de-LU.js",DE:"globalize.culture.de.js","DSB-DE":"globalize.culture.dsb-DE.js",DSB:"globalize.culture.dsb.js","DV-MV":"globalize.culture.dv-MV.js",DV:"globalize.culture.dv.js","EL-GR":"globalize.culture.el-GR.js",EL:"globalize.culture.el.js","EN-029":"globalize.culture.en-029.js","EN-AU":"globalize.culture.en-AU.js","EN-BZ":"globalize.culture.en-BZ.js","EN-CA":"globalize.culture.en-CA.js","EN-GB":"globalize.culture.en-GB.js","EN-IE":"globalize.culture.en-IE.js","EN-IN":"globalize.culture.en-IN.js","EN-JM":"globalize.culture.en-JM.js","EN-MY":"globalize.culture.en-MY.js","EN-NZ":"globalize.culture.en-NZ.js","EN-PH":"globalize.culture.en-PH.js","EN-SG":"globalize.culture.en-SG.js","EN-TT":"globalize.culture.en-TT.js","EN-US":"globalize.culture.en-US.js","EN-ZA":"globalize.culture.en-ZA.js","EN-ZW":"globalize.culture.en-ZW.js","ES-AR":"globalize.culture.es-AR.js","ES-BO":"globalize.culture.es-BO.js","ES-CL":"globalize.culture.es-CL.js","ES-CO":"globalize.culture.es-CO.js","ES-CR":"globalize.culture.es-CR.js","ES-DO":"globalize.culture.es-DO.js","ES-EC":"globalize.culture.es-EC.js","ES-ES":"globalize.culture.es-ES.js","ES-GT":"globalize.culture.es-GT.js","ES-HN":"globalize.culture.es-HN.js","ES-MX":"globalize.culture.es-MX.js","ES-NI":"globalize.culture.es-NI.js","ES-PA":"globalize.culture.es-PA.js","ES-PE":"globalize.culture.es-PE.js","ES-PR":"globalize.culture.es-PR.js","ES-PY":"globalize.culture.es-PY.js","ES-SV":"globalize.culture.es-SV.js","ES-US":"globalize.culture.es-US.js","ES-UY":"globalize.culture.es-UY.js","ES-VE":"globalize.culture.es-VE.js",ES:"globalize.culture.es.js","ET-EE":"globalize.culture.et-EE.js",ET:"globalize.culture.et.js","EU-ES":"globalize.culture.eu-ES.js",EU:"globalize.culture.eu.js","FA-IR":"globalize.culture.fa-IR.js",FA:"globalize.culture.fa.js","FI-FI":"globalize.culture.fi-FI.js",FI:"globalize.culture.fi.js","FIL-PH":"globalize.culture.fil-PH.js",FIL:"globalize.culture.fil.js","FO-FO":"globalize.culture.fo-FO.js",FO:"globalize.culture.fo.js","FR-BE":"globalize.culture.fr-BE.js","FR-CA":"globalize.culture.fr-CA.js","FR-CH":"globalize.culture.fr-CH.js","FR-FR":"globalize.culture.fr-FR.js","FR-LU":"globalize.culture.fr-LU.js","FR-MC":"globalize.culture.fr-MC.js",FR:"globalize.culture.fr.js","FY-NL":"globalize.culture.fy-NL.js",FY:"globalize.culture.fy.js","GA-IE":"globalize.culture.ga-IE.js",GA:"globalize.culture.ga.js","GD-GB":"globalize.culture.gd-GB.js",GD:"globalize.culture.gd.js","GL-ES":"globalize.culture.gl-ES.js",GL:"globalize.culture.gl.js","GSW-FR":"globalize.culture.gsw-FR.js",GSW:"globalize.culture.gsw.js","GU-IN":"globalize.culture.gu-IN.js",GU:"globalize.culture.gu.js","HA-LATN-NG":"globalize.culture.ha-Latn-NG.js","HA-LATN":"globalize.culture.ha-Latn.js",HA:"globalize.culture.ha.js","HE-IL":"globalize.culture.he-IL.js",HE:"globalize.culture.he.js","HI-IN":"globalize.culture.hi-IN.js",HI:"globalize.culture.hi.js","HR-BA":"globalize.culture.hr-BA.js","HR-HR":"globalize.culture.hr-HR.js",HR:"globalize.culture.hr.js","HSB-DE":"globalize.culture.hsb-DE.js",HSB:"globalize.culture.hsb.js","HU-HU":"globalize.culture.hu-HU.js",HU:"globalize.culture.hu.js","HY-AM":"globalize.culture.hy-AM.js",HY:"globalize.culture.hy.js","ID-ID":"globalize.culture.id-ID.js",ID:"globalize.culture.id.js","IG-NG":"globalize.culture.ig-NG.js",IG:"globalize.culture.ig.js","II-CN":"globalize.culture.ii-CN.js",II:"globalize.culture.ii.js","IS-IS":"globalize.culture.is-IS.js",IS:"globalize.culture.is.js","IT-CH":"globalize.culture.it-CH.js","IT-IT":"globalize.culture.it-IT.js",IT:"globalize.culture.it.js","IU-CANS-CA":"globalize.culture.iu-Cans-CA.js","IU-CANS":"globalize.culture.iu-Cans.js","IU-LATN-CA":"globalize.culture.iu-Latn-CA.js","IU-LATN":"globalize.culture.iu-Latn.js",IU:"globalize.culture.iu.js","JA-JP":"globalize.culture.ja-JP.js",JA:"globalize.culture.ja.js","KA-GE":"globalize.culture.ka-GE.js",KA:"globalize.culture.ka.js","KK-KZ":"globalize.culture.kk-KZ.js",KK:"globalize.culture.kk.js","KL-GL":"globalize.culture.kl-GL.js",KL:"globalize.culture.kl.js","KM-KH":"globalize.culture.km-KH.js",KM:"globalize.culture.km.js","KN-IN":"globalize.culture.kn-IN.js",KN:"globalize.culture.kn.js","KO-KR":"globalize.culture.ko-KR.js",KO:"globalize.culture.ko.js","KOK-IN":"globalize.culture.kok-IN.js",KOK:"globalize.culture.kok.js","KY-KG":"globalize.culture.ky-KG.js",KY:"globalize.culture.ky.js","LB-LU":"globalize.culture.lb-LU.js",LB:"globalize.culture.lb.js","LO-LA":"globalize.culture.lo-LA.js",LO:"globalize.culture.lo.js","LT-LT":"globalize.culture.lt-LT.js",LT:"globalize.culture.lt.js","LV-LV":"globalize.culture.lv-LV.js",LV:"globalize.culture.lv.js","MI-NZ":"globalize.culture.mi-NZ.js",MI:"globalize.culture.mi.js","MK-MK":"globalize.culture.mk-MK.js",MK:"globalize.culture.mk.js","ML-IN":"globalize.culture.ml-IN.js",ML:"globalize.culture.ml.js","MN-CYRL":"globalize.culture.mn-Cyrl.js","MN-MN":"globalize.culture.mn-MN.js","MN-MONG-CN":"globalize.culture.mn-Mong-CN.js","MN-MONG":"globalize.culture.mn-Mong.js",MN:"globalize.culture.mn.js","MOH-CA":"globalize.culture.moh-CA.js",MOH:"globalize.culture.moh.js","MR-IN":"globalize.culture.mr-IN.js",MR:"globalize.culture.mr.js","MS-BN":"globalize.culture.ms-BN.js","MS-MY":"globalize.culture.ms-MY.js",MS:"globalize.culture.ms.js","MT-MT":"globalize.culture.mt-MT.js",MT:"globalize.culture.mt.js","NB-NO":"globalize.culture.nb-NO.js",NB:"globalize.culture.nb.js","NE-NP":"globalize.culture.ne-NP.js",NE:"globalize.culture.ne.js","NL-BE":"globalize.culture.nl-BE.js","NL-NL":"globalize.culture.nl-NL.js",NL:"globalize.culture.nl.js","NN-NO":"globalize.culture.nn-NO.js",NN:"globalize.culture.nn.js",NO:"globalize.culture.no.js","NSO-ZA":"globalize.culture.nso-ZA.js",NSO:"globalize.culture.nso.js","OC-FR":"globalize.culture.oc-FR.js",OC:"globalize.culture.oc.js","OR-IN":"globalize.culture.or-IN.js",OR:"globalize.culture.or.js","PA-IN":"globalize.culture.pa-IN.js",PA:"globalize.culture.pa.js","PL-PL":"globalize.culture.pl-PL.js",PL:"globalize.culture.pl.js","PRS-AF":"globalize.culture.prs-AF.js",PRS:"globalize.culture.prs.js","PS-AF":"globalize.culture.ps-AF.js",PS:"globalize.culture.ps.js","PT-BR":"globalize.culture.pt-BR.js","PT-PT":"globalize.culture.pt-PT.js",PT:"globalize.culture.pt.js","QUT-GT":"globalize.culture.qut-GT.js",QUT:"globalize.culture.qut.js","QUZ-BO":"globalize.culture.quz-BO.js","QUZ-EC":"globalize.culture.quz-EC.js","QUZ-PE":"globalize.culture.quz-PE.js",QUZ:"globalize.culture.quz.js","RM-CH":"globalize.culture.rm-CH.js",RM:"globalize.culture.rm.js","RO-RO":"globalize.culture.ro-RO.js",RO:"globalize.culture.ro.js","RU-RU":"globalize.culture.ru-RU.js",RU:"globalize.culture.ru.js","RW-RW":"globalize.culture.rw-RW.js",RW:"globalize.culture.rw.js","SA-IN":"globalize.culture.sa-IN.js",SA:"globalize.culture.sa.js","SAH-RU":"globalize.culture.sah-RU.js",SAH:"globalize.culture.sah.js","SE-FI":"globalize.culture.se-FI.js","SE-NO":"globalize.culture.se-NO.js","SE-SE":"globalize.culture.se-SE.js",SE:"globalize.culture.se.js","SI-LK":"globalize.culture.si-LK.js",SI:"globalize.culture.si.js","SK-SK":"globalize.culture.sk-SK.js",SK:"globalize.culture.sk.js","SL-SI":"globalize.culture.sl-SI.js",SL:"globalize.culture.sl.js","SMA-NO":"globalize.culture.sma-NO.js","SMA-SE":"globalize.culture.sma-SE.js",SMA:"globalize.culture.sma.js","SMJ-NO":"globalize.culture.smj-NO.js","SMJ-SE":"globalize.culture.smj-SE.js",SMJ:"globalize.culture.smj.js","SMN-FI":"globalize.culture.smn-FI.js",SMN:"globalize.culture.smn.js","SMS-FI":"globalize.culture.sms-FI.js",SMS:"globalize.culture.sms.js","SQ-AL":"globalize.culture.sq-AL.js",SQ:"globalize.culture.sq.js","SR-CYRL-BA":"globalize.culture.sr-Cyrl-BA.js","SR-CYRL-CS":"globalize.culture.sr-Cyrl-CS.js","SR-CYRL-ME":"globalize.culture.sr-Cyrl-ME.js","SR-CYRL-RS":"globalize.culture.sr-Cyrl-RS.js","SR-CYRL":"globalize.culture.sr-Cyrl.js","SR-LATN-BA":"globalize.culture.sr-Latn-BA.js","SR-LATN-CS":"globalize.culture.sr-Latn-CS.js","SR-LATN-ME":"globalize.culture.sr-Latn-ME.js","SR-LATN-RS":"globalize.culture.sr-Latn-RS.js","SR-LATN":"globalize.culture.sr-Latn.js",SR:"globalize.culture.sr.js","SV-FI":"globalize.culture.sv-FI.js","SV-SE":"globalize.culture.sv-SE.js",SV:"globalize.culture.sv.js","SW-KE":"globalize.culture.sw-KE.js",SW:"globalize.culture.sw.js","SYR-SY":"globalize.culture.syr-SY.js",SYR:"globalize.culture.syr.js","TA-IN":"globalize.culture.ta-IN.js",TA:"globalize.culture.ta.js","TE-IN":"globalize.culture.te-IN.js",TE:"globalize.culture.te.js","TG-CYRL-TJ":"globalize.culture.tg-Cyrl-TJ.js","TG-CYRL":"globalize.culture.tg-Cyrl.js",TG:"globalize.culture.tg.js","TH-TH":"globalize.culture.th-TH.js",TH:"globalize.culture.th.js","TK-TM":"globalize.culture.tk-TM.js",TK:"globalize.culture.tk.js","TN-ZA":"globalize.culture.tn-ZA.js",TN:"globalize.culture.tn.js","TR-TR":"globalize.culture.tr-TR.js",TR:"globalize.culture.tr.js","TT-RU":"globalize.culture.tt-RU.js",TT:"globalize.culture.tt.js","TZM-LATN-DZ":"globalize.culture.tzm-Latn-DZ.js","TZM-LATN":"globalize.culture.tzm-Latn.js",TZM:"globalize.culture.tzm.js","UG-CN":"globalize.culture.ug-CN.js",UG:"globalize.culture.ug.js","UK-UA":"globalize.culture.uk-UA.js",UK:"globalize.culture.uk.js","UR-PK":"globalize.culture.ur-PK.js",UR:"globalize.culture.ur.js","UZ-CYRL-UZ":"globalize.culture.uz-Cyrl-UZ.js","UZ-CYRL":"globalize.culture.uz-Cyrl.js","UZ-LATN-UZ":"globalize.culture.uz-Latn-UZ.js","UZ-LATN":"globalize.culture.uz-Latn.js",UZ:"globalize.culture.uz.js","VI-VN":"globalize.culture.vi-VN.js",VI:"globalize.culture.vi.js","WO-SN":"globalize.culture.wo-SN.js",WO:"globalize.culture.wo.js","XH-ZA":"globalize.culture.xh-ZA.js",XH:"globalize.culture.xh.js","YO-NG":"globalize.culture.yo-NG.js",YO:"globalize.culture.yo.js","ZH-CHS":"globalize.culture.zh-CHS.js","ZH-CHT":"globalize.culture.zh-CHT.js","ZH-CN":"globalize.culture.zh-CN.js","ZH-HANS":"globalize.culture.zh-Hans.js","ZH-HANT":"globalize.culture.zh-Hant.js","ZH-HK":"globalize.culture.zh-HK.js","ZH-MO":"globalize.culture.zh-MO.js","ZH-SG":"globalize.culture.zh-SG.js","ZH-TW":"globalize.culture.zh-TW.js",ZH:"globalize.culture.zh.js","ZU-ZA":"globalize.culture.zu-ZA.js",ZU:"globalize.culture.zu.js"},setLanguage:function(n,t,i,r){function e(t){$.getScript($format(u._setLanguageCultureFileUrlFormat,i,u._globalizeCultureFileMap[n])).done(function(){var i,u;for(i in Globalize.cultures)if(i.toUpperCase()===n){Globalize.cultures[i].cultureName=i;Globalize.addCultureInfo(n,Globalize.cultures[i]);break}for(u=0;u<t.length;u++)Globalize.addCultureInfo(n,{messages:t[u]});Globalize.culture(n);r(n)}).fail(function(){r()})}var u=this,f=["OfficeAppResources.resjson","DynamicsAppResources.resjson",];n||(n=u._setLanguageDefaultLanguage);n=n.toUpperCase();n!==u._setLanguageDefaultLanguage?u._loadFiles(t,f,function(i){function s(t){var f=[];t!==undefined?f=i!==undefined?i.concat(t):t:i!==undefined?(n=u._setLanguageDefaultLanguage,f=i):n=undefined;n!==undefined?e(f):r()}for(var h=!1,o=0;o<f.length;o++)if(f[o]=u._resourceFileMap[f[o]][n],f[o]===undefined){h=!0;break}h?s():u._loadFiles(t,f,s)}):u._loadFiles(t,f,function(n){n!==undefined?e(n):r()})},_loadFiles:function(n,t,i){function f(n){r!==undefined&&n!==undefined?r.push(n):r=undefined;++o===t.length&&i(r)}function s(n){f(n)}function h(){f()}for(var e=this,r=[],o=0,u=0;u<t.length;u++)$.ajax({url:$format(e._setLanguageFileUrlFormat,n,t[u]),type:"GET",dataType:"json",success:s,error:h})}};
/*!
// <copyright file="Messaging.js" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
*/
messaging=function(){var n={};return n.MessageTypes={resourceReadyRequest:"ResourceReadyRequest",checkAuthenticationRequest:"CheckAuthenticationRequest",checkAuthenticationResponse:"CheckAuthenticationResponse",crossDomainCheckAuthenticationRequest:"CrossDomainCheckAuthenticationRequest",crossDomainCheckAuthenticationResponse:"CrossDomainCheckAuthenticationResponse",getConfigRequest:"GetConfigRequest",getConfigResponse:"GetConfigResponse",getDataRequest:"GetDataRequest",getDataResponse:"GetDataResponse",getCountRequest:"GetCountRequest",getCountResponse:"GetCountResponse",getMetadataRequest:"GetMetadataRequest",getMetadataResponse:"GetMetadataResponse",getLabelsRequest:"GetLabelsRequest",getLabelsResponse:"GetLabelsResponse",getCustomLookupRequest:"GetCustomLookupRequest",getCustomLookupResponse:"GetCustomLookupResponse",getDisplayValueRequest:"GetDisplayValueRequest",getDisplayValueResponse:"GetDisplayValueResponse",getEntitiesRequest:"GetEntitiesRequest",getEntitiesResponse:"GetEntitiesResponse",publishDataRequest:"PublishDataRequest",publishDataResponse:"PublishDataResponse",getUpdatedDataRequest:"GetUpdatedDataRequest",getUpdatedDataResponse:"GetUpdatedDataResponse",unknownMessageTypeResponse:"UnknownMessageTypeResponse"},n.ResponseStatus={success:"Success",failure:"Failure"},n.BaseRequest=function(){this.Type=""},n.Requests={ResourceReadyRequest:function(t){n.BaseRequest.apply(this);this.Type=n.MessageTypes.resourceReadyRequest;this.ResourceID=t},CheckAuthenticationRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.checkAuthenticationRequest;this.ForceRefresh=!1},CrossDomainCheckAuthenticationRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.crossDomainCheckAuthenticationRequest},GetConfigRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.getConfigRequest},GetDataRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.getDataRequest;this.EntityName="";this.EntitySetName="";this.FieldSelectList=undefined;this.FilterExpression=undefined;this.ExpandRelations=undefined;this.MaxResults=undefined;this.RelationName=undefined;this.Key=undefined;this.Headers={}},GetCountRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.getCountRequest;this.EntityNameName="";this.EntitySetName="";this.FilterExpression=undefined;this.RelationName=undefined;this.Key=undefined;this.Headers={}},GetEntitiesRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.getEntitiesRequest;this.Headers={}},GetMetadataRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.getMetadataRequest;this.Entities={};this.Headers={}},GetLabelsRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.getLabelsRequest;this.LabelIDs=[];this.Language=undefined;this.Headers={}},GetCustomLookupRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.getCustomLookupRequest;this.CustomLookupMethod="";this.EntityCollectionName="";this.Headers={};this.Fields=[]},GetDisplayValueRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.getDisplayValueRequest;this.EntityName="";this.FieldName="";this.AttributeNames=[];this.AttributeValues=[];this.TypeFieldValue=undefined;this.DimensionEntityCollectionName="";this.Headers={}},PublishDataRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.publishDataRequest;this.EntitySetName="";this.DataChanges=undefined;this.DataChangeSuccessesPlaceholder=undefined;this.DataChangeFailuresPlaceholder=undefined;this.Headers={};this.PublishSequentially=!1},GetUpdatedDataRequest:function(){n.BaseRequest.apply(this);this.Type=n.MessageTypes.getUpdatedDataRequest;this.EntitySetName="";this.ExpandRelations=[];this.DataChangeSuccesses=undefined;this.DataChangeFailures=undefined;this.UpdateCreates=!1;this.Headers={}}},n.BaseResponse=function(){this.Type="";this.Status="";this.FailureReason="";this.Request=undefined},n.Responses={CheckAuthenticationResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.checkAuthenticationResponse;this.Ready=!1;this.Authenticated=!1;this.OriginSet={}},CrossDomainCheckAuthenticationResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.crossDomainCheckAuthenticationResponse},GetConfigResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getConfigResponse;this.Config={}},GetDataResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getDataResponse;this.EntityName="";this.Partial=!1;this.Data=[]},GetCountResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getCountResponse;this.EntityName="";this.Count=0},GetEntitiesResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getEntitiesResponse;this.Entities={}},GetMetadataResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getMetadataResponse;this.Entities={};this.Enums={}},GetLabelsResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getLabelsResponse;this.LabelResults=[]},GetCustomLookupResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getCustomLookupResponse;this.CustomLookupValues=""},GetDisplayValueResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getDisplayValueResponse;this.DisplayValue=""},PublishDataProgressResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.publishDataResponse;this.PublishedRowCount=0;this.Partial=!0},PublishDataResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.publishDataResponse;this.DataChangeSuccesses=undefined;this.DataChangeFailures=undefined;this.SuccessCount=-1;this.FailureCount=-1;this.ErrorMessages=[]},GetUpdatedDataProgressResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getUpdatedDataResponse;this.UpdatedRowCount=0;this.Partial=!0},GetUpdatedDataResponse:function(){n.BaseResponse.apply(this);this.Type=n.MessageTypes.getUpdatedDataResponse;this.DataChangeSuccesses=undefined;this.DataChangeFailures=undefined;this.ErrorMessages=[]},UnknownMessageTypeResponse:function(t){n.BaseResponse.apply(this);this.Type=n.MessageTypes.unknownMessageTypeResponse;this.Status=n.ResponseStatus.failure;this.FailureReason=resources.Error.UnknownMessageType(t)}},n.LabelResult=function(n){this.ID=n;this.Value=undefined;this.FailureReason=undefined},n.RequestResponseMap={},n.RequestResponseMap[n.MessageTypes.checkAuthenticationRequest]=n.Responses.CheckAuthenticationResponse,n.RequestResponseMap[n.MessageTypes.crossDomainCheckAuthenticationRequest]=n.Responses.CrossDomainCheckAuthenticationResponse,n.RequestResponseMap[n.MessageTypes.getConfigRequest]=n.Responses.GetConfigResponse,n.RequestResponseMap[n.MessageTypes.getDataRequest]=n.Responses.GetDataResponse,n.RequestResponseMap[n.MessageTypes.getMetadataRequest]=n.Responses.GetMetadataResponse,n.RequestResponseMap[n.MessageTypes.getLabelsRequest]=n.Responses.GetLabelsResponse,n.RequestResponseMap[n.MessageTypes.getCustomLookupRequest]=n.Responses.GetCustomLookupResponse,n.RequestResponseMap[n.MessageTypes.publishDataRequest]=n.Responses.PublishDataResponse,n.RequestResponseMap[n.MessageTypes.getUpdatedDataRequest]=n.Responses.GetUpdatedDataResponse,n.indicateResourceIsReady=function(){var t=n.indicateResourceIsReady._ResourceIdQueryStringExpression.exec(window.location.href);t&&t.length===2&&window.parent.postMessage(new n.Requests.ResourceReadyRequest(t[1]),"*")},n.indicateResourceIsReady._ResourceIdQueryStringExpression=/^[^\?]+\?ResourceID=([^&]+)/,n.CustomLookupFieldDetails=function(n,t){this.FieldName=n;this.SerializedValue=t},n.MessageHandler=function(t){var i=this;this._messageHandlers=new util.Map;t===undefined&&(t=!1);this.messageListener=function(r){var u=i._messageHandlers.get(r.data.Type),f;u?u(r):t===!0&&(f=new n.Responses.UnknownMessageTypeResponse(r.data.Type),r.source.postMessage(f,r.origin))};this.addHandler=function(n,t){i._messageHandlers.add(n,t)};this.removeHandler=function(n){i._messageHandlers.remove(n)}},n.ErrorHandler=function(t){var i=this;this.handleError=function(i){var u=n.RequestResponseMap[t.data.Type],r;u===undefined?(r=new n.BaseResponse,r.Type=n.MessageTypes.unknownMessageTypeResponse):r=new u;r.Status=n.ResponseStatus.failure;r.FailureReason=i.message!==undefined?i.message:i;t.source.postMessage(r,t.origin)};this.handleAjaxError=function(n,t,r){i.handleError(r)}},n}();
/*!
// <copyright file="AppletMessaging.js" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
*/
!Office;appletMessaging=function(){var n={Requests:{},Responses:{},MessageTypes:{},MessagingDetails:{AppletID:undefined,AppWindow:{Source:undefined,Origin:undefined,sendMessage:function(t,i){n.MessagingDetails.MessageHandler.sendMessage(this.Source,this.Origin,t,i)}},MessageHandler:undefined},ResponseStatus:{success:0,failure:1},WellKnownResources:{Data:"Microsoft.Dynamics.Platform.Integration.Office.DataResource"}};return n.Requests.Request=function(t,i){i===undefined&&(i={});i.IncludeDataInResponse===undefined&&(i.IncludeDataInResponse=!0);i.AppletID===undefined&&(i.AppletID=n.MessagingDetails.AppletID);this.Type=t;this.AppletID=i.AppletID;this.Data=undefined;this.IncludeDataInResponse=i.IncludeDataInResponse;this.MessageID=n.createUniqueMessageID(i.AppletID,t);this.ExpectedResponseType=i.ExpectedResponseType},n.Responses.Response=function(n){this.Request=n;n.IncludeDataInResponse||(this.Request.Data=undefined);this.Status=undefined;this.FailureMessage=undefined;this.Data=undefined},n.MessageTypes.AppletReady="AppletReady",n.Requests.AppletReadyRequest=function(t){n.Requests.Request.apply(this,[n.MessageTypes.AppletReady,{AppletID:t}])},n.MessageTypes.AppletConfiguration="AppletConfiguration",n.Requests.AppletConfigurationRequest=function(t,i){i===undefined&&(i={});n.Requests.Request.apply(this,[n.MessageTypes.AppletConfiguration,{AppletID:t,ExpectedResponseType:n.Responses.AppletConfigurationResponse}]);this.Data={AppVersion:i.AppVersion,ApplicationType:i.ApplicationType,Settings:i.Settings,Language:i.Language}},n.Responses.AppletConfigurationResponse=function(t,i){i===undefined&&(i={});n.Responses.Response.apply(this,[t]);this.Data={OptionsGroups:i.OptionsGroups}},n.MessageTypes.AppletAction="AppletAction",n.Requests.AppletActionRequest=function(t,i){n.Requests.Request.apply(this,[n.MessageTypes.AppletAction,{AppletID:t}]);this.Data={ActionName:i}},n.MessageTypes.OptionsChanged="OptionsChanged",n.Requests.AppletOptionsChangedRequest=function(t,i){n.Requests.Request.apply(this,[n.MessageTypes.OptionsChanged,{AppletID:t,ExpectedResponseType:n.Responses.AppletOptionsChangedResponse}]);this.Data={OptionsGroups:i}},n.Responses.AppletOptionsChangedResponse=function(t,i){n.Responses.Response.apply(this,[t]);this.Data={Settings:i}},n.MessageTypes.SaveSettings="SaveSettings",n.Requests.SaveSettingsRequest=function(t,i){i===undefined&&(i={});i.ExpectedResponseType=n.Responses.SaveSettingsResponse;n.Requests.Request.apply(this,[n.MessageTypes.SaveSettings,i]);this.Data={Settings:t}},n.Responses.SaveSettingsResponse=function(t){n.Responses.Response.apply(this,[t])},n.MessageTypes.DocumentEventSubscription="DocumentEventSubscription",n.Requests.DocumentEventSubscriptionRequest=function(t){t===undefined&&(t={});t.ExpectedResponseType=n.Responses.DocumentEventSubscriptionResponse;n.Requests.Request.apply(this,[n.MessageTypes.DocumentEventSubscription,t]);this.Data={DocumentEventSubscriptions:[]}},n.Responses.DocumentEventSubscriptionResponse=function(t){n.Responses.Response.apply(this,[t]);this.Data={Results:[]}},n.MessageTypes.BindingEventSubscription="BindingEventSubscription",n.Requests.BindingEventSubscriptionRequest=function(t,i){i===undefined&&(i={});i.ExpectedResponseType=n.Responses.BindingEventSubscriptionResponse;n.Requests.Request.apply(this,[n.MessageTypes.BindingEventSubscription,i]);this.Data={BindingID:t,BindingEventSubscriptions:[]}},n.Responses.BindingEventSubscriptionResponse=function(t){n.Responses.Response.apply(this,[t]);this.Data={Results:[]}},n.MessageTypes.OfficeEvent="OfficeEvent",n.Requests.OfficeEventRequest=function(t,i,r){n.Requests.Request.apply(this,[n.MessageTypes.OfficeEvent,{AppletID:t}]);this.Data={EventSource:i,EventArgs:r}},n.Requests.OfficeEventRequest.EventSource={Document:0,Binding:1},n.MessageTypes.BindingMethod="BindingMethod",n.Requests.BindingMethodRequest=function(t,i){i===undefined&&(i={});i.ExpectedResponseType=n.Responses.BindingMethodResponse;n.Requests.Request.apply(this,[n.MessageTypes.BindingMethod,i]);this.Data={BindingID:t,Methods:[]}},n.Responses.BindingMethodResponse=function(t){n.Responses.Response.apply(this,[t]);this.Data={Results:[]}},n.MessageTypes.DocumentMethod="DocumentMethod",n.Requests.DocumentMethodRequest=function(t,i){i===undefined&&(i={});i.ExpectedResponseType=n.Responses.DocumentMethodResponse;n.Requests.Request.apply(this,[n.MessageTypes.DocumentMethod,i]);this.Data={Method:t}},n.Responses.DocumentMethodResponse=function(t){n.Responses.Response.apply(this,[t]);this.Data={Result:undefined}},n.MessageTypes.BindingsMethod="BindingsMethod",n.Requests.BindingsMethodRequest=function(t,i){i===undefined&&(i={});i.ExpectedResponseType=n.Responses.BindingsMethodResponse;n.Requests.Request.apply(this,[n.MessageTypes.BindingsMethod,i]);this.Data={Method:t}},n.Responses.BindingsMethodResponse=function(t){n.Responses.Response.apply(this,[t]);this.Data={Result:undefined}},n.MessageTypes.OfficeAction="OfficeAction",n.Requests.OfficeActionRequest=function(t,i){i===undefined&&(i={});i.ExpectedResponseType=n.Responses.OfficeActionResponse;n.Requests.Request.apply(this,[n.MessageTypes.OfficeAction,i]);this.Data={Actions:t}},n.Responses.OfficeActionResponse=function(t){n.Responses.Response.apply(this,[t]);this.Data={Values:{},Results:[]}},n.MessageTypes.AddNotification="AddNotification",n.Requests.AddNotificationRequest=function(t,i){n.Requests.Request.apply(this,[n.MessageTypes.AddNotification,i]);this.Data={Notification:t}},n.MessageTypes.PromptUser="PromptUser",n.Requests.PromptUserRequest=function(t,i){i===undefined&&(i={});i.ExpectedResponseType=n.Responses.PromptUserResponse;n.Requests.Request.apply(this,[n.MessageTypes.PromptUser,i]);this.Data={Message:t,Details:i.Details}},n.Responses.PromptUserResponse=function(t,i){n.Responses.Response.apply(this,[t]);this.Data={UserResponse:i}},n.MessageTypes.LogEvent="LogEvent",n.Requests.LogEventRequest=function(t,i){i===undefined&&(i={});n.Requests.Request.apply(this,[n.MessageTypes.LogEvent,i]);this.Data={Event:t,MessageType:i.MessageType,TelemetryType:i.TelemetryType,TelemetryDetails:i.TelemetryDetails}},n.MessageTypes.BeginOperation="BeginOperation",n.Requests.BeginOperationRequest=function(t,i,r){n.Requests.Request.apply(this,[n.MessageTypes.BeginOperation,r]);this.Data={OperationID:t,Message:i}},n.MessageTypes.UpdateOperation="UpdateOperation",n.Requests.UpdateOperationRequest=function(t,i,r){n.Requests.Request.apply(this,[n.MessageTypes.UpdateOperation,r]);this.Data={OperationID:t,Message:i}},n.MessageTypes.EndOperation="EndOperation",n.Requests.EndOperationRequest=function(t,i,r){r===undefined&&(r={});r.IncludeTimeStamp===undefined&&(r.IncludeTimeStamp=!0);n.Requests.Request.apply(this,[n.MessageTypes.EndOperation,r]);this.Data={OperationID:t,Message:i,IncludeTimeStamp:r.IncludeTimeStamp}},n.MessageTypes.Resource="Resource",n.Requests.ResourceRequest=function(t,i){i===undefined&&(i={});i.ExpectedResponseType=n.Responses.ResourceResponse;n.Requests.Request.apply(this,[n.MessageTypes.Resource,i]);this.Data={ResourceID:t,ResourceRequest:i.ResourceRequest}},n.Responses.ResourceResponse=function(t,i){i===undefined&&(i={});n.Responses.Response.apply(this,[t]);this.Data={ResourceResponse:i.ResourceResponse}},n.MessageTypes.InterApplet="InterApplet",n.Requests.InterAppletRequest=function(t,i,r){r===undefined&&(r={});r.ExpectedResponseType=n.Responses.InterAppletResponse;n.Requests.Request.apply(this,[n.MessageTypes.InterApplet,r]);this.Data={DestinationAppletID:t,AppletRequest:i}},n.Responses.InterAppletResponse=function(t,i){n.Responses.Response.apply(this,[t]);this.Data={AppletResponse:i}},n.MessageTypes.DependentAppletUnloaded="DependentAppletUnloaded",n.Requests.DependentAppletUnloadedRequest=function(t,i){n.Requests.Request.apply(this,[n.MessageTypes.DependentAppletUnloaded,i]);this.Data={DependentAppletID:t}},n.OfficeAction=function(t,i){i===undefined&&(i={});this.Path=t;this.Scope=i.Scope||n.OfficeActionScope.Context;this.VariableName=i.VariableName;this.ReturnResult=i.ReturnResult;this.Sync=i.Sync;"AssignmentValue"in i&&(this.AssignmentValue=i.AssignmentValue)},n.OfficeReference=function(n,t,i){i===undefined&&(i={});this.Name=n;this.Type=t;this.Arguments=i.Arguments;this.ExecuteAsLoop=i.ExecuteAsLoop},n.OfficeActionScope={Context:0,Local:1,Office:2,AsyncResult:3},n.OfficeReferenceType={Property:0,Function:1},n.OfficeMethodInformation=function(n,t){t===undefined&&(t={});this.MethodName=n;this.Arguments=t.Arguments;this.Options=t.Options;this.IsRequired=t.IsRequired===undefined?!0:t.IsRequired},n.OfficeMethodInformation.MethodNames={Document:{SetSelectedData:"setSelectedDataAsync",GetSelectedData:"getSelectedDataAsync",GoToByID:"goToByIdAsync"},Bindings:{AddFromSelection:"addFromSelectionAsync",AddFromNamedItem:"addFromNamedItemAsync",ReleaseBinding:"releaseByIdAsync"},Binding:{GetData:"getDataAsync",SetData:"setDataAsync",TableBinding:{AddRows:"addRowsAsync",DeleteAllData:"deleteAllDataValuesAsync",SetFormats:"setFormatsAsync",ClearFormats:"clearFormatsAsync",AddColumns:"addColumnsAsync"}}},n.OfficeTableData=function(){this.headers=undefined;this.rows=undefined},n.OptionsGroup=function(n){this.Label=n;this.Options=[]},n.OptionInformation=function(n,t,i){this.Type=n;this.Label=t;this.Value=i},n.OptionInformation.Types={String:0,Boolean:1,Action:2},n.NotificationType={notification:"notification",error:"error"},n.Notification=function(n,t,i){i===undefined&&(i={});this.Type=n;this.Message=t;this.Details=i.Details;this.IncludeTimeStamp=i.IncludeTimeStamp===undefined?!0:i.IncludeTimeStamp;this.LinkOptions=i.LinkOptions;this.DisplayToUser=i.DisplayToUser},n.createUniqueMessageID=function(t,i){return $format(n.createUniqueMessageID._messageIdFormat,t,i,++n.createUniqueMessageID._lastMessageNumber)},n.createUniqueMessageID._messageIdFormat="msg-{0}-{1}-{2}",n.createUniqueMessageID._lastMessageNumber=0,n.createCloneableDeepCopy=function(t,i,r){r===undefined&&(r={});switch(typeof t){case n.createCloneableDeepCopy.PropertyTypes.function:i();break;case n.createCloneableDeepCopy.PropertyTypes.object:if((r.HandledObjectsArray===undefined||r.ObjectCopiesArray===undefined)&&(r.HandledObjectsArray=[],r.ObjectCopiesArray=[]),$.isArray(t))new n.createCloneableDeepCopy._AsyncArrayCopier(t,i,r).copy();else if(t===null||t instanceof Date||t instanceof RegExp||Office!==undefined&&Office.TableData!==undefined&&t instanceof Office.TableData)i(t);else{var u=r.HandledObjectsArray.indexOf(t);u===-1?new n.createCloneableDeepCopy._AsyncObjectCopier(t,i,r).copy():i(r.ObjectCopiesArray[u])}break;default:i(t)}},n.createCloneableDeepCopy.PropertyTypes={"function":"function",object:"object"},n.createCloneableDeepCopy._AsyncArrayCopier=function(t,i,r){var u=this;this._arrayCopy=[];this._arrayLength=t.length;this.copy=function(){u._copyArrayItem(0)};this._copyArrayItem=function(f){if(f>=u._arrayLength){i(u._arrayCopy);return}n.createCloneableDeepCopy(t[f],function(t){function i(){u._copyArrayItem(f+1)}u._arrayCopy.push(t);f>0&&f%n.createCloneableDeepCopy._AsyncArrayCopier._BatchSize?window.setTimeout(i,10):i()},{HandledObjectsArray:r.HandledObjectsArray,ObjectCopiesArray:r.ObjectCopiesArray})}},n.createCloneableDeepCopy._AsyncArrayCopier._BatchSize=128,n.createCloneableDeepCopy._AsyncObjectCopier=function(t,i,r){var u=this;this._objectCopy={};this._propertyNames=Object.keys(t);this._propertyNamesLength=this._propertyNames.length;this.copy=function(){u._copyNextMember(0)};this._copyNextMember=function(f){if(f>=u._propertyNamesLength){i(u._objectCopy);return}var e=u._propertyNames[f];r.HandledObjectsArray.push(t);r.ObjectCopiesArray.push(u._objectCopy);n.createCloneableDeepCopy(t[e],function(n){u._objectCopy[e]=n;u._copyNextMember(f+1)},{HandledObjectsArray:r.HandledObjectsArray,ObjectCopiesArray:r.ObjectCopiesArray})}},n.MessageHandler=function(t){var i=this;this._messageVerificationCallback=t===undefined?function(){return!0}:t;this._messageHandlers=new util.Map;this._responseCallbacks=new util.Map;this._pendingRequests=new util.Map;this.listen=function(n){var r,t,u,f,e;i._messageVerificationCallback(n)&&(n.data!==undefined&&(n.data.Request!==undefined&&(r=n.data.Request.Type,t=n.data.Request.MessageID,u=n.data.Partial===!0,u||n.data.Data===undefined||n.data.Data.ResourceResponse===undefined||(u=n.data.Data.ResourceResponse.Partial===!0)),t===undefined&&r===undefined&&(r=n.data.Type)),t!==undefined&&(f=i._responseCallbacks.get(t),i._pendingRequests.containsKey(t)&&!u&&(window.clearTimeout(i._pendingRequests.get(t)),i._pendingRequests.remove(t))),$.isFunction(f)?(f(n.data),u||i._responseCallbacks.remove(t)):(r!==undefined&&(e=i._messageHandlers.get(r)),$.isFunction(e)&&e(n)))};this.sendMessage=function(t,r,u,f){var e,o;f===undefined&&(f={});u.ExpectedResponseType!==undefined&&(e=u.ExpectedResponseType,delete u.ExpectedResponseType,o=f.ResponseTimeout===undefined?n.MessageHandler._DefaultResponseTimeout:f.ResponseTimeout,o!==0&&i._pendingRequests.add(u.MessageID,window.setTimeout(function(){if(i._pendingRequests.containsKey(u.MessageID)){i._pendingRequests.remove(u.MessageID);var t=new e(u);t.Status=n.ResponseStatus.failure;t.FailureMessage=resources.AppletMessaging.RequestTimedOutMessage();n.createCloneableDeepCopy(t,function(n){i._sendMessageToWindow(n)})}},o)));t.postMessage(u,r);u.ExpectedResponseType=e};this._sendMessageToWindow=function(t){try{window.postMessage(t,window.location.origin)}catch(i){n.createCloneableDeepCopy(t,function(n){window.postMessage(n,window.location.origin)})}};this.registerMessageHandler=function(n,t){i._messageHandlers.add(n,t)};this.unregisterMessageHandler=function(n){i._messageHandlers.remove(n)};this.isMessageTypeHandled=function(n){return i._messageHandlers.get(n)!==undefined};this.registerResponseCallback=function(n,t){i._responseCallbacks.add(n,t)};this.unRegisterResponseCallback=function(n){i._responseCallbacks.remove(n)};this.isMessageResponseHandled=function(n){return i._responseCallbacks.get(n)!==undefined}},n.MessageHandler._DefaultResponseTimeout=2e4,n}();
/*!
// <copyright file="Authentication.js" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
*/
authentication=function(){var n={OperationID:"Authentication"};return n._cookieEvents={_cookieSignInEvent:"cookie-sign-in-event",_cookieSignOutEvent:"cookie-sign-out-event"},n._oAuthEvents={_oAuthSignInEvent:"oAuth-sign-in-event",_oAuthSignOutEvent:"oAuth-sign-out-event"},n.Authenticator=function(t,i,r,u){var f=this;this._recheckAuthenticationTimeout=250;this._pollingTimeout=250;this._authWindow=undefined;this.handleCheckAuthenticationResponse=function(n,t){n?t.Ready===!1?window.setTimeout(f.checkAuthentication,f._recheckAuthenticationTimeout):t.Authenticated===!1?i():u(t.OriginSet):(app.showError(resources.Authentication.UnableToLoadAuthenticationResourceError()),i())};this.checkAuthentication=function(n){n===undefined&&(n=!1);t();var i=new messaging.Requests.CheckAuthenticationRequest;i.ForceRefresh=n;appletInteraction.sendAppResourceRequest(appletInteraction.WellKnownResources.Auth.ID,i,f.handleCheckAuthenticationResponse)};this.requestSignIn=function(){f._authWindow=window.open($format("{0}{1}?Language={2}",app.State.Settings.HostName,app.RelativePageLocations.SignIn,app.State.Language));app.State.ManualSignInAttempted=!0;app.logEvent(n._cookieEvents._cookieSignInEvent,{MessageType:util.MessageType.Telemetry,TelemetryType:util.TelemetryType.Informational});f._authWindow&&!f._authWindow.closed&&(r(),f._checkAuthWindowClosed())};this._checkAuthWindowClosed=function(){try{f._authWindow.closed?f.checkAuthentication(!0):window.setTimeout(f._checkAuthWindowClosed,f._pollingTimeout)}catch(n){window.setTimeout(f._checkAuthWindowClosed,f._pollingTimeout)}};this.signOut=function(){app._contentDiv.empty();util.changeAttribute(app._contentDiv,app.ContentAttributes.signingOut,!0);app._contentDiv.text(resources.Authentication.SigningOutMessage());app.logEvent(n._cookieEvents._cookieSignOutEvent,{MessageType:util.MessageType.Telemetry,TelemetryType:util.TelemetryType.Informational});var t=$format("{0}/Logout",app.State.Settings.HostName),i=window.open(t),r=window.setInterval(function(){try{i.closed&&(window.clearInterval(r),app.addNewFrame(app._contentDiv,"logout",t,function(){window.location.reload(!0)}))}catch(u){}},f._pollingTimeout)}},n.OAuthAuthenticator=function(t,i,r,u){var f=this,e=window.location.href.replace(window.location.hash,"");if(f._adalConfig={instance:undefined,clientId:undefined,tenant:"common",cacheLocation:"localStorage",redirectUri:e,postLogoutRedirectUri:e},app.State.ServerConfig.AuthRealm)if(app.State.ServerConfig.AuthClientId){if(!app.State.ServerConfig.AuthResourceId){app.showError(resources.Authentication.InvalidServerConfiguration(),{Details:resources.Authentication.NoAuthResourceId()});return}}else{app.showError(resources.Authentication.InvalidServerConfiguration(),{Details:resources.Authentication.NoAuthClientId()});return}else{app.showError(resources.Authentication.InvalidServerConfiguration(),{Details:resources.Authentication.NoAuthRealm()});return}window.parent!==window&&(f._adalConfig.redirectUri=window.location.href.replace(/DynamicsApp\.html.*/,"Authenticated.html"),f._adalConfig.displayCall=function(n){localStorage.adalConfigInstance=f._adalConfig.instance;localStorage.adalConfigClientID=f._adalConfig.clientId;localStorage.authenticatedPageLabel=resources.Message.CloseWindow();window.open(n)});f._adalConfig.instance=app.State.ServerConfig.AuthRealm;f._adalConfig.clientId=app.State.ServerConfig.AuthClientId;f.AuthContext=new AuthenticationContext(f._adalConfig);f.AuthContext.handleWindowCallback();f.AuthContext.getLoginError()&&app.showError(f.AuthContext.getLoginError());f.requestSignIn=function(){app.logEvent(n._oAuthEvents._oAuthSignInEvent,{MessageType:util.MessageType.Telemetry,TelemetryType:util.TelemetryType.Informational});f.AuthContext.login()};f.checkAuthentication=function(){t();f.AuthContext.getCachedUser()?f.AuthContext.acquireToken(app.State.ServerConfig.AuthResourceId,function(n,t){var r,e;n||!t?(i(),app.addErrorNotification(resources.AppletInteraction.AuthenticationError(),n)):(r={},r[app.State.Settings.HostName]=app.State.Settings.HostName,app.State.OAuthContext=f.AuthContext,e=f.AuthContext.getCachedUser(),app.addNotification(resources.Authentication.LoggedInAs(e.userName)),u(r,e.profile.name))}):i()};f.signOut=function(){app.logEvent(n._oAuthEvents._oAuthSignOutEvent,{MessageType:util.MessageType.Telemetry,TelemetryType:util.TelemetryType.Informational});f.AuthContext.logOut()}},n.getAuthenticator=function(t,i,r,u){return app.State.ServerConfig.AuthType==="OAuth"?new n.OAuthAuthenticator(t,i,r,u):new n.Authenticator(t,i,r,u)},n}();
/*!
// <copyright file="DynamicsApp.js" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
*/
app=function(){var n={State:undefined,version:1,runtimeConfigKey:"RuntimeConfig",featuresKey:"Features",resourceDiv:undefined,appletDiv:undefined,appletTitle:undefined,appletSelectionList:undefined,_contentDiv:undefined,_signInLink:undefined,_signOutLink:undefined,_userMenu:undefined,_notificationsHandler:undefined,_operationStatusHandler:undefined,_messageBoxHandler:undefined,_dialogHandler:undefined,_authenticator:undefined,optionsButton:undefined,optionsDialog:{optionsDialogId:"optionsDialog",heading:undefined,dynamicsAppOptions:{heading:undefined,generalOptionsGroup:{container:undefined,heading:undefined,serverLabel:undefined,serverInput:undefined,languageLabel:undefined,languageInput:undefined},appletConfigurationGroup:{heading:undefined,appletConfigurationButton:undefined}},cancelButton:undefined,okButton:undefined,appletOptionsContent:undefined,optionsButtonClicked:function(){n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.serverInput.val(n.State.Settings.HostName);n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.languageInput.val(n.State.Settings.Language);n.updateHeaderOptionsDOM();appletInteraction.updateAllAppletOptionsDOMs();appletInteraction.appletStack!==undefined&&$.each(appletInteraction.appletStack,function(t,i){var r=util.findElementById($format(appletInteraction._IdentifierFormats.AppletOptionsElement,i.AppletID));util.doesElementExist(r)&&r.attr(n.GeneralAttributes.isExpanded,t===0)});n.openDialog(n.optionsDialog.optionsDialogId)},okClicked:function(){n.updateSettings()},closeClicked:function(){n.closeActiveDialog(n.optionsDialog.optionsDialogId)},configureAppletClicked:function(){appletInteraction.appletConfiguration.resetConfigurationDialogValues();n.openDialog(n.appletConfigurationDialog.dialogID)}},appletConfigurationDialog:{dialogID:"appletConfigDialog",heading:undefined,configDialogContainer:{heading:undefined,configContent:undefined},okButton:undefined,cancelButton:undefined,okClicked:function(){appletInteraction.appletConfiguration.applyAppletConfiguration()},closeClicked:function(){n.closeActiveDialog(n.appletConfigurationDialog.dialogID)}},DataHeaderOptionConstants:{DataHeaderOptionsAttribute:"data-header",DataHeaderOptionsSelector:"[data-header]"},noServerText:undefined,noServerLink:undefined,noAppletLink:undefined,OperationIDs:{ConfigurationRetrieval:"retrieving-configuration",RegistrationsRetrieval:"registrations-retrieval"}},t;return n.htmlFrameFormat='<iframe id="{0}" />',n.appsForOfficeNode="/OfficeApps",n.RelativePageLocations={SignIn:n.appsForOfficeNode+"/Authenticated.html"},n.AuthenticationState={uninitialized:"uninitialized",notAuthenticated:"notAuthenticated",waitingUserAuthentication:"waitingUserAuthentication",authenticating:"authenticating",authenticated:"authenticated"},n.ContentAttributes={ieBrowserNotSupported:"data-ie-browser-not-supported",appReady:"data-ready",AuthenticationState:"data-authentication-state",ManualSignInAttempted:"data-manual-signin-attempted",signingOut:"data-signing-out",Initialized:"data-initialized",hasActiveDialog:"data-has-active-dialog",appletsReadyState:"data-applets-ready-state",appletSelectionShown:"data-applet-selection-shown",registrationsRetrieved:"data-registrations-retrieved",appletsLoading:"data-applets-loading"},n.GeneralAttributes={isShown:"data-is-shown",isActive:"data-is-active",isExpanded:"data-is-expanded"},n.ControlIDs={resourceDiv:"resourceDiv",appletDiv:"appletDiv",appletTitle:"appletHeader",appletSelectionList:"appletSelectionList",contentDiv:"content",signInLink:"signInLink",signInDiv:"signInDiv",notificationsDiv:"notifications",appButtonsDiv:"appButtons",footerDiv:"footer",optionsButton:"optionsButton",userButton:"userButton",userMenu:"userMenu",appletOptionsContent:"appletOptionsContent",generalContentDiv:"generalContent",appletConfigurationDialog:{configDialogContainer:"appletConfigDialogContainer",configContent:"appletConfigContent"},noServerSplashScreen:"noServerSplashScreen",noAppletsSplashScreen:"noAppletSplashScreen"},n.CssClasses={dialogHeader:"dialogHeader"},n.AppletsReadyState={None:"none",Single:"single",Multiple:"multiple"},n.handleGlobalError=function(t,i,r,u,f){return n.logEvent("exception-telemetry-event",{MessageType:util.MessageType.Telemetry,TelemetryType:util.TelemetryType.Exception,TelemetryDetails:JSON.stringify({URLLocation:i,Line:r,Column:u,Message:t,Error:f})}),n.showError(resources.DynamicsApp.UnhandledErrorOccurredMessage(),{Details:t}),!0},n.onDocumentReady=function(){n.initialize(function(){n.onInitialized()})},n._isUnsupportedIE=function(){return/MSIE /.test(window.navigator.appVersion)},n.initialize=function(t){n.State=new n.ApplicationState;n.State.Settings=n.loadConfiguration();n.State.Features=n.loadFeatures();var i=n.State.Settings.Language||Office.context.displayLanguage;resources.setLanguage(i,"../Resources","../Scripts/ext/globalize",function(r){function l(t){util.changeAttribute(o,n.ContentAttributes.appletSelectionShown,t)}function f(n){util.changeAttribute(u,f._UserMenuShownAttribute,s=n)}function a(){l(!1);f(!1)}function y(){n._contentDiv.attr(n.ContentAttributes.appReady,!0);n.updateUIFromState();n.State.IsInitialized=!0;i=i.toUpperCase();r!=i&&n.addErrorNotification(resources.DynamicsApp.LanguageInitializationlErrorMessageFormat(i,r));t()}var c,u,e,o,s,v,h;if(n.State.Language=r,n._contentDiv=util.findElementById(n.ControlIDs.contentDiv),n._isUnsupportedIE()){n._contentDiv.empty();util.addStyleSheet("ExcelTheme.css",function(){n._contentDiv.text(resources.DynamicsApp.UnsupportedIE());n._contentDiv.attr(n.ContentAttributes.ieBrowserNotSupported,!0)});return}window.onerror=n.handleGlobalError;Office.context.document.bindings.addFromPromptAsync?(n.State.CurrentApplication=util.ApplicationType.Excel,n.State.OfficeVersion="Excel"in window?util.OfficeVersion.Release:util.OfficeVersion.Legacy):Office.context.document.customXmlParts&&(n.State.CurrentApplication=util.ApplicationType.Word,n.State.OfficeVersion="Word"in window?util.OfficeVersion.Release:util.OfficeVersion.Legacy);n.resourceDiv=util.findElementById(n.ControlIDs.resourceDiv,n._contentDiv);n.appletDiv=util.findElementById(n.ControlIDs.appletDiv,n._contentDiv);n.appletTitle=util.findElementById(n.ControlIDs.appletTitle,n._contentDiv);n.appletSelectionList=util.findElementById(n.ControlIDs.appletSelectionList,n._contentDiv);n._signInLink=util.findElementById(n.ControlIDs.signInLink,n._contentDiv);n.optionsDialog.appletOptionsContent=util.findElementById(n.ControlIDs.appletOptionsContent,n._contentDiv);n.optionsButton=util.findElementById(n.ControlIDs.optionsButton);c=util.findElementById(n.ControlIDs.notificationsDiv,n._contentDiv);u=util.findElementById(n.ControlIDs.appButtonsDiv,n._contentDiv);n.noServerText=$($format("#{0} > span",n.ControlIDs.noServerSplashScreen));n.noServerLink=$($format("#{0} > a",n.ControlIDs.noServerSplashScreen));n.noAppletLink=$($format("#{0} > a",n.ControlIDs.noAppletsSplashScreen));e=util.findElementById(n.ControlIDs.userButton,u);n._userMenu=util.findElementById(n.ControlIDs.userMenu,u);n._signOutLink=$("a",n._userMenu);util.changeAttribute(n.optionsButton,"title",resources.DynamicsApp.OptionsButtonTooltip());$("#manualSignInAttemptedText").text(resources.Authentication.ManualSignInAttempted());n._signOutLink.text(resources.Authentication.SignOutLabel());o=n.appletTitle.parent();s=!1;f._UserMenuShownAttribute="data-user-menu-shown";n._userMenu.click(function(n){n.stopPropagation()});util.changeAttribute(e,"title",resources.DynamicsApp.UserButtonTooltip());e.click(function(n){f(!s);n.stopPropagation()});n._signOutLink.click(function(){n.saveSettings(function(){n.saveSettings=function(){};f(!1);appletInteraction.unloadAllApplets();appletInteraction.unloadAllResources();n._authenticator.signOut()})});n.appletTitle.click(function(t){var i=o.attr(n.ContentAttributes.appletSelectionShown)==="true";l(!i&&appletInteraction.getAppletsReadyState()===n.AppletsReadyState.Multiple);t.stopPropagation()});$(document).click(a);$(window).blur(a);n.noServerLink.click(function(){n.optionsDialog.optionsButtonClicked()});n.noAppletLink.click(function(){n.optionsDialog.optionsButtonClicked();n.optionsDialog.configureAppletClicked()});v=util.findElementById(n.ControlIDs.footerDiv).height();util.findElementById(n.ControlIDs.generalContentDiv).css("bottom",v+"px");n.initializeOptionsDialog();n.initializeAppletConfigDialog();n._signInLink.text(resources.DynamicsApp.SignInButtonLabel());n.noServerText.text(resources.DynamicsApp.NoServerMessage());n.noServerLink.text(resources.DynamicsApp.NoServerLinkLabel());n.noAppletLink.text(resources.DynamicsApp.NoAppletLinkLabel());n._notificationsHandler=new n._NotificationsHandler(u);n._notificationsHandler.initialize();n._operationStatusHandler=new n._OperationStatusHandler(c);n._operationStatusHandler.initialize();n._messageBoxHandler=new n._MessageBoxHandler(n._contentDiv);n._messageBoxHandler.initialize();n._dialogHandler=new n._DialogHandler;n._dialogHandler.initialize();n.State.ActivityID=util.generateGuid();n.State.CurrentApplication!==undefined?(h=n.State.CurrentApplication===util.ApplicationType.Word?"Word":"Excel",util.addStyleSheet($format("{0}Theme.css",h),function(){util.addStyleSheet($format("{0}DynamicsApp.css",h),y)})):y()})},n.initializeOptionsDialog=function(){n.optionsDialog.heading=$("#optionsDialog .dialogHeader");n.optionsDialog.cancelButton=$("#optionsCancelButton");n.optionsDialog.okButton=$("#optionsOkButton");n.optionsDialog.dynamicsAppOptions.heading=$("#appOptionsHeader");n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.container=$("#appGeneralOptionsContainer");n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.heading=$("#appGeneralOptionsGroupHeader");n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.serverLabel=$("#serverLabel");n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.serverInput=$("#serverInput");n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.languageLabel=$("#languageLabel");n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.languageInput=$("#languageInput");n.optionsDialog.dynamicsAppOptions.appletConfigurationGroup.heading=$("#appAppletOptionsGroupHeader");n.optionsDialog.dynamicsAppOptions.appletConfigurationGroup.appletConfigurationButton=$("#appletConfigurationButton");n.optionsDialog.heading.text(resources.DynamicsApp.OptionsDialogTitle());n.optionsDialog.cancelButton.text(resources.DynamicsApp.OptionsCancelButtonText());n.optionsDialog.okButton.text(resources.DynamicsApp.OptionsOkButtonText());n.optionsDialog.dynamicsAppOptions.heading.text(resources.DynamicsApp.DynamicsAppOptionsTitle());n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.heading.text(resources.DynamicsApp.DynamicsAppGeneralOptionsTitle());n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.serverLabel.text(resources.DynamicsApp.OptionsDialogServerText());n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.languageLabel.text(resources.DynamicsApp.OptionsDialogLanguageText());n.optionsDialog.dynamicsAppOptions.appletConfigurationGroup.heading.text(resources.DynamicsApp.DynamicsAppAppletConfigTitle());n.optionsDialog.dynamicsAppOptions.appletConfigurationGroup.appletConfigurationButton.text(resources.DynamicsApp.OptionsAppletConfigButtonLabel());n.optionsButton.click(n.optionsDialog.optionsButtonClicked);n.optionsDialog.cancelButton.click(n.optionsDialog.closeClicked);n.optionsDialog.okButton.click(n.optionsDialog.okClicked);n.optionsDialog.dynamicsAppOptions.heading.click(n.toggleOptionSection);n.optionsDialog.dynamicsAppOptions.appletConfigurationGroup.appletConfigurationButton.click(n.optionsDialog.configureAppletClicked)},n.initializeAppletConfigDialog=function(){n.appletConfigurationDialog.heading=$($format("#{0} > h1",n.appletConfigurationDialog.dialogID));n.appletConfigurationDialog.configDialogContainer.heading=$("#appletConfigDialogContainer > h2");n.appletConfigurationDialog.configDialogContainer.configContent=$("#appletConfigContent");n.appletConfigurationDialog.okButton=$("#appletConfigOkButton");n.appletConfigurationDialog.cancelButton=$("#appletConfigCancelButton");n.appletConfigurationDialog.heading.text(resources.DynamicsApp.AppletConfigDialogTitle());n.appletConfigurationDialog.configDialogContainer.heading.text(resources.DynamicsApp.AppletConfigGroupTitle());n.appletConfigurationDialog.okButton.text(resources.DynamicsApp.AppletConfigOkButtonLabel());n.appletConfigurationDialog.cancelButton.text(resources.DynamicsApp.AppletConfigCancelButtonLabel());n.appletConfigurationDialog.okButton.click(n.appletConfigurationDialog.okClicked);n.appletConfigurationDialog.cancelButton.click(n.appletConfigurationDialog.closeClicked)},n.loadConfiguration=function(){var t=Office.context.document.settings.get(n.runtimeConfigKey),i;return(t===undefined||t===null)&&(Office.context.document.settings.set(n.runtimeConfigKey,{}),t=Office.context.document.settings.get(n.runtimeConfigKey)),t.HostName===undefined?t.HostName="":(i=t.HostName.length-1,t.HostName.substr(i)==="/"&&(t.HostName=t.HostName.substr(0,i))),t.Applets===undefined&&(t.Applets={}),t.ActiveAppletId===undefined&&(t.ActiveAppletId=""),t.Language===undefined&&(t.Language=""),t},n.loadFeatures=function(){var t=Office.context.document.settings.get(n.featuresKey);return(t===undefined||t===null)&&(Office.context.document.settings.set(n.featuresKey,{}),t=Office.context.document.settings.get(n.featuresKey)),t.LogDomEvents===undefined&&(t.LogDomEvents=!1),t.LogTelemetry===undefined&&(t.LogTelemetry=!0),t},n.onInitialized=function(){n.State.CurrentApplication===undefined?(n.updateUIFromState(),n.showError(resources.DynamicsApp.UnrecognizedApplicationError())):(appletInteraction.initialize(),n.State.Settings.HostName!==""&&n.startAuthentication())},n.startAuthentication=function(t){var i=new n.startAuthentication._CallbackHandler(t);i._executeAuthentication()},n.startAuthentication._CallbackHandler=function(){var t=this;this._executeAuthentication=function(){n.State.AuthenticationState=n.AuthenticationState.authenticating;n.updateUIFromState();t._executeConfiguration()};this._executeConfiguration=function(){n.beginOperation(n.OperationIDs.ConfigurationRetrieval,resources.DynamicsApp.RetrievingConfigurationMessage());var t=new messaging.Requests.GetConfigRequest;appletInteraction.sendAppResourceRequest(appletInteraction.WellKnownResources.Config.ID,t,function(t,i){var r,u;if(t)if(i.Status===messaging.ResponseStatus.success){n.State.ServerConfig=i.Config;n.State.Settings.Headers===undefined&&(n.State.Settings.Headers={});n.State.ServerConfig.Headers===undefined&&(n.State.ServerConfig.Headers={});for(r in n.State.Settings.Headers)u=n.State.ServerConfig.Headers[r],u!==undefined&&(u.Value=n.State.Settings.Headers[r]);for(r in n.State.ServerConfig.Headers)n.State.Settings.Headers[r]=n.State.ServerConfig.Headers[r].Value;n.saveSettings(function(){n.authenticate(n.authenticationComplete);n.endOperation(n.OperationIDs.ConfigurationRetrieval,resources.DynamicsApp.RetrievingConfigurationSucceededMessage())})}else n.showError(resources.DynamicsApp.ConfigRetrievalErrorMessage(),{Details:i.FailureReason}),n.endOperation(n.OperationIDs.ConfigurationRetrieval,resources.DynamicsApp.RetrievingConfigurationFailedMessage());else n.showError(resources.DynamicsApp.ConfigRetrievalErrorMessage()),n.endOperation(n.OperationIDs.ConfigurationRetrieval,resources.DynamicsApp.RetrievingConfigurationFailedMessage())})}},n.authenticationComplete=function(t){t&&(n.beginOperation(n.OperationIDs.RegistrationsRetrieval,resources.DynamicsApp.RegistrationsRetrievalMessage()),n.generateHeaderOptionsDOM(),appletInteraction.retrieveRegistrations(n.registrationsRetrieved))},n.registrationsRetrieved=function(t){n.State.RegistrationsRetrieved=t;t?n.loadApplets():n.showError(resources.DynamicsApp.RegistrationRetrievalError());n.endOperation(n.OperationIDs.RegistrationsRetrieval,t?resources.DynamicsApp.RegistrationsRetrievalSucceededMessage():resources.DynamicsApp.RegistrationsRetrievalFailedMessage());n.updateUIFromState()},n.loadApplets=function(){$.each(appletInteraction.registeredApplets,function(t,i){var r=n.State.CurrentApplication&i.SupportedApplications;r&&i.AppletID in n.State.Settings.Applets&&appletInteraction.loadApplet(i.AppletID,i.RelativeUrl,n.State.Settings.Applets[i.AppletID])})},n.generateHeaderOptionsDOM=function(){var t=n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.languageInput,i,r;for(i in n.State.ServerConfig.Headers)r=n.State.ServerConfig.Headers[i],t=$($format(n.generateHeaderOptionsDOM._OptionFormat,r.DisplayName,i)).insertAfter(t),t.find("input").val(r.Value)},n.updateHeaderOptionsDOM=function(){var t=n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.container.find(n.DataHeaderOptionConstants.DataHeaderOptionsSelector);$.each(t,function(t,i){var r=$(i),u=r.find("input"),f=r.attr(n.DataHeaderOptionConstants.DataHeaderOptionsAttribute),e=n.State.ServerConfig.Headers[f];u.val(e.Value)})},n.generateHeaderOptionsDOM._OptionFormat="<div data-header='{1}'><span>{0}<\/span><input class='stringOptionInput' /><\/div>",n.updateUIFromState=function(){var i=n.State.AppletsLoadingCount>0,t;n.changeContentAttribute(n.ContentAttributes.Initialized,n.State.IsInitialized);n.changeContentAttribute(n.ContentAttributes.ManualSignInAttempted,n.State.ManualSignInAttempted);n.changeContentAttribute(n.ContentAttributes.AuthenticationState,n.State.AuthenticationState);switch(n.State.AuthenticationState){case n.AuthenticationState.notAuthenticated:util.enableControl(n._signInLink,!0);break;case n.AuthenticationState.waitingUserAuthentication:case n.AuthenticationState.authenticating:case n.AuthenticationState.authenticated:util.enableControl(n._signInLink,!1)}n.changeContentAttribute(n.ContentAttributes.registrationsRetrieved,n.State.RegistrationsRetrieved);n.changeContentAttribute(n.ContentAttributes.appletsReadyState,n.State.AppletsReadyState);n.changeContentAttribute(n.ContentAttributes.appletsLoading,i);t=n.State.RegistrationsRetrieved&&!i;util.enableControl(n.optionsDialog.dynamicsAppOptions.appletConfigurationGroup.appletConfigurationButton,t);util.enableControl(n.noAppletLink,t)},n.authenticate=function(t){var i=new n.authenticate._CallbackHandler(t);n._authenticator=authentication.getAuthenticator(i.authenticatingCallback,i.notAuthenticatedCallback,i.waitingUserAuthenticationCallback,i.authenticatedCallback);n._signInLink.on("click",n._authenticator.requestSignIn);n._authenticator.checkAuthentication(!0)},n.authenticate._CallbackHandler=function(t){var i=this;this.authenticatingCallback=function(){n.State.AuthenticationState=n.AuthenticationState.authenticating;n.updateUIFromState();n.beginOperation(authentication.OperationID,resources.DynamicsApp.Authentication_Verifying())};this.waitingUserAuthenticationCallback=function(){n.State.AuthenticationState=n.AuthenticationState.waitingUserAuthentication;n.updateUIFromState()};this.authenticatedCallback=function(t,r){n._signInLink.off("click");n.State.ValidOriginSet=t;r!==undefined&&n._userMenu.prepend($format(n.authenticate._CallbackHandler._userNameElementFormat,r));i._authenticationComplete(!0)};this.notAuthenticatedCallback=function(){i._authenticationComplete(!1)};this._authenticationComplete=function(i){n.State.AuthenticationState=i?n.AuthenticationState.authenticated:n.AuthenticationState.notAuthenticated;n.updateUIFromState();n.endOperation(authentication.OperationID,i?resources.DynamicsApp.Authentication_Authenticated():resources.DynamicsApp.Authentication_NotAuthenticated());t(i)}},n.authenticate._CallbackHandler._userNameElementFormat="<span>{0}<\/span><br /><hr />",n.updateSettings=function(){function f(n){n?appletInteraction.updateAllAppletsOptions(t,e):r(!1)}function e(){jQuery.extend(!0,n.State.Settings,t);n.saveSettings(function(n){n.status===Office.AsyncResultStatus.Succeeded?r(!0):r(!1)});n.logEvent("options-saved-telemetry-event",{MessageType:util.MessageType.Telemetry,TelemetryType:util.TelemetryType.Informational})}function r(r){var u,f;if(r)if(i)window.location.reload(!0);else{for(u in t.Headers)f=n.State.ServerConfig.Headers[u],f!==undefined&&(f.Value=t.Headers[u]);n.State.Language=t.Language;n.closeActiveDialog(n.optionsDialog.optionsDialogId)}}var t=jQuery.extend(!0,{},n.State.Settings),i=!1,o=n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.container.find(n.DataHeaderOptionConstants.DataHeaderOptionsSelector),u;$.each(o,function(i,r){var u=$(r),f=u.find("input"),e=u.attr(n.DataHeaderOptionConstants.DataHeaderOptionsAttribute);t.Headers[e]=f.val()});t.HostName=n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.serverInput.val();t.Language=n.optionsDialog.dynamicsAppOptions.generalOptionsGroup.languageInput.val();u=!0;t.Language!==n.State.Settings.Language&&(i=!0);t.HostName!==n.State.Settings.HostName&&(i=!0,t.HostName&&t.HostName.search(n.updateSettings.HttpsUrlExpression)===-1&&(n.showError(resources.DynamicsApp.InvalidHostUrlEnteredErrorMessage()),u=!1));u?i?n.showConfirmationDialog(resources.DynamicsApp.OptionsConfirmChangesTitle(),f,resources.DynamicsApp.OptionsConfirmAppReloadMessage()):f(!0):r(!1)},n.updateSettings.HttpsUrlExpression=/^https:\/\/[^ \"]+$/g,n.saveSettings=function(t){Office.context.document.settings.set(n.runtimeConfigKey,n.State.Settings);Office.context.document.settings.saveAsync(function(i){i.status===Office.AsyncResultStatus.Failed&&n.showError(resources.DynamicsApp.UnableToSaveSettingsError(),resources.DynamicsApp.UnableToSaveSettingsDetail());$.isFunction(t)&&t(i)})},n.addNewFrame=function(t,i,r,u){var e=$format(n.htmlFrameFormat,i),f=$(e).appendTo(t);return f.unbind("load"),f.bind("load",null,function(){$.isFunction(u)&&u()}),util.navigateFrame(f,r),f},n.beginOperation=function(t,i,r){r===undefined&&(r={});r.SourceID!==undefined&&(t=n._qualifyBySourceID(t,r.SourceID));n._operationStatusHandler.beginOperation(t,i,r)},n.updateOperation=function(t,i,r){r===undefined&&(r={});r.SourceID!==undefined&&(t=n._qualifyBySourceID(t,r.SourceID));n._operationStatusHandler.updateOperation(t,i)},n.endOperation=function(t,i,r){r===undefined&&(r={});r.SourceID!==undefined&&(t=n._qualifyBySourceID(t,r.SourceID));var u=n._operationStatusHandler.endOperation(t,i,r);i=resources.DynamicsApp.Notification_DurationFormat(i,u);n._notificationsHandler.addNotification(new n._NotificationsHandler.Notification(n._NotificationsHandler.NotificationType.notification,i),r.IncludeTimeStamp);n.logEvent($format(n.endOperation.OperationCompletedEventFormat,t))},n.cancelOperations=function(t){n._operationStatusHandler.cancelOperations(t)},n.endOperation.OperationCompletedEventFormat="complete-{0}",t=window.appInsights||function(n){function f(n){t[n]=function(){var i=arguments;t.queue.push(function(){t[n].apply(t,i)})}}var t={config:n},r=document,e=window,o="script",s=r.createElement(o),i,u;for(s.src=n.url||"//az416426.vo.msecnd.net/scripts/a/ai.0.js",r.getElementsByTagName(o)[0].parentNode.appendChild(s),t.cookie=r.cookie,t.queue=[],i=["Event","Exception","Metric","PageView","Trace"];i.length;)f("track"+i.pop());return n.disableExceptionTracking||(i="onerror",f("_"+i),u=e[i],e[i]=function(n,r,f,e,o){var s=u&&u(n,r,f,e,o);return s!==!0&&t["_"+i](n,r,f,e,o),s}),t}({instrumentationKey:"a8640c62-56a5-49c5-8d37-adcc48ac1523"}),window.appInsights=t,n.logEvent=function(t,i){i===undefined&&(i={});n.State.Features.LogTelemetry&&i.MessageType===util.MessageType.Telemetry&&window.appInsights.trackEvent(t,{Application:"Microsoft Dynamics Office Web Addin",MessageType:i.MessageType,TelemetryType:i.TelemetryType,TelemetryDetails:i.TelemetryDetails,ODataID:n.State.ActivityID,Host:n.State.Settings.HostName},null);n.State.Features.LogDomEvents&&n.changeContentAttribute($format("data-last-{0}",n._qualifyBySourceID(t,i===undefined?undefined:i.SourceID)),(new Date).getTime().toString())},n._qualifyBySourceID=function(t,i){return i===undefined?t:$format(n._qualifyBySourceID.SourceQualifierFormat,i,t)},n._qualifyBySourceID.SourceQualifierFormat="{0}-{1}",n.showError=function(t,i){i===undefined&&(i={});t===resources.DynamicsApp.UnhandledErrorOccurredMessage()?n.logEvent("exception-telemetry-event",{MessageType:i.MessageType,TelemetryType:util.TelemetryType.ExceptionError,TelemetryDetails:i.Details}):n.logEvent("error-telemetry-event",{MessageType:i.MessageType,TelemetryType:util.TelemetryType.Error,TelemetryDetails:i.Details});n._messageBoxHandler.showError(t,i);n._notificationsHandler.addNotification(new n._NotificationsHandler.Notification(n._NotificationsHandler.NotificationType.error,t,i.Details),i.IncludeTimeStamp)},n.showConfirmationDialog=function(t,i,r){n._messageBoxHandler.showConfirmationDialog(t,i,r)},n.showNotification=function(t,i){i===undefined&&(i={});n._messageBoxHandler.showNotification(t,i);n._notificationsHandler.addNotification(new n._NotificationsHandler.Notification(n._NotificationsHandler.NotificationType.notification,t,i.Details),i.IncludeTimeStamp)},n.addNotification=function(t,i){n._notificationsHandler.addNotification(new n._NotificationsHandler.Notification(n._NotificationsHandler.NotificationType.notification,t),i)},n.addErrorNotification=function(t,i,r){arguments.length===2&&typeof i=="boolean"&&(r=i,i=undefined);n._notificationsHandler.addNotification(new n._NotificationsHandler.Notification(n._NotificationsHandler.NotificationType.error,t,i),r)},n.sendMessage=function(n,t,i,r){if(n!==undefined&&n[0].contentWindow)if(r===!1){var u=t.ExpectedResponseType;delete t.ExpectedResponseType;n[0].contentWindow.postMessage(t,i);t.ExpectedResponseType=u}else appletMessaging.createCloneableDeepCopy(t,function(t){n[0].contentWindow&&n[0].contentWindow.postMessage(t,i)})},n.openDialog=function(t){n._dialogHandler.openDialog(t)},n.closeActiveDialog=function(t){n._dialogHandler.closeActiveDialog(t)},n.changeContentAttribute=function(t,i){util.changeAttribute(n._contentDiv,t,i)},n.handleUnknownMessageTypeResponse=function(){n.showError(resources.DynamicsApp.UnknownMessageError())},n.ApplicationState=function(){this.IsInitialized=!1;this.AuthenticationState=n.AuthenticationState.uninitialized;this.AppletsReadyState=n.AppletsReadyState.None;this.RegistrationsRetrieved=!1;this.AppletsLoadingCount=0;this.Settings=undefined;this.Features=undefined;this.ServerConfig=undefined;this.ValidOriginSet=undefined;this.OAuthContext=undefined;this.Language=undefined;this.ActivityID=undefined;this.ManualSignInAttempted=!1;this.CurrentApplication=undefined;this.OfficeVersion=undefined},n._NotificationsHandler=function(t){var i=this;this._notificationsButton=undefined;this._notifications=[];this._newNotificationCount=0;this._messageCenterHandler=undefined;this.initialize=function(){i._notificationsButton=util.findElementById(n._NotificationsHandler.ControlIDs.button,t);i._notificationsButton.click(i._notificationsButtonClicked);util.changeAttribute(i._notificationsButton,"title",resources.DynamicsApp.NotificationsButtonTooltip());i._messageCenterHandler=new n._MessageCenterHandler;i._messageCenterHandler.initialize()};this.addNotification=function(t,r){i._notifications.push(t);t.NotificationType===n._NotificationsHandler.NotificationType.error&&(i._newNotificationCount++,i._updateNotificationsButtonCount());i._messageCenterHandler.addNotification(t,r)};this._updateNotificationsButtonCount=function(){var n="";i._newNotificationCount>0&&(n=i._newNotificationCount.toString());i._notificationsButton.text(n)};this._notificationsButtonClicked=function(){i._newNotificationCount>0&&(i._messageCenterHandler.showErrorsOnly(),i._newNotificationCount=0,i._updateNotificationsButtonCount());i._messageCenterHandler.openDialog()}},n._NotificationsHandler.ControlIDs={button:"notificationsButton"},n._NotificationsHandler.NotificationType={notification:"notification",error:"error"},n._NotificationsHandler.Notification=function(n,t,i){var r=this;this.NotificationType=n;this.Message=t;this.Details=i;this.getFormattedMessage=function(){return r.Details?resources.DynamicsApp.Notification_WithDetailsMessageFormat(r.Message,r.Details):r.Message}},n._MessageCenterHandler=function(){var t=this;this._showErrorsOnly=!1;this._messageCenterDialog=undefined;this._messagesContainer=undefined;this._errorsOnlyCheckbox=undefined;this._clearButton=undefined;this._doneButton=undefined;this._notificationItemHtmlFormat='<div data-notification-type="{0}"><span>{1} {2}<\/span><p class="dynamicsSymbolItem">{3}<\/p><\/div>';this._notificationItemNoTimeHtmlFormat='<div data-notification-type="{0}"><p class="dynamicsSymbolItem">{1}<\/p><\/div>';this.initialize=function(){var i,r,u;t._messageCenterDialog=util.findElementById(n._MessageCenterHandler.ControlIDs.messageCenterDialog,n._contentDiv);t._messagesContainer=util.findElementById(n._MessageCenterHandler.ControlIDs.messagesContainer,t._messageCenterDialog);t._errorsOnlyCheckbox=util.findElementById(n._MessageCenterHandler.ControlIDs.errorsOnlyCheckbox,t._messageCenterDialog);t._clearButton=util.findElementById(n._MessageCenterHandler.ControlIDs.clearButton,t._messageCenterDialog);t._doneButton=util.findElementById(n._MessageCenterHandler.ControlIDs.doneButton,t._messageCenterDialog);i=util.findElementByClass(n.CssClasses.dialogHeader,t._messageCenterDialog);i.text(resources.DynamicsApp.MessageCenterHeading());r=util.findElementById(n._MessageCenterHandler.ControlIDs.noMessagesText,t._messageCenterDialog);r.text(resources.DynamicsApp.MessageCenterNoMessages());u=util.findElementById(n._MessageCenterHandler.ControlIDs.errorsOnlyLabel,t._messageCenterDialog);u.text(resources.DynamicsApp.MessageCenterErrorsOnlyLabel());t._errorsOnlyCheckbox.change(t._updateShowErrorsOnly);t._clearButton.click(t.clearNotifications);t._clearButton.text(resources.DynamicsApp.MessageCenterClearButtonLabel());t._doneButton.click(t.closeDialog);t._doneButton.text(resources.DynamicsApp.MessageCenterDoneButtonLabel());t.clearNotifications()};this.addNotification=function(i,r){var u;u=r===!1?$format(t._notificationItemNoTimeHtmlFormat,i.NotificationType,i.getFormattedMessage()):$format(t._notificationItemHtmlFormat,i.NotificationType,Globalize.format(new Date,Globalize.culture().calendar.patterns.T),Globalize.format(new Date,Globalize.culture().calendar.patterns.d),i.getFormattedMessage());t._messagesContainer.prepend(u);util.changeAttribute(t._messageCenterDialog,n._MessageCenterHandler.Attributes.hasMessages,!0)};this.clearNotifications=function(){util.changeAttribute(t._messageCenterDialog,n._MessageCenterHandler.Attributes.hasMessages,!1);t._messagesContainer.empty()};this.openDialog=function(){n.logEvent("message-notification-opened-event",{MessageType:util.MessageType.Telemetry,TelemetryType:util.TelemetryType.Informational});n.openDialog(n._MessageCenterHandler.ControlIDs.messageCenterDialog)};this.closeDialog=function(){n.closeActiveDialog(n._MessageCenterHandler.ControlIDs.messageCenterDialog)};this.showErrorsOnly=function(){t._errorsOnlyCheckbox.prop("checked",!0);t._updateShowErrorsOnly()};this._updateShowErrorsOnly=function(){var i=t._errorsOnlyCheckbox.prop("checked");i!==t._showErrorsOnly&&(t._showErrorsOnly=i,util.changeAttribute(t._messagesContainer,n._MessageCenterHandler.Attributes.errorsOnly,t._showErrorsOnly))}},n._MessageCenterHandler.ControlIDs={messageCenterDialog:"messageCenter",messagesContainer:"messagesContainer",noMessagesText:"noMessagesText",errorsOnlyCheckbox:"showErrorsOnlyInput",errorsOnlyLabel:"showErrorsOnlyLabel",clearButton:"messageCenterClearButton",doneButton:"messageCenterDoneButton"},n._MessageCenterHandler.Attributes={hasMessages:"data-has-messages",errorsOnly:"data-errors-only"},n._OperationStatusHandler=function(t){var i=this;this._textElement=undefined;this._operationMap=new util.Map;this._sourceOperationsMap=new util.Map;this.initialize=function(){i._textElement=util.findElementById(n._OperationStatusHandler.ControlIDs.text,t)};this.cancelOperations=function(n){var t=i._sourceOperationsMap.get(n);t!==undefined&&$.each(t.getItems(),function(t,r){i.endOperation(r,"",{SourceID:n})})};this.beginOperation=function(r,u,f){if(f===undefined&&(f={}),f.SourceID!==undefined){var e=i._sourceOperationsMap.get(f.SourceID);e===undefined&&(e=new util.StringSet,i._sourceOperationsMap.add(f.SourceID,e));e.add(r)}i._operationMap.add(r,{Text:u,Time:(new Date).getTime()});i._setText(resources.DynamicsApp.Status_BusyFormattedMessage(u));util.changeAttribute(t,n.GeneralAttributes.isShown,!0);util.changeAttribute(t,n._OperationStatusHandler.Attributes.operationActive,!0)};this.updateOperation=function(n,t){var r=i._operationMap.get(n),u;r!==undefined&&(r.Text=t,u=i._operationMap.getKeys(),u.length>0&&i._operationMap.get(u[0])===r&&i._setText(resources.DynamicsApp.Status_BusyFormattedMessage(t)))};this.endOperation=function(r,u,f){var h,c,e,o,s;return f===undefined&&(f={}),f.SourceID!==undefined&&(h=i._sourceOperationsMap.get(f.SourceID),h!==undefined&&h.remove(r)),e=i._operationMap.get(r),c=e!==undefined&&e.Time!==undefined?(((new Date).getTime()-e.Time)/1e3).toFixed(1):"?",i._operationMap.remove(r),o=i._operationMap.getKeys(),o.length===0?(util.changeAttribute(t,n._OperationStatusHandler.Attributes.operationActive,!1),i._setText(u),util.changeAttribute(t,n.GeneralAttributes.isShown,!1)):(s=i._operationMap.get(o[0]),$.each(o,function(n,t){var r=i._operationMap.get(t);r.Time>s.Time&&(s=r)}),i._setText(resources.DynamicsApp.Status_BusyFormattedMessage(s.Text))),c};this._setText=function(n){i._textElement.text(n);i._textElement.attr("title",n)}},n._OperationStatusHandler.ControlIDs={container:"status",text:"statusText"},n._OperationStatusHandler.Attributes={operationActive:"data-operation-active"},n._MessageBoxHandler=function(){var t=this;this._messageBoxContainer=undefined;this._errorSymbol=undefined;this._warningSymbol=undefined;this._textElement=undefined;this._linkElement=undefined;this._okButton=undefined;this._noButton=undefined;this._currentMessage=undefined;this._messageStack=[];this.initialize=function(){t._messageBoxContainer=util.findElementById(n._MessageBoxHandler.ControlIDs.container,n._contentDiv);t._errorSymbol=util.findElementById(n._MessageBoxHandler.ControlIDs.errorSymbol,t._messageBoxContainer);t._warningSymbol=util.findElementById(n._MessageBoxHandler.ControlIDs.warningSymbol,t._messageBoxContainer);t._textElement=util.findElementById(n._MessageBoxHandler.ControlIDs.messageText,t._messageBoxContainer);t._linkElement=util.findElementById(n._MessageBoxHandler.ControlIDs.link,t._messageBoxContainer);t._okButton=util.findElementById(n._MessageBoxHandler.ControlIDs.okButton,t._messageBoxContainer);t._okButton.click(t._okButtonClicked);t._noButton=util.findElementById(n._MessageBoxHandler.ControlIDs.noButton,t._messageBoxContainer);t._noButton.text(resources.DynamicsApp.NoButtonLabel());t._noButton.click(t._noButtonClicked)};this.showError=function(i,r){r===undefined&&(r={});t._registerNewMessage(new n._MessageBoxHandler.MessageInfo(n._MessageBoxHandler.MessageBoxType.Error,i,r));t._messageBoxContainer.attr(n._MessageBoxHandler.Attributes.messageBoxType,n._MessageBoxHandler.Attributes.messageBoxType_error);t._okButton.text(resources.DynamicsApp.OkButtonLabel());var u;u=r.Details===undefined?i:resources.DynamicsApp.Notification_WithDetailsMessageFormat(i,r.Details);t._textElement.text(u);util.changeAttribute(t._messageBoxContainer,n.GeneralAttributes.isShown,!0);r.LinkOptions!==undefined?(t._messageBoxContainer.attr(n._MessageBoxHandler.Attributes.hasLink,!0),t._linkElement.text(r.LinkOptions.Text),t._linkElement.click(function(){r.LinkOptions.Action();t._okButtonClicked()})):(t._messageBoxContainer.attr(n._MessageBoxHandler.Attributes.hasLink,!1),t._linkElement.text(""),t._linkElement.click(undefined))};this.showConfirmationDialog=function(i,r,u){t._registerNewMessage(new n._MessageBoxHandler.MessageInfo(n._MessageBoxHandler.MessageBoxType.Confirmation,i,{Callback:r,Details:u}));t._messageBoxContainer.attr(n._MessageBoxHandler.Attributes.messageBoxType,n._MessageBoxHandler.Attributes.messageBoxType_confirmation);t._messageBoxContainer.attr(n._MessageBoxHandler.Attributes.hasLink,!1);t._okButton.text(resources.DynamicsApp.YesButtonLabel());var f;f=u===undefined?i:resources.DynamicsApp.Notification_TitleAndMessageFormat(i,u);t._textElement.text(f);util.changeAttribute(t._messageBoxContainer,n.GeneralAttributes.isShown,!0)};this.showNotification=function(i,r){r===undefined&&(r={});t._registerNewMessage(new n._MessageBoxHandler.MessageInfo(n._MessageBoxHandler.MessageBoxType.Notification,i,r));t._messageBoxContainer.attr(n._MessageBoxHandler.Attributes.messageBoxType,n._MessageBoxHandler.Attributes.messageBoxType_notification);t._okButton.text(resources.DynamicsApp.OkButtonLabel());var u;u=r.Details===undefined?i:resources.DynamicsApp.Notification_WithDetailsMessageFormat(i,r.Details);t._textElement.text(u);util.changeAttribute(t._messageBoxContainer,n.GeneralAttributes.isShown,!0);r.LinkOptions!==undefined?(t._messageBoxContainer.attr(n._MessageBoxHandler.Attributes.hasLink,!0),t._linkElement.text(r.LinkOptions.Text),t._linkElement.click(function(){r.LinkOptions.Action();t._okButtonClicked()})):(t._messageBoxContainer.attr(n._MessageBoxHandler.Attributes.hasLink,!1),t._linkElement.text(""),t._linkElement.click(undefined))};this._registerNewMessage=function(n){t._currentMessage!==undefined&&t._messageStack.push(t._currentMessage);t._currentMessage=n};this._okButtonClicked=function(){t._registerClick(!0)};this._noButtonClicked=function(){t._registerClick(!1)};this._registerClick=function(i){if(t._currentMessage!==undefined&&t._currentMessage.Callback!==undefined&&t._currentMessage.Callback(i),t._textElement.text(""),t._messageBoxContainer.attr(n._MessageBoxHandler.Attributes.hasLink,!1),t._linkElement.text(""),t._linkElement.click(undefined),t._currentMessage=undefined,t._messageStack.length>0){var r=t._messageStack.pop();switch(r.Type){case n._MessageBoxHandler.MessageBoxType.Confirmation:t.showConfirmationDialog(r.Message,r.Callback,r.Details);break;case n._MessageBoxHandler.MessageBoxType.Error:t.showError(r.Message,{Details:r.Details,LinkOptions:r.LinkOptions});break;case n._MessageBoxHandler.MessageBoxType.Notification:t.showNotification(r.Message,{Details:r.Details,LinkOptions:r.LinkOptions})}}else util.changeAttribute(t._messageBoxContainer,n.GeneralAttributes.isShown,!1)}},n._MessageBoxHandler.ControlIDs={container:"messageBoxContainer",errorSymbol:"errorSymbol",warningSymbol:"warningSymbol",messageText:"messageBoxText",link:"messageBoxLink",okButton:"messageBoxOkButton",noButton:"messageBoxNoButton"},n._MessageBoxHandler.Attributes={messageBoxType:"data-message-box-type",messageBoxType_error:"error",messageBoxType_confirmation:"confirmation",messageBoxType_notification:"notification",hasLink:"data-has-link"},n._MessageBoxHandler.MessageInfo=function(n,t,i){i===undefined&&(i={});this.Type=n;this.Message=t;this.Details=i.Details;this.LinkOptions=i.LinkOptions;this.Callback=i.Callback},n._MessageBoxHandler.MessageBoxType={Confirmation:"Confirmation",Error:"Error",Notification:"Notification"},n._DialogHandler=function(){var t=this;this._dialogContainer=undefined;this._dialogStack=[];this.initialize=function(){t._dialogContainer=util.findElementById(n._DialogHandler.ControlIDs.dialogContainer,n._contentDiv)};this.openDialog=function(i){var u=util.findElementById(i,t._dialogContainer),f=util.doesElementExist(u),r;return f&&(t._dialogStack.length>0&&(r=util.findElementById(t._dialogStack[t._dialogStack.length-1],t._dialogContainer),util.doesElementExist(r)&&util.changeAttribute(r,n.GeneralAttributes.isActive,!1)),util.changeAttribute(u,n.GeneralAttributes.isActive,!0),util.changeAttribute(n._contentDiv,n.ContentAttributes.hasActiveDialog,!0),t._dialogStack.push(i)),f};this.closeActiveDialog=function(i){var r,u,e,f;return i===undefined&&t._dialogStack.length>0&&(i=t._dialogStack[t._dialogStack.length-1]),r=t._dialogStack.length>0&&t._dialogStack[t._dialogStack.length-1]===i,r&&(u=util.findElementById(i,t._dialogContainer),r=util.doesElementExist(u)),r&&(t._dialogStack.pop(),util.changeAttribute(u,n.GeneralAttributes.isActive,!1),t._dialogStack.length>0?(e=t._dialogStack[t._dialogStack.length-1],f=util.findElementById(e,t._dialogContainer),util.doesElementExist(f)?util.changeAttribute(f,n.GeneralAttributes.isActive,!0):util.changeAttribute(n._contentDiv,n.ContentAttributes.hasActiveDialog,!1)):util.changeAttribute(n._contentDiv,n.ContentAttributes.hasActiveDialog,!1)),r}},n._DialogHandler.ControlIDs={dialogContainer:"dialogContent"},n.toggleOptionSection=function(t){var i=$(t.target).parent(),r=i.attr(n.GeneralAttributes.isExpanded)!=="false";i.attr(n.GeneralAttributes.isExpanded,!r)},n}();
/*!
// <copyright file="AppletInteraction.js" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
*/
appletInteraction={registeredApplets:undefined,pendingAppletReadyCallbacks:undefined,appletMap:undefined,registeredResources:undefined,pendingResourceReadyCallbacks:undefined,resourceMap:undefined,messageHandler:undefined,appletStack:undefined,OperationIDs:{LoadAppletFormat:"loading-applet-{0}"}};appletInteraction.ResourceInformation=function(n,t){this.ID=n;this.Url=t};appletInteraction.WellKnownResources={Data:new appletInteraction.ResourceInformation(appletMessaging.WellKnownResources.Data,app.appsForOfficeNode+"/ODataInteraction.html"),Auth:new appletInteraction.ResourceInformation("authentication-resource",app.appsForOfficeNode+"/Public/CheckAuthentication.html"),Config:new appletInteraction.ResourceInformation("config-resource",app.appsForOfficeNode+"/Public/Config.html")};appletInteraction.InitialRequestMaxRetries=10;appletInteraction.InitialRequestRetryTimeout=2e3;appletInteraction.UpdateAppletOptionsTimeout=5e3;appletInteraction.AppletRegistrationEntityName="OfficeAppAppletRegistration";appletInteraction.AppletRegistrationEntityCollectionName="OfficeAppAppletRegistrations";appletInteraction.ResourceRegistrationEntityName="OfficeAppResourceRegistration";appletInteraction.ResourceRegistrationEntityCollectionName="OfficeAppResourceRegistrations";appletInteraction.RelativeUrlValidationRegex=/^(\/.+)+(\.[a-zA-Z]{2,4})$/g;appletInteraction.LabelIdValidationRegex=/^@.+/;appletInteraction._IdentifierFormats={AppletFrame:"appletFrame_{0}",ResourceFrame:"resourceFrame_{0}",AppletOptionsElement:"appletOptions_{0}",AppletOptionControl:"option_{0}_{1}_{2}",AppletSelectionItemElement:"appletSelectionItem_{0}"};appletInteraction._MarkupFormats={AppletOptionsElement:"<div id='{0}' class='optionSection'><h2 class='optionsHeader'>{1}<\/h2><div class='optionSectionContainer'><\/div><\/div>",AppletOptionsGroupElement:"<div><h3>{0}<\/h3><\/div>",AppletOptionStringControl:"<div><span>{1}<\/span><input id='{0}' class='stringOptionInput' /><\/div>",AppletOptionCheckboxControl:"<div><input type='checkbox' id='{0}' class='inlineControl' /><span class='inlineControl'>{1}<\/span><\/div>",AppletOptionButtonControl:"<button id='{0}'>{1}<\/button>",AppletSelectionItemElement:"<li id='{0}'><span>{1}<\/span><\/li>"};appletInteraction._ControlProperties={Checked:"checked"};appletInteraction._OptionControlType={Input:"input"};appletInteraction.initialize=function(){appletInteraction.pendingAppletReadyCallbacks=new util.Map;appletInteraction.appletMap=new util.Map;appletInteraction.pendingResourceReadyCallbacks=new util.Map;appletInteraction.resourceMap=new util.Map;appletInteraction.appletStack=[];appletInteraction.resetRegistrations();appletInteraction.messageHandler=new appletMessaging.MessageHandler(appletInteraction.verifyMessage);window.addEventListener("message",appletInteraction.messageHandler.listen,!1);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.AppletReady,appletInteraction._handleAppletReadyRequest);appletInteraction.messageHandler.registerMessageHandler(messaging.MessageTypes.resourceReadyRequest,appletInteraction._handleResourceReadyRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.SaveSettings,appletInteraction.handleSaveSettingsRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.AddNotification,appletInteraction.handleAddNotificationRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.PromptUser,appletInteraction.handlePromptUserRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.LogEvent,appletInteraction.handleLogEventRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.BeginOperation,appletInteraction.handleBeginOperationRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.UpdateOperation,appletInteraction.handleUpdateOperationRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.EndOperation,appletInteraction.handleEndOperationRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.Resource,appletInteraction.handleResourceRequest);officeInteraction.initialize()};appletInteraction.verifyMessage=function(n){var u=!1,t,i,r;return n.data!==undefined&&(t=n.data,i=t.AppletID,i===undefined&&t.Request!==undefined&&(i=t.Request.AppletID),i!==undefined?u=appletInteraction.appletMap.containsKey(i)||t.Type==appletMessaging.MessageTypes.AppletReady&&appletInteraction.pendingAppletReadyCallbacks.containsKey(i):(r=t.ResourceID,r===undefined&&t.Request!==undefined&&(r=t.Request.ResourceID),r!==undefined&&(u=appletInteraction.registeredResources.containsKey(r)||r===appletInteraction.sendAppResourceRequest.AppID))),u};appletInteraction.resetRegistrations=function(){var t,n;appletInteraction.registeredApplets=[];appletInteraction.registeredResources=new util.Map;for(t in appletInteraction.WellKnownResources)n=appletInteraction.WellKnownResources[t],appletInteraction.registeredResources.add(n.ID,$format(appletInteraction.resetRegistrations._ResourceUrlFormat,app.State.Settings.HostName,n.Url,n.ID,app.State.Language))};appletInteraction.resetRegistrations._ResourceUrlFormat="{0}{1}?ResourceID={2}&Language={3}";appletInteraction.retrieveRegistrations=function(n){function e(){u&&f&&(i?appletInteraction.registeredApplets.length===0?(app.addErrorNotification(resources.AppletInteraction.NoAppletRegistrationsFoundMessageFormat()),n(!0)):appletInteraction.appletConfiguration.generateAppletConfigurationDOM(function(){n(!0)}):n(!1))}var u=!1,f=!1,i=!0,r=new messaging.Requests.GetDataRequest,t;r.EntityName=appletInteraction.AppletRegistrationEntityName;r.EntitySetName=appletInteraction.AppletRegistrationEntityCollectionName;appletInteraction.sendAppResourceRequest(appletMessaging.WellKnownResources.Data,r,function(n,t){u=!0;n?(appletInteraction.registeredApplets=[],$.each(t.Data,function(n,t){t.RelativeUrl.search(appletInteraction.RelativeUrlValidationRegex)===-1?app.addErrorNotification(resources.AppletInteraction.InvalidRelativeUrlFormat(t.AppletID,t.RelativeUrl)):app.State.CurrentApplication&t.SupportedApplications&&(t.LocalizedName=t.Name,appletInteraction.registeredApplets.push(t))})):i=!1;e()});t=new messaging.Requests.GetDataRequest;t.EntityName=appletInteraction.ResourceRegistrationEntityName;t.EntitySetName=appletInteraction.ResourceRegistrationEntityCollectionName;appletInteraction.sendAppResourceRequest(appletMessaging.WellKnownResources.Data,t,function(n,t){f=!0;n?$.each(t.Data,function(n,t){t.RelativeUrl.search(appletInteraction.RelativeUrlValidationRegex)===-1?app.addErrorNotification(resources.AppletInteraction.InvalidRelativeUrlFormat(t.ResourceID,t.RelativeUrl)):appletInteraction.registeredResources.get(t.ResourceID)===undefined?appletInteraction.registeredResources.add(t.ResourceID,t.RelativeUrl):t.ResourceID!==appletMessaging.WellKnownResources.Data&&app.addErrorNotification(resources.AppletInteraction.DuplicateResourceFormat(t.ResourceID,t.RelativeUrl))}):i=!1;e()})};appletInteraction.unloadAllApplets=function(){$.each(appletInteraction.appletMap.getKeys(),function(n,t){appletInteraction.unloadApplet(t)})};appletInteraction.unloadApplet=function(n){var u=appletInteraction.appletMap.get(n),t,i,r;u!==undefined&&(t=appletInteraction.appletStack.indexOf(u),t!==-1&&(appletInteraction.appletStack.splice(t,1),appletInteraction.activateApplet(appletInteraction.getActiveAppletInformation())),officeInteraction.unsubscribeAllDocumentEvents(n),officeInteraction.unsubscribeAllBindingEvents(n),appletInteraction._removeAppletFrame(n),appletInteraction.appletMap.remove(n));i=util.findElementById($format(appletInteraction._IdentifierFormats.AppletOptionsElement,n),app.optionsDialog.appletOptionsContent);util.doesElementExist(i)&&i.remove();r=util.findElementById($format(appletInteraction._IdentifierFormats.AppletSelectionItemElement,n));util.doesElementExist(r)&&r.remove();delete app.State.Settings.Applets[n];app.saveSettings();app.cancelOperations(n)};appletInteraction._removeAppletFrame=function(n){var t=appletInteraction.appletMap.get(n);t!==undefined&&t.Frame!==undefined&&(t.Frame.remove(),t.Frame=undefined)};appletInteraction.unloadAllResources=function(){$.each(appletInteraction.resourceMap.getKeys(),function(n,t){appletInteraction.unloadResource(t)})};appletInteraction.unloadResource=function(n){var t=appletInteraction.resourceMap.get(n);t!==undefined&&(t.Frame!==undefined&&t.Frame.remove(),appletInteraction.resourceMap.remove(n))};appletInteraction.AppletInformation=function(n){this.AppletID=n;this.Title=undefined;this.Options=undefined;this.Frame=undefined;this.Origin=undefined};appletInteraction.ResourceInformation=function(n){this.ResourceID=n;this.Frame=undefined;this.Origin=undefined};appletInteraction.loadApplet=function(n,t,i){function f(){app.showError(resources.AppletInteraction.UnableToLoadAppletErrorFormat(n),{Details:resources.AppletInteraction.AppletConfigurationTimedOutErrorFormat(n)});appletInteraction.pendingAppletReadyCallbacks.remove(n);appletInteraction.unloadApplet(n);app.endOperation(u,resources.AppletInteraction.AppletLoadingFailedMessageFormat(r.LocalizedName));app.State.AppletsLoadingCount--;app.updateUIFromState()}var r,u,e,o;$.each(appletInteraction.registeredApplets,function(t,i){if(i.AppletID===n)return r=i,!1});u=$format(appletInteraction.OperationIDs.LoadAppletFormat,n);r!==undefined?(app.beginOperation(u,resources.AppletInteraction.AppletLoadingMessageFormat(r.LocalizedName)),app.State.AppletsLoadingCount++,app.updateUIFromState(),appletInteraction._removeAppletFrame(n),e=app.addNewFrame(app.appletDiv,$format(appletInteraction._IdentifierFormats.AppletFrame,n),$format("{0}{1}?AppletID={2}",app.State.Settings.HostName,t,n)),o=window.setTimeout(function(){appletInteraction.pendingAppletReadyCallbacks.containsKey(n)&&f()},appletInteraction.loadApplet._AppletReadyTimeout),appletInteraction.pendingAppletReadyCallbacks.add(n,function(t){var u;window.clearTimeout(o);u=new appletInteraction.AppletInformation(n);u.Title=r.LocalizedName;u.Frame=e;u.Origin=t;appletInteraction.appletMap.add(n,u);var s=new appletMessaging.Requests.AppletConfigurationRequest(n,{AppVersion:app.version,ApplicationType:app.State.CurrentApplication,Settings:i,Language:app.State.Language}),h=!1,c=window.setTimeout(function(){h||f()},appletInteraction.loadApplet._AppletConfigurationTimeout);appletInteraction.messageHandler.registerResponseCallback(s.MessageID,function(n){window.clearTimeout(c);appletInteraction._handleAppletConfigurationResponse(n)});appletInteraction.sendMessageToApplet(n,s,!1)})):app.addErrorNotification(resources.AppletInteraction.AppletToLoadNotRegisteredMessageFormat(n))};appletInteraction.loadApplet._AppletReadyTimeout=3e4;appletInteraction.loadApplet._AppletConfigurationTimeout=1e4;appletInteraction._handleAppletReadyRequest=function(n){var t=n.data.AppletID,i=appletInteraction.pendingAppletReadyCallbacks.get(t);i!==undefined&&(appletInteraction.pendingAppletReadyCallbacks.remove(t),i(n.origin))};appletInteraction._handleAppletConfigurationResponse=function(n){var t=n.Request.AppletID,i=appletInteraction.appletMap.get(t),u=n.Status===appletMessaging.ResponseStatus.success,r;u?i!==undefined&&(i.Options=n.Data.OptionsGroups,appletInteraction._generateOptionsDOM(i),appletInteraction._generateSelectionDOM(i),appletInteraction._completeAppletConfiguration(t)):(app.showError(resources.AppletInteraction.UnableToLoadAppletErrorFormat(t),{Details:n.FailureMessage}),appletInteraction.unloadApplet(t));r=i===undefined?t:i.Title;app.endOperation($format(appletInteraction.OperationIDs.LoadAppletFormat,t),u?resources.AppletInteraction.AppletLoadingSucceededMessageFormat(r):resources.AppletInteraction.AppletLoadingFailedMessageFormat(r));app.State.AppletsLoadingCount--;app.updateUIFromState()};appletInteraction.updateAllAppletsOptions=function(n,t){function r(){i.getKeys().length===0&&t()}function u(t){if(t){var u=i.get(t.Request.AppletID);window.clearTimeout(u);n.Applets[t.Request.AppletID]=t.Data.Settings;i.remove(t.Request.AppletID)}r()}var i=new util.Map;$.each(appletInteraction.appletMap.getKeys(),function(n,t){if(appletInteraction._updateAppletOptions(t)&&appletInteraction.sendAppletOptionsChangedRequest(t,u)){var f=window.setTimeout(function(){app.addErrorNotification(resources.AppletInteraction.UnableToUpdateAppletOptionsErrorFormat(t));i.remove(t);r()},appletInteraction.UpdateAppletOptionsTimeout);i.add(t,f)}});r()};appletInteraction._updateAppletOptions=function(n){var i=!1,t=appletInteraction.appletMap.get(n),r;return t!==undefined&&(r=util.findElementById($format(appletInteraction._IdentifierFormats.AppletOptionsElement,t.AppletID),app.optionsDialog.appletOptionsContent),r.length===1&&$.each(t.Options,function(n,u){$.each(u.Options,function(u,f){var s=$format(appletInteraction._IdentifierFormats.AppletOptionControl,t.AppletID,n,u),o=util.findElementById(s,r),e;switch(f.Type){case appletMessaging.OptionInformation.Types.String:e=o.val();break;case appletMessaging.OptionInformation.Types.Boolean:e=o.prop(appletInteraction._ControlProperties.Checked);break;case appletMessaging.OptionInformation.Types.Action:e=f.Value}i=i||f.Value!==e;f.Value=e})})),i};appletInteraction._generateSelectionDOM=function(n){var t=$($format(appletInteraction._MarkupFormats.AppletSelectionItemElement,$format(appletInteraction._IdentifierFormats.AppletSelectionItemElement,n.AppletID),n.Title)).appendTo(app.appletSelectionList);t.click(function(){appletInteraction.activateApplet(n)})};appletInteraction._generateOptionsDOM=function(n){if(n.Options!==undefined&&n.Options.length>0){var t=$($format(appletInteraction._MarkupFormats.AppletOptionsElement,$format(appletInteraction._IdentifierFormats.AppletOptionsElement,n.AppletID),n.Title)).appendTo(app.optionsDialog.appletOptionsContent);t.find(appletInteraction._generateOptionsDOM.AppletOptionSectionHeaderSelector).click(app.toggleOptionSection);t=t.find(appletInteraction._generateOptionsDOM.AppletOptionSectionSelector);$.each(n.Options,function(i,r){var u=$($format(appletInteraction._MarkupFormats.AppletOptionsGroupElement,r.Label)).appendTo(t);$.each(r.Options,function(t,r){var e=$format(appletInteraction._IdentifierFormats.AppletOptionControl,n.AppletID,i,t),f;switch(r.Type){case appletMessaging.OptionInformation.Types.String:f=$($format(appletInteraction._MarkupFormats.AppletOptionStringControl,e,r.Label)).appendTo(u);f.find(appletInteraction._OptionControlType.Input).val(r.Value);break;case appletMessaging.OptionInformation.Types.Boolean:f=$($format(appletInteraction._MarkupFormats.AppletOptionCheckboxControl,e,r.Label)).appendTo(u);f.find(appletInteraction._OptionControlType.Input).prop(appletInteraction._ControlProperties.Checked,r.Value);break;case appletMessaging.OptionInformation.Types.Action:f=$($format(appletInteraction._MarkupFormats.AppletOptionButtonControl,e,r.Label)).appendTo(u);f.click(function(){appletInteraction.sendAppletActionRequest(n.AppletID,r.Value)})}})})}};appletInteraction.updateAllAppletOptionsDOMs=function(){$.each(appletInteraction.appletMap.getKeys(),function(n,t){var i=appletInteraction.appletMap.get(t);i!==undefined&&appletInteraction._updateOptionsDOM(i)})};appletInteraction._updateOptionsDOM=function(n){var t=util.findElementById($format(appletInteraction._IdentifierFormats.AppletOptionsElement,n.AppletID),app.optionsDialog.appletOptionsContent);util.doesElementExist(t)&&$.each(n.Options,function(i,r){$.each(r.Options,function(r,u){var e=$format(appletInteraction._IdentifierFormats.AppletOptionControl,n.AppletID,i,r),f=util.findElementById(e,t);switch(u.Type){case appletMessaging.OptionInformation.Types.String:f.val(u.Value);break;case appletMessaging.OptionInformation.Types.Boolean:f.prop(appletInteraction._ControlProperties.Checked,u.Value)}})})};appletInteraction._generateOptionsDOM.AppletOptionSectionSelector="> div";appletInteraction._generateOptionsDOM.AppletOptionSectionHeaderSelector="> h2";appletInteraction._completeAppletConfiguration=function(n){var t,i=!1;$.each(appletInteraction.appletMap.getKeys(),function(r,u){var f=appletInteraction.appletMap.get(u),e;f!==undefined&&f.Frame!==undefined&&(u===n?t=f:i||(e=f.Frame.attr(app.GeneralAttributes.isActive),i=e!==undefined&&e.toString().toLowerCase()==="true"))});t!==undefined&&(appletInteraction.appletStack.push(t),i?(app.State.AppletsReadyState=appletInteraction.getAppletsReadyState(),app.updateUIFromState()):appletInteraction.activateApplet(t));n in app.State.Settings.Applets||(app.State.Settings.Applets[n]={},app.saveSettings())};appletInteraction.activateApplet=function(n){var r="",u=appletInteraction.appletStack.length,t,i;n!==undefined&&(r=n.Title,t=appletInteraction.getActiveAppletInformation(),t!==n&&(i=appletInteraction.appletStack.indexOf(n),i===-1?u++:appletInteraction.appletStack.splice(i,1),appletInteraction.appletStack.splice(0,0,n),t!==undefined&&(t.Frame.attr(app.GeneralAttributes.isActive,!1),util.findElementById($format(appletInteraction._IdentifierFormats.AppletSelectionItemElement,t.AppletID)).attr(app.GeneralAttributes.isActive,!1))),n.Frame.attr(app.GeneralAttributes.isActive,!0),util.findElementById($format(appletInteraction._IdentifierFormats.AppletSelectionItemElement,n.AppletID)).attr(app.GeneralAttributes.isActive,!0));app.appletTitle.text(r);app.State.AppletsReadyState=appletInteraction.getAppletsReadyState();app.updateUIFromState();app.State.Settings.ActiveAppletId=n!==undefined?n.AppletID:undefined;app.saveSettings()};appletInteraction.getActiveAppletInformation=function(){return appletInteraction.appletStack.length>0?appletInteraction.appletStack[0]:undefined};appletInteraction.getAppletsReadyState=function(){var n;switch(appletInteraction.appletStack.length){case 0:n=app.AppletsReadyState.None;break;case 1:n=app.AppletsReadyState.Single;break;default:n=app.AppletsReadyState.Multiple}return n};appletInteraction.sendAppletOptionsChangedRequest=function(n,t){var r=!1,u=appletInteraction.appletMap.get(n),i;return u!==undefined&&(i=new appletMessaging.Requests.AppletOptionsChangedRequest(n,u.Options),appletInteraction.messageHandler.registerResponseCallback(i.MessageID,t),appletInteraction.sendMessageToApplet(n,i),r=!0),r};appletInteraction.handleSaveSettingsRequest=function(n){var t=n.data,i=t.Data.Settings;i===undefined&&(i={});app.State.Settings.Applets[t.AppletID]=i;app.saveSettings(function(n){var i=new appletMessaging.Responses.SaveSettingsResponse(t);i.Status=n.status===Office.AsyncResultStatus.Succeeded?appletMessaging.ResponseStatus.success:appletMessaging.ResponseStatus.failure;i.FailureMessage=n.error===undefined?undefined:n.error.message;appletInteraction.sendMessageToApplet(t.AppletID,i)})};appletInteraction.sendAppletActionRequest=function(n,t){var i=new appletMessaging.Requests.AppletActionRequest(n,t);appletInteraction.sendMessageToApplet(n,i)};appletInteraction.handleAddNotificationRequest=function(n){var t=n.data.Data.Notification,i;t.DisplayToUser&&t.LinkOptions!==undefined&&(i=t.LinkOptions.Action,t.LinkOptions.Action=function(){appletInteraction.sendAppletActionRequest(n.data.AppletID,i)});t.Type===appletMessaging.NotificationType.error?t.DisplayToUser?app.showError(t.Message,t):app.addErrorNotification(t.Message,t.Details,t.IncludeTimeStamp):t.DisplayToUser?app.showNotification(t.Message,t):app.addNotification(t.Message,t.IncludeTimeStamp)};appletInteraction.handlePromptUserRequest=function(n){var t=new appletInteraction.handlePromptUserRequest._CallbackHandler(n);app.showConfirmationDialog(n.data.Data.Message,t._sendPromptUserResponse,n.data.Data.Details)};appletInteraction.handlePromptUserRequest._CallbackHandler=function(n){this._sendPromptUserResponse=function(t){var i=new appletMessaging.Responses.PromptUserResponse(n.data,t);i.Status=appletMessaging.ResponseStatus.success;appletInteraction.sendMessageToApplet(n.data.AppletID,i)}};appletInteraction.handleLogEventRequest=function(n){app.logEvent(n.data.Data.Event,{SourceID:n.data.AppletID,MessageType:n.data.Data.MessageType,TelemetryType:n.data.Data.TelemetryType,TelemetryDetails:n.data.Data.TelemetryDetails})};appletInteraction.handleBeginOperationRequest=function(n){app.beginOperation(n.data.Data.OperationID,n.data.Data.Message,{SourceID:n.data.AppletID})};appletInteraction.handleUpdateOperationRequest=function(n){app.updateOperation(n.data.Data.OperationID,n.data.Data.Message,{SourceID:n.data.AppletID})};appletInteraction.handleEndOperationRequest=function(n){app.endOperation(n.data.Data.OperationID,n.data.Data.Message,{IncludeTimeStamp:n.data.Data.IncludeTimeStamp,SourceID:n.data.AppletID})};appletInteraction.sendAppResourceRequest=function(n,t,i){function u(){var r=appletMessaging.createUniqueMessageID(appletInteraction.sendAppResourceRequest.AppID,n);appletInteraction.enhanceResourceRequest(t,n,r,function(){appletInteraction.sendMessageToResource(n,t,!1);appletInteraction.messageHandler.registerResponseCallback(r,function(n){$.isFunction(i)&&i(!0,n)})})}var r=appletInteraction.resourceMap.get(n),f,e,o;r===undefined?(f=appletInteraction.registeredResources.get(n),f===undefined?(app.showError(resources.AppletInteraction.ResourceNotRegisteredErrorFormat(n)),i(!1)):appletInteraction.pendingResourceReadyCallbacks.containsKey(n)?appletInteraction.pendingResourceReadyCallbacks.get(n).push(function(n){n?u():i(!1)}):(e=$format(appletInteraction._IdentifierFormats.ResourceFrame,n),r=new appletInteraction.ResourceInformation(n),r.Frame=app.addNewFrame(app.resourceDiv,e,f),o=window.setTimeout(function(){appletInteraction.pendingResourceReadyCallbacks.containsKey(n)&&(appletInteraction.unloadResource(n),$.each(appletInteraction.pendingResourceReadyCallbacks.get(n),function(n,t){t(!1)}))},appletInteraction.handleResourceRequest._ResourceLoadTimeout),appletInteraction.pendingResourceReadyCallbacks.add(n,[function(t,f){t?(window.clearTimeout(o),r.Origin=f,appletInteraction.resourceMap.add(n,r),u()):i(!1)}]))):u()};appletInteraction.sendAppResourceRequest.AppID="DynamicsApp";appletInteraction.handleResourceRequest=function(n){function f(){if(i.Data.ResourceRequest===undefined){var r=new appletMessaging.Responses.ResourceResponse(i);r.Status=appletMessaging.ResponseStatus.success;appletInteraction.sendMessageToApplet(n.data.AppletID,r,!1)}else appletInteraction.enhanceResourceRequest(i.Data.ResourceRequest,t,o,function(){appletInteraction.sendMessageToResource(t,i.Data.ResourceRequest,!1);appletInteraction.messageHandler.registerResponseCallback(o,function(n){var t=new appletMessaging.Responses.ResourceResponse(i,{ResourceResponse:n});t.Status=appletMessaging.ResponseStatus.success;appletInteraction.sendMessageToApplet(i.AppletID,t,!1)})})}function s(){var n=new appletMessaging.Responses.ResourceResponse(i),r;n.Status=appletMessaging.ResponseStatus.failure;n.FailureMessage=resources.AppletInteraction.ResourceConfigurationTimedOutErrorFormat(t);r=messaging.RequestResponseMap[i.Data.ResourceRequest===undefined?"":i.Data.ResourceRequest.Type];r!==undefined&&(n.Data.ResourceResponse=new r,n.Data.ResourceResponse.Request=i.Data.ResourceRequest);appletInteraction.sendMessageToApplet(i.AppletID,n,!1)}var i=n.data,o=i.MessageID,t=i.Data.ResourceID,r=appletInteraction.resourceMap.get(t),e,u,h,c;r===undefined?(e=appletInteraction.registeredResources.get(t),e===undefined?(u=new appletMessaging.Responses.ResourceResponse(i),u.Status=appletMessaging.ResponseStatus.failure,u.FailureMessage=resources.AppletInteraction.ResourceNotRegisteredErrorFormat(t),appletInteraction.sendMessageToApplet(n.data.AppletID,u,!1)):appletInteraction.pendingResourceReadyCallbacks.containsKey(t)?appletInteraction.pendingResourceReadyCallbacks.add(t,function(n){n?f():s()}):(h=$format(appletInteraction._IdentifierFormats.ResourceFrame,t),r=new appletInteraction.ResourceInformation(t),r.Frame=app.addNewFrame(app.resourceDiv,h,e),c=window.setTimeout(function(){appletInteraction.pendingResourceReadyCallbacks.containsKey(t)&&(appletInteraction.unloadResource(t),$.each(appletInteraction.pendingResourceReadyCallbacks.get(t),function(n,t){t(!1)}))},appletInteraction.handleResourceRequest._ResourceLoadTimeout),appletInteraction.pendingResourceReadyCallbacks.add(t,[function(n,i){n?(window.clearTimeout(c),r.Origin=i,appletInteraction.resourceMap.add(t,r),f()):s()}]))):f()};appletInteraction.handleResourceRequest._ResourceLoadTimeout=3e4;appletInteraction._handleResourceReadyRequest=function(n){var t=n.data.ResourceID,i=appletInteraction.pendingResourceReadyCallbacks.get(t);i!==undefined&&(appletInteraction.pendingResourceReadyCallbacks.remove(t),$.each(i,function(t,i){i(!0,n.origin)}))};appletInteraction.enhanceResourceRequest=function(n,t,i,r){function u(){appletInteraction.enhanceResourceRequest._processingTokenAcquisition=!0;app.State.OAuthContext.acquireToken(app.State.ServerConfig.AuthResourceId,function(t,i){t||!i?app.showError(resources.AppletInteraction.AuthenticationError(),{Details:t}):n.Headers.Authorization="Bearer "+i;r();appletInteraction.enhanceResourceRequest._acquireTokenQueue.length>0?appletInteraction.enhanceResourceRequest._acquireTokenQueue.splice(0,1)[0]():appletInteraction.enhanceResourceRequest._processingTokenAcquisition=!1})}if(n.ResourceID=t,n.MessageID=i,t===appletMessaging.WellKnownResources.Data&&appletInteraction.enhanceResourceRequest._HeadersProperty in n){for(var f in app.State.ServerConfig.Headers)n.Headers[f]=app.State.ServerConfig.Headers[f].Value;n.Headers["ms-dyn-aid"]=app.State.ActivityID;n.Headers["ms-dyn-useragent"]="DynamicsOfficeApp/1";app.State.OAuthContext!==undefined?appletInteraction.enhanceResourceRequest._processingTokenAcquisition?appletInteraction.enhanceResourceRequest._acquireTokenQueue.push(u):u():r()}else r()};appletInteraction.enhanceResourceRequest._processingTokenAcquisition=!1;appletInteraction.enhanceResourceRequest._acquireTokenQueue=[];appletInteraction.enhanceResourceRequest._HeadersProperty="Headers";appletInteraction.sendMessageToApplet=function(n,t,i){var r=appletInteraction.appletMap.get(n);r!==undefined&&app.sendMessage(r.Frame,t,app.State.ValidOriginSet[r.Origin],i)};appletInteraction.sendMessageToResource=function(n,t,i){var r=appletInteraction.resourceMap.get(n),u;r!==undefined&&(u=app.State.ValidOriginSet===undefined?"*":app.State.ValidOriginSet[r.Origin],app.sendMessage(r.Frame,t,u,i))};appletInteraction.appletConfiguration={ClassNames:{DependentApplets:"dependentApplets",AppletCheckbox:"appletCheckbox"},Attributes:{AppletID:"data-applet-id",Title:"title"},Properties:{Checked:"checked"},Markup:{Checkbox:"<div {4}='{0}' class='{2}'><input type='checkbox' /><span>{1}<\/span><div class='{3}'><\/div><\/div>"}};appletInteraction.appletConfiguration.Selectors={DependentApplets:$format(".{0}",appletInteraction.appletConfiguration.ClassNames.DependentApplets),ImmediateDepenentApplets:$format("> .{0}",appletInteraction.appletConfiguration.ClassNames.DependentApplets),AppletCheckbox:$format(".{0}",appletInteraction.appletConfiguration.ClassNames.AppletCheckbox),AppletCheckboxTitle:"> span",ImmediateCheckboxChildren:"> input[type='checkbox']",AllCheckboxChildren:"input[type='checkbox']"};appletInteraction.appletConfiguration.generateAppletConfigurationDOM=function(n){function u(){r--;r===0&&n()}var i=[],t=new util.Map,r;$.each(appletInteraction.registeredApplets,function(n,r){var u={ID:r.AppletID,NameLabelID:r.Name,DescriptionLabelID:r.Description,AppletRegistration:r};r.DependentOn!==undefined&&r.DependentOn!==""?u.DependentOnID=r.DependentOn:i.push(u);t.add(u.ID,u)});$.each(t.getKeys(),function(n,i){var u=t.get(i),r;u.DependentOnID!==undefined&&(r=t.get(u.DependentOnID),r!==undefined&&(r.Dependents===undefined&&(r.Dependents=[]),r.Dependents.push(u)))});r=i.length;$.each(i,function(n,t){appletInteraction.appletConfiguration.generateAppletConfigurationItemDOM(t,app.appletConfigurationDialog.configDialogContainer.configContent,u)})};appletInteraction.appletConfiguration.generateAppletConfigurationItemDOM=function(n,t,i){function u(){function o(){u--;u===0&&i()}var f=$($format(appletInteraction.appletConfiguration.Markup.Checkbox,n.ID,n.Name,appletInteraction.appletConfiguration.ClassNames.AppletCheckbox,appletInteraction.appletConfiguration.ClassNames.DependentApplets,appletInteraction.appletConfiguration.Attributes.AppletID)).appendTo(t),r,u,e;n.Description!==undefined&&n.Description!==""&&f.attr(appletInteraction.appletConfiguration.Attributes.Title,n.Description);r=f.find(appletInteraction.appletConfiguration.Selectors.ImmediateCheckboxChildren);r.click(function(){r.prop(appletInteraction.appletConfiguration.Properties.Checked)?appletInteraction.appletConfiguration.checkParents(r):appletInteraction.appletConfiguration.uncheckChildren(r)});u=0;n.Dependents!==undefined?(u=n.Dependents.length,e=f.find(appletInteraction.appletConfiguration.Selectors.ImmediateDepenentApplets),$.each(n.Dependents,function(n,t){appletInteraction.appletConfiguration.generateAppletConfigurationItemDOM(t,e,o)})):i()}var f=appletInteraction.LabelIdValidationRegex.test(n.NameLabelID),e=appletInteraction.LabelIdValidationRegex.test(n.DescriptionLabelID),r=new messaging.Requests.GetLabelsRequest;r.Language=app.State.Language;r.LabelIDs=[];f?r.LabelIDs.push(n.NameLabelID):n.Name=n.NameLabelID;e?r.LabelIDs.push(n.DescriptionLabelID):n.Description=n.DescriptionLabelID;r.LabelIDs.length>0?appletInteraction.sendAppResourceRequest(appletMessaging.WellKnownResources.Data,r,function(t,i){t?(f&&(n.Name=i.LabelResults[0].Value,n.AppletRegistration.LocalizedName=n.Name),e&&(n.Description=i.LabelResults[i.LabelResults.length-1].Value)):(app.addErrorNotification(resources.AppletInteraction.AppletLocalizationErrorFormat(n.ID)),n.Name=n.NameLabelID);u()}):u()};appletInteraction.appletConfiguration.applyAppletConfiguration=function(){var t=[],i=[],f=app.appletConfigurationDialog.configDialogContainer.configContent.find(appletInteraction.appletConfiguration.Selectors.AppletCheckbox),r,u,n;$.each(f,function(n,r){var u=$(r),e=u.find(appletInteraction.appletConfiguration.Selectors.ImmediateCheckboxChildren),o=u.find(appletInteraction.appletConfiguration.Selectors.AppletCheckboxTitle);if(util.doesElementExist(e)&&util.doesElementExist(o)){var f=u.attr(appletInteraction.appletConfiguration.Attributes.AppletID),s=o.text(),h=appletInteraction.appletMap.containsKey(f),c=e.prop(appletInteraction.appletConfiguration.Properties.Checked);c&&!h?t.push({ID:f,Title:s}):!c&&h&&i.push({ID:f,Title:s})}});r=t.length>0;u=i.length>0;r||u?(n=resources.AppletInteraction.UserConfirmAppletsLoadedChangesMessage(),u&&(n=resources.AppletInteraction.AppletsToBeUnloadedMessageFormat(i.map(appletInteraction.appletConfiguration.applyAppletConfiguration._getAppletTitle).join(resources.AppletInteraction.AppletListSeparator()),n)),r&&(n=resources.AppletInteraction.AppletsToBeLoadedMessageFormat(t.map(appletInteraction.appletConfiguration.applyAppletConfiguration._getAppletTitle).join(resources.AppletInteraction.AppletListSeparator()),n)),app.showConfirmationDialog(n,function(n){if(n){var r=new util.Map;$.each(appletInteraction.registeredApplets,function(n,t){r.add(t.AppletID,t)});$.each(i,function(n,t){appletInteraction.unloadApplet(t.ID)});$.each(t,function(n,t){var i=r.get(t.ID);i!==undefined&&appletInteraction.loadApplet(i.AppletID,i.RelativeUrl,app.State.Settings.Applets[i.AppletID])});app.closeActiveDialog(app.appletConfigurationDialog.dialogID)}})):app.closeActiveDialog(app.appletConfigurationDialog.dialogID)};appletInteraction.appletConfiguration.applyAppletConfiguration._getAppletTitle=function(n){return n.Title};appletInteraction.appletConfiguration.resetConfigurationDialogValues=function(){var n=app.appletConfigurationDialog.configDialogContainer.configContent.find(appletInteraction.appletConfiguration.Selectors.AppletCheckbox);$.each(n,function(n,t){var i=$(t),r=i.find(appletInteraction.appletConfiguration.Selectors.ImmediateCheckboxChildren),u;util.doesElementExist(r)&&(u=i.attr(appletInteraction.appletConfiguration.Attributes.AppletID),r.prop(appletInteraction.appletConfiguration.Properties.Checked,appletInteraction.appletMap.containsKey(u)))})};appletInteraction.appletConfiguration.checkParents=function(n){var r=n.parent().parent(appletInteraction.appletConfiguration.Selectors.DependentApplets),i,t;util.doesElementExist(r)&&(i=r.parent(appletInteraction.appletConfiguration.Selectors.AppletCheckbox),util.doesElementExist(i)&&(t=i.find(appletInteraction.appletConfiguration.Selectors.ImmediateCheckboxChildren),util.doesElementExist(t)&&(t.prop(appletInteraction.appletConfiguration.Properties.Checked,!0),appletInteraction.appletConfiguration.checkParents(t))))};appletInteraction.appletConfiguration.uncheckChildren=function(n){var i=n.parent(),t;util.doesElementExist(i)&&(t=i.find(appletInteraction.appletConfiguration.Selectors.AllCheckboxChildren),util.doesElementExist(t)&&t.prop(appletInteraction.appletConfiguration.Properties.Checked,!1))};
/*!
// <copyright file="OfficeInteraction.js" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
*/
officeInteraction={documentEventSubscriptionMap:undefined,bindingEventSubscriptionMap:undefined};officeInteraction.initialize=function(){officeInteraction.documentEventSubscriptionMap=new util.Map;officeInteraction.bindingEventSubscriptionMap=new util.Map;appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.DocumentEventSubscription,officeInteraction.handleDocumentEventSubscriptionRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.BindingEventSubscription,officeInteraction.handleBindingEventSubscriptionRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.OfficeAction,officeInteraction.handleOfficeActionRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.DocumentMethod,officeInteraction.handleDocumentMethodRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.BindingsMethod,officeInteraction.handleBindingsMethodRequest);appletInteraction.messageHandler.registerMessageHandler(appletMessaging.MessageTypes.BindingMethod,officeInteraction.handleBindingMethodRequest)};officeInteraction.handleDocumentEvent=function(n){var t=officeInteraction.documentEventSubscriptionMap.get(n.type);t!==undefined&&$.each(t,function(t,i){var r=new appletMessaging.Requests.OfficeEventRequest(i,appletMessaging.Requests.OfficeEventRequest.EventSource.Document,n);appletInteraction.sendMessageToApplet(i,r)});app.logEvent($format(officeInteraction.handleDocumentEvent._DocumentEventFormat,n.type))};officeInteraction.handleDocumentEvent._DocumentEventFormat="document-{0}-event";officeInteraction.handleBindingEvent=function(n){var i=officeInteraction.bindingEventSubscriptionMap.get(n.binding.id),t;i!==undefined&&(t=i.get(n.type),t!==undefined&&$.each(t,function(t,i){var r=new appletMessaging.Requests.OfficeEventRequest(i,appletMessaging.Requests.OfficeEventRequest.EventSource.Binding,n);appletInteraction.sendMessageToApplet(i,r)}));app.logEvent($format(officeInteraction.handleBindingEvent._BindingEventFormat,n.type))};officeInteraction.handleBindingEvent._BindingEventFormat="binding-{0}-event";officeInteraction.unsubscribeAllDocumentEvents=function(n){$.each(officeInteraction.documentEventSubscriptionMap.getKeys(),function(t,i){officeInteraction.unsubscribeDocumentEvent(n,i)})};officeInteraction.unsubscribeDocumentEvent=function(n,t){var i=officeInteraction.documentEventSubscriptionMap.get(t),r;i!==undefined&&(r=i.indexOf(n),r!==-1&&i.splice(r,1))};officeInteraction.unsubscribeAllBindingEvents=function(n){$.each(officeInteraction.bindingEventSubscriptionMap.getKeys(),function(t,i){var r=officeInteraction.bindingEventSubscriptionMap.get(i);r!==undefined&&$.each(r.getKeys(),function(t,r){officeInteraction.unsubscribeBindingEvent(n,i,r)})})};officeInteraction.unsubscribeBindingEvent=function(n,t,i){var f=officeInteraction.bindingEventSubscriptionMap.get(t),r,u;f!==undefined&&(r=f.get(i),r!==undefined&&(u=r.indexOf(n),u!==-1&&r.splice(u,1)))};officeInteraction.handleDocumentEventSubscriptionRequest=function(n){var t=new officeInteraction.handleDocumentEventSubscriptionRequest._CallbackHandler(n);$.each(n.data.Data.DocumentEventSubscriptions,function(n,i){var r=officeInteraction.documentEventSubscriptionMap.get(i);r!==undefined?t._addHandlerCallback({status:Office.AsyncResultStatus.Succeeded,asyncContext:{Index:n,EventType:i}}):Office.context.document.addHandlerAsync(i,officeInteraction.handleDocumentEvent,{asyncContext:{Index:n,EventType:i}},t._addHandlerCallback)})};officeInteraction.handleDocumentEventSubscriptionRequest._CallbackHandler=function(n){var t=this;for(this.results=[],this.expectedResultCount=n.data.Data.DocumentEventSubscriptions.length,this.receivedResultCount=0,this.failedResponseReceived=!1;t.results.length!==t.expectedResultCount;)t.results.push(undefined);this._addHandlerCallback=function(i){var f=i.asyncContext.Index,u,e,r;t.results[f]=i;t.receivedResultCount++;i.status===Office.AsyncResultStatus.Failed?t.failedResponseReceived=!0:(u=officeInteraction.documentEventSubscriptionMap.get(i.asyncContext.EventType),u===undefined&&(u=[],officeInteraction.documentEventSubscriptionMap.add(i.asyncContext.EventType,u)),u.push(n.data.AppletID));t.receivedResultCount===t.expectedResultCount&&(e=n.data.Data,r=new appletMessaging.Responses.DocumentEventSubscriptionResponse(n.data),r.Data.Results=t.results,t.failedResponseReceived?(r.Status=appletMessaging.ResponseStatus.failure,r.FailureMessage=resources.OfficeInteraction.AppletDocumentSubscriptionErrorFormat(e.DocumentEventSubscriptions[f])):r.Status=appletMessaging.ResponseStatus.success,appletInteraction.sendMessageToApplet(n.data.AppletID,r))}};officeInteraction.handleBindingEventSubscriptionRequest=function(n){var t=new officeInteraction.handleBindingEventSubscriptionRequest._CallbackHandler(n);Office.context.document.bindings.getByIdAsync(n.data.Data.BindingID,t._getByIdCallback)};officeInteraction.handleBindingEventSubscriptionRequest._CallbackHandler=function(n){var t=this;this.eventTypes=n.data.Data.BindingEventSubscriptions;this.results=[];this.receivedResultCount=0;this.failedResponseReceived=!1;this._getByIdCallback=function(i){var r,f,u;if(i.status===Office.AsyncResultStatus.Failed)r=new appletMessaging.Responses.BindingEventSubscriptionResponse(n.data),r.Status=appletMessaging.ResponseStatus.failure,r.FailureReason=resources.OfficeInteraction.AppletTableBindingRetrievalError(),r.Data.Results=t.results,appletInteraction.sendMessageToApplet(n.data.AppletID,r);else{for(f=i.value;t.results.length!==t.eventTypes.length;)t.results.push(undefined);u=officeInteraction.bindingEventSubscriptionMap.get(f.id);u===undefined&&(u=new util.Map,officeInteraction.bindingEventSubscriptionMap.add(f.id,u));$.each(t.eventTypes,function(n,i){u.get(i)!==undefined?t._addHandlerCallback({status:Office.AsyncResultStatus.Succeeded,asyncContext:{Index:n,EventType:i}}):f.addHandlerAsync(i,officeInteraction.handleBindingEvent,{asyncContext:{Index:n,EventType:i}},t._addHandlerCallback)})}};this._addHandlerCallback=function(i){var e=i.asyncContext.Index,r,f,o,u;t.results[e]=i;t.receivedResultCount++;i.status===Office.AsyncResultStatus.Failed?t.failedResponseReceived=!0:(r=officeInteraction.bindingEventSubscriptionMap.get(n.data.Data.BindingID),r===undefined&&(r=new util.Map,officeInteraction.bindingEventSubscriptionMap.add(n.data.Data.BindingID,r)),f=r.get(i.asyncContext.EventType),f===undefined&&(f=[],r.add(i.asyncContext.EventType,f)),f.push(n.data.AppletID));t.receivedResultCount===t.eventTypes.length&&(o=n.data.Data,u=new appletMessaging.Responses.BindingEventSubscriptionResponse(n.data),u.Data.Results=t.results,t.failedResponseReceived?(u.Status=appletMessaging.ResponseStatus.failure,u.FailureMessage=resources.OfficeInteraction.AppletTableBindingSubscriptionErrorFormat(o.BindingEventSubscriptions[e])):u.Status=appletMessaging.ResponseStatus.success,appletInteraction.sendMessageToApplet(n.data.AppletID,u))}};officeInteraction.handleOfficeActionRequest=function(n){if(app.State.OfficeVersion<util.OfficeVersion.Release){app.showError(resources.OfficeInteraction.Office2016RequiredError());appletInteraction.unloadApplet(n.data.AppletID);return}var t=new officeInteraction.handleOfficeActionRequest._OfficeActionExecutor(n.data);t.continueOfficeActionExecution()};officeInteraction.handleOfficeActionRequest._OfficeActionExecutor=function(n){var t=this;this.actionIndex=0;this.context=undefined;this.contextPromise=undefined;this.currentAsyncResult=undefined;this.localScope={};this.returnValues={};this.asyncResults=[];this.errorMessage=undefined;this.continueOfficeActionExecution=function(i){if(i){if(i.status===Office.AsyncResultStatus.Failed){t.errorMessage=i.error.message;t._sendResponse();return}t.currentAsyncResult=i;t.asyncResults.push(i)}if(t.actionIndex===n.Data.Actions.length){t.contextPromise?(t.contextPromise=t.contextPromise.then(t._sendResponse),t._addCatchToCurrentPromise()):t._sendResponse();return}var r=n.Data.Actions[t.actionIndex],u=t._isLegacy(r);if(t._verifyContext(r),t.contextPromise)t.contextPromise=t.contextPromise.then(function(){t._executeOfficeAction(r)}),u&&(t._addCatchToCurrentPromise(),t.contextPromise=undefined);else try{t._executeOfficeAction(r)}catch(f){t.errorMessage=f.message;t._sendResponse();return}r.Sync&&!u&&(t.contextPromise=t.contextPromise?t.contextPromise.then(t.context.sync):t.context.sync());t.actionIndex++;u||t.continueOfficeActionExecution()};this._isLegacy=function(n){return n.Scope===appletMessaging.OfficeActionScope.Office||n.Scope===appletMessaging.OfficeActionScope.AsyncResult};this._verifyContext=function(n){var i=n.Scope===appletMessaging.OfficeActionScope.Context||n.Sync;if(t.context===undefined&&i&&!t._isLegacy(n))switch(app.State.CurrentApplication){case util.ApplicationType.Excel:t.context=new Excel.RequestContext;break;case util.ApplicationType.Word:t.context=new Word.RequestContext;break;default:throw new Error(resources.DynamicsApp.UnrecognizedApplicationError());}};this._addCatchToCurrentPromise=function(){t.contextPromise.catch(function(n){t.errorMessage=n.message;t._sendResponse()})};this._sendResponse=function(){var i=new appletMessaging.Responses.OfficeActionResponse(n);t.errorMessage===undefined?(i.Status=appletMessaging.ResponseStatus.success,i.Data.Values=t.returnValues,i.Data.Results=t.asyncResults):(i.Status=appletMessaging.ResponseStatus.failure,i.FailureReason=t.errorMessage);appletInteraction.sendMessageToApplet(n.AppletID,i)};this._resolveOfficeActionPath=function(n,i){var r,u,f,e,o;switch(n.Scope){case appletMessaging.OfficeActionScope.Context:r=t.context;break;case appletMessaging.OfficeActionScope.Local:r=t.localScope;break;case appletMessaging.OfficeActionScope.Office:r=Office;break;case appletMessaging.OfficeActionScope.AsyncResult:r=t.currentAsyncResult}for(u=0;u<n.Path.length;u++)f=n.Path[u],u===n.Path.length-1&&"AssignmentValue"in i?(r[f.Name]=i.AssignmentValue,r=undefined):(e=r[f.Name],f.Type===appletMessaging.OfficeReferenceType.Function&&(o=f.Arguments,u===n.Path.length-1&&t._isLegacy(n)&&o.push(t.continueOfficeActionExecution),e=e.apply(r,o)),r=e);return r};this._executeOfficeAction=function(n){var r={},i;!t._isLegacy(n)&&"AssignmentValue"in n&&n.VariableName===undefined&&(r.AssignmentValue=n.AssignmentValue);i=t._resolveOfficeActionPath(n,r);n.VariableName!==undefined&&(t.localScope[n.VariableName]=i,n.ReturnResult&&(t.returnValues[n.VariableName]=i))}};officeInteraction.handleDocumentMethodRequest=function(n){function r(i){var r=new appletMessaging.Responses.DocumentMethodResponse(n.data);i.status===Office.AsyncResultStatus.Failed?(r.Status=appletMessaging.ResponseStatus.failure,r.FailureMessage=resources.OfficeInteraction.ExecutingDocumentMethodErrorFormat(t.MethodName)):r.Status=appletMessaging.ResponseStatus.success;r.Data.Result=i;appletInteraction.sendMessageToApplet(n.data.AppletID,r)}var t=n.data.Data.Method,u=Office.context.document[t.MethodName],i;u!==undefined?(i=[],t.Arguments!==undefined&&$.each(t.Arguments,function(n,t){if(t instanceof appletMessaging.OfficeTableData||t.rows!==undefined||t.headers!==undefined){var r=new Office.TableData;r.rows=t.rows;r.headers=t.headers;i.push(r)}else i.push(t)}),t.Options!==undefined&&i.push(t.Options),i.push(r),u.apply(Office.context.document,i)):r({status:Office.AsyncResultStatus.Failed,error:{message:resources.OfficeInteraction.OfficeMethodNotFoundErrorFormat(t.MethodName)}})};officeInteraction.handleBindingsMethodRequest=function(n){function r(i){var r=new appletMessaging.Responses.DocumentMethodResponse(n.data);i.status===Office.AsyncResultStatus.Failed?(r.Status=appletMessaging.ResponseStatus.failure,r.FailureMessage=resources.OfficeInteraction.ExecutingBindingsMethodErrorFormat(t.MethodName)):r.Status=appletMessaging.ResponseStatus.success;r.Data.Result=i;appletInteraction.sendMessageToApplet(n.data.AppletID,r)}var t=n.data.Data.Method,u=Office.context.document.bindings[t.MethodName],i;u!==undefined?(i=t.Arguments===undefined?[]:t.Arguments,t.Options!==undefined&&i.push(t.Options),i.push(r),u.apply(Office.context.document.bindings,i)):r({status:Office.AsyncResultStatus.Failed,error:{message:resources.OfficeInteraction.OfficeMethodNotFoundErrorFormat(t.MethodName)}})};officeInteraction.handleBindingMethodRequest=function(n){var t=new officeInteraction.handleBindingMethodRequest._CallbackHandler(n);Office.context.document.bindings.getByIdAsync(n.data.Data.BindingID,t._getByIdCallback)};officeInteraction.handleBindingMethodRequest._CallbackHandler=function(n){var t=this;this.results=[];this.currentMethodIndex=0;this.binding=undefined;this._getByIdCallback=function(i){var r,u;t.results.push(i);i.status===Office.AsyncResultStatus.Failed?(r=new appletMessaging.Responses.BindingMethodResponse(n.data),r.Status=appletMessaging.ResponseStatus.failure,r.FailureReason=resources.OfficeInteraction.AppletTableBindingRetrievalError(),r.Data.Results=t.results,appletInteraction.sendMessageToApplet(n.data.AppletID,r)):n.data.Data.Methods.length===0?(u=new appletMessaging.Responses.BindingMethodResponse(n.data),u.Status=appletMessaging.ResponseStatus.success,u.Data.Results=t.results,appletInteraction.sendMessageToApplet(n.data.AppletID,u)):(t.binding=i.value,t._executeNextTableBindingMethod())};this._executeNextTableBindingMethod=function(){var i=n.data.Data.Methods[t.currentMethodIndex],u=t.binding[i.MethodName],r;t.currentMethodIndex++;u!==undefined?(r=[],i.Arguments!==undefined&&$.each(i.Arguments,function(n,t){if(t instanceof appletMessaging.OfficeTableData||t.rows!==undefined||t.headers!==undefined){var i=new Office.TableData;i.rows=t.rows;i.headers=t.headers;r.push(i)}else r.push(t)}),i.Options!==undefined&&r.push(i.Options),r.push(t._bindingMethodCallback),u.apply(t.binding,r)):t._bindingMethodCallback({status:i.IsRequired?Office.AsyncResultStatus.Failed:Office.AsyncResultStatus.Succeeded,error:i.IsRequired?{message:resources.AppletInteraction.OfficeMethodNotFoundErrorFormat(i.MethodName)}:undefined})};this._bindingMethodCallback=function(i){if(t.results.push(i),i.status===Office.AsyncResultStatus.Failed||t.currentMethodIndex>=n.data.Data.Methods.length){var u=n.data.Data,r=new appletMessaging.Responses.BindingMethodResponse(n.data);r.Data.Results=t.results;i.status===Office.AsyncResultStatus.Failed?(r.Status=appletMessaging.ResponseStatus.failure,r.FailureMessage=resources.OfficeInteraction.AppletTableBindingMethodErrorFormat(u.Methods[t.currentMethodIndex-1])):r.Status=appletMessaging.ResponseStatus.success;appletInteraction.sendMessageToApplet(n.data.AppletID,r)}else t._executeNextTableBindingMethod()}}
//# sourceMappingURL=DynamicsApp.min.js.map
